unit Main;

{$MODE Delphi}

interface

uses LCLIntf, LCLType, LMessages, windows, SysUtils, Classes, Graphics, Forms,
  Controls, Menus, StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls,
  StdActns, ActnList, ToolWin, ImgList, MRUList, PrintersDlgs, ugrafdefs,
  unitdefin, fpsallformats, fpspreadsheetgrid, fpspreadsheetctrls, fpstypes,
  UFormGraf, unitinterf, AbDfBase, AbDfDec, AbDfEnc, CSaveComps{, Actions};

type

  { TMainForm }

  TMainForm = class(TForm)
    Abrir1: TMenuItem;
    Abrirtodaslasplanillas1: TMenuItem;
    Acercade1: TMenuItem;
    ActionList1: TActionList;
    Agregardatos1: TMenuItem;
    Archivo1: TMenuItem;
    Ayuda1: TMenuItem;
    BorrarArchivostemporarios1: TMenuItem;
    Cerrar1: TMenuItem;
    Configurarimpresora1: TMenuItem;
    Ejecutable1: TMenuItem;
    FileNew3: TMenuItem;
    Fin1: TMenuItem;
    Grabardatos1: TMenuItem;
    Grabarresultados1: TMenuItem;
    Guardar1: TMenuItem;
    Guardartodaslasplanillas1: TMenuItem;
    Importardatos1: TMenuItem;
    Importardistribucin1: TMenuItem;
    Imprimir1: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    BotSalvarResultados: TToolButton;
    BotCortar: TToolButton;
    BotCopiar: TToolButton;
    BotPegar: TToolButton;
    BotGen: TToolButton;
    Guardar0: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MRUList: TMRUManager;
    N3: TMenuItem;
    N32bitsgenrico1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N64bits1: TMenuItem;
    Nuevo1: TMenuItem;
    NuevoFIT1: TMenuItem;
    Opendefinition1: TMenuItem;
    OpenDialogOutFile: TOpenDialog;
    OpenDlg: TOpenDialog;
    Parmetrosdeimpresin1: TMenuItem;
    PrinterSetup: TPrinterSetupDialog;
    Recent1: TMenuItem;
    Salvardistribucin1: TMenuItem;
    Savedefinition1: TMenuItem;
    SaveDialog: TSaveDialog;
    SaveOutMemoDlg: TSaveDialog;
    SaveDlgProj: TSaveDialog;
    sWorkbookSource1: TsWorkbookSource;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    BotGrafDatos: TToolButton;
    BotCorrer: TToolButton;
    ToolButton5: TToolButton;
    BotParar: TToolButton;
    BotGrafResult: TToolButton;
    Vistapreliminar1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialogProj: TOpenDialog;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    WindowTileItem2: TMenuItem;
    ToolBar: TToolBar;
    BotNewFit: TToolButton;
    BotNewOx: TToolButton;
    ToolButton3: TToolButton;
    BotOpen: TToolButton;
    BotSave: TToolButton;
    BotPrint: TToolButton;
    BotNewContin: TToolButton;
    ToolButton7: TToolButton;
    BotImportDat: TToolButton;
    BotImportDistr: TToolButton;
    BotSalvDat: TToolButton;
    ImageList1: TImageList;
    procedure Abrir1Click(Sender: TObject);
    procedure Abrirtodaslasplanillas1Click(Sender: TObject);
    procedure Archivo1Click(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure Borrararchivostemporarios1Click(Sender: TObject);
    procedure BotCopiarClick(Sender: TObject);
    procedure BotCorrerClick(Sender: TObject);
    procedure BotCortarClick(Sender: TObject);
    procedure BotGenClick(Sender: TObject);
    procedure BotGrafDatosClick(Sender: TObject);
    procedure BotGuardarClick(Sender: TObject);
    procedure BotImportDistrClick(Sender: TObject);
    procedure BotPararClick(Sender: TObject);
    procedure BotPegarClick(Sender: TObject);
    procedure BotPrintClick(Sender: TObject);
    procedure BotSalvarResultadosClick(Sender: TObject);
    procedure BotSalvDatClick(Sender: TObject);
    procedure Cerrar1Click(Sender: TObject);
    procedure Configurarimpresora1Click(Sender: TObject);
    procedure Cut(Sender: TObject);
    procedure FileNewContin(Sender: TObject);
    procedure FileNewHumic(Sender: TObject);
    procedure FileNewOxide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Guardar0Click(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure Fin1Click(Sender: TObject);
    procedure Guardartodaslasplanillas1Click(Sender: TObject);
    procedure GrafResultClick(Sender: TObject);
    procedure ImportarDatosClick(Sender: TObject);
    procedure MRUListClick(Sender: TObject; const RecentName, ACaption: string;
      UserData: PtrInt);
    procedure N32bitsgenrico1Click(Sender: TObject);
    procedure N64bits1Click(Sender: TObject);
    procedure Opendefinition1Click(Sender: TObject);
    procedure Parmetrosdeimpresin1Click(Sender: TObject);
    procedure Previa1Click(Sender: TObject);
    procedure Salvardistribucin1Click(Sender: TObject);
    procedure Savedefinition1Click(Sender: TObject);
    procedure Siguiente1Click(Sender: TObject);
    procedure Vistapreliminar1Click(Sender: TObject);
    procedure SaveCompsLoadComponentEvent(Sender: TObject;
                  ComponentName: string; Count, Index: Integer; var Continue: Boolean);
    procedure SaveCompsStoreComponentEvent(Sender: TObject;
                  ComponentName: string; Count, Index: Integer; var Continue: Boolean);
  private
    { Private declarations }
    procedure AbrirProyecto(fn: string);
    procedure CreateMDIChild(const Name: string; childmode: Tpmode);
//    procedure RecuperarEstado(f: TFileStream; Child: TFormInterf);
//    procedure RecuperarEstado3(f: TFileStream);
//    procedure RecuperarEstado4(f: TFileStream; index: integer; filename: string);
    procedure SalvaProyecto(FileName: string);
  public
    { Public declarations }
    comline: Array[1..1024] of Char;

    procedure BotDisabled;
    procedure BotEnabled;
    procedure Exportar(Plan: TsWorkSheetGrid; ptit: string);
    procedure Importar(Plan: TsWorkSheetGrid; ptit: string);
    function Traercuenta: string;
    procedure SaveOutMemo;
  end;

type
  Trecbind = (recend, recform1, recform2, recform3, recform4, recpland, recplanc,
              recplanr, recgrafa, recgrafr, recgrafd, recgraff, rgrafa,
              rgrafr, rgrafd, rgraff, routmemo, recgrafv, recplanv, rgrafv, recplanx);

const
  nummarcas = 10;

type
   buf8 = Array[1..8] of Byte;
   bufs = Array[1..nummarcas] of buf8;

const            // recognized file formats
    marca: buf8 = (Ord('C'), Ord('O'), Ord('N'), Ord('T'),
                   Ord('I'), Ord('N'), Ord('D'), Ord('T'));
    marki: buf8 = (Ord('C'), Ord('O'), Ord('N'), Ord('T'),
                   Ord('I'), Ord('N'), Ord('D'), Ord('2'));
    mark3: buf8 = (Ord('C'), Ord('O'), Ord('N'), Ord('T'),
                   Ord('I'), Ord('N'), Ord('D'), Ord('3'));
    marbc: buf8 = (Ord('B'), Ord('I'), Ord('N'), Ord('D'),
                   Ord('C'), Ord('O'), Ord('D'), Ord('T'));
    marbf: buf8 = (Ord('B'), Ord('I'), Ord('N'), Ord('D'),
                   Ord('F'), Ord('I'), Ord('D'), Ord('T'));
    marf2: buf8 = (Ord('B'), Ord('I'), Ord('N'), Ord('D'),
                   Ord('F'), Ord('I'), Ord('D'), Ord('2'));
    marf3: buf8 = (Ord('B'), Ord('I'), Ord('N'), Ord('D'),
                   Ord('F'), Ord('I'), Ord('D'), Ord('3'));
    mbdco: buf8 = (Ord('B'), Ord('I'), Ord('N'), Ord('G'),     //NEW CONTIN
                   Ord('C'), Ord('O'), Ord('N'), Ord('T'));
    mbdfh: buf8 = (Ord('B'), Ord('I'), Ord('N'), Ord('G'),     //NEW FIT HUMIC
                   Ord('F'), Ord('I'), Ord('T'), Ord('H'));
    mbdfo: buf8 = (Ord('B'), Ord('I'), Ord('N'), Ord('G'),     //NEW FIT OXIDE
                   Ord('F'), Ord('I'), Ord('T'), Ord('O'));



    tagcontin = 'intcontin';
    tagfit = 'intfit';

    archin0 = 'continin';
    archin1 = 'fitin';
    archout0 = 'continout';
    archsal0 = 'continsal';
    archsal1 = 'fitsal';
    exec32 = 'contin32.exe';
    exec64 = 'contin64.exe';
    fexec32 = 'LMFit32.exe';
//    fexecC2D = 'LMFitC2D.exe';
    fexec64 = 'LMFit64.exe';

var
  MainForm: TMainForm;
  fitexec: string = fexec32;
  continexec: string = exec32;
  dirprogr, dirtemp, archin, archout, archsal: string;
  procid: cardinal;
  startingprog: Boolean;
  floading: boolean = False;
  marcas: bufs;

implementation

{$R *.frm}

uses about, uformprog, TaGraph, fpscsv;

const
  maxplan = 50;

var
  runcount: integer = 0;
  plansnames: Array[1..maxplan] of string;
  plansindex: Array[1..maxplan] of integer;
  plancount, pindex: integer;
  filecount: integer = 0;

procedure TMainForm.CreateMDIChild(const Name: string; childmode: Tpmode);
var
  Child: TFormInterf;
begin
  { create a new MDI child window }
  Child := TFormInterf.Create(Application);
  Child.Caption := Name;
  Child.childmode := childmode;
  Child.myfilename:= '';
  Child.Init;
  Child.Show;
end;

procedure TMainForm.Abrir1Click(Sender: TObject);
var
  fn: string;
begin
  if OpenDialogProj.Execute then begin
    fn := OpenDialogProj.FileName;
    AbrirProyecto(fn);
  end;
end;

procedure TMainForm.AbrirProyecto(fn: string);
var
  f: TFileStream;
  b: buf8;
  Child: TFormInterf;
  l: int64;
  mode: Tpmode;
  i, j, k, c, c1, n, ncu, col1, col2, colt, colh, ni, nc, kk: integer;
  nr: Trecbind;
  fnp, fnt: string;
  buf: TStringList;
  mi, mc: TMemoryStream;
  st: string;
  ah: TAbDeflateHelper;
  decsep: char;
  Savecomps: TSaveComps;

  function compar(m, a: buf8): boolean;
  var i: integer;
  begin
    Result := True;
    for i:= 1 to 8 do Result := Result and (a[i] = m[i]);
  end;

  procedure recupgrec(var r: TRecGrafNEW);
  var
    c1: integer;
  begin
    try
      mi.CopyFrom(f, l);
      mi.Position := 0;
      c1 := Inflate(mi, mc, ah);
      if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
      mc.Position := 0;
      if mc.Size = SizeOf(TRecgrafNEW) then
         mc.ReadBuffer(r, SizeOf(TRecgrafNEW));
    except
        on e: Exception do MessageDlg('Graf data recovery failed! '+e.Message, mtError, [mbOK], 0);
    end;
    mi.Clear;
    mc.Clear;
  end;


  procedure recupplanx (ind: integer);
  var
    p: TsWorksheetGrid;
  begin
    if l>0 then begin
      try
        mi.CopyFrom(f, l);
        mi.Position := 0;
        c1 := Inflate(mi, mc, ah);
        if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
        mc.Position := 0;
        p.Clear;
        p.LoadFromStream(mc);
//        p.Recalc;
      except
        on e: Exception do MessageDlg('Worksheet recovery failed! '+e.Message, mtError, [mbOK], 0);
      end;
    end {else p.Clear};
    mi.Clear;
    mc.Clear;
    if (ind <> plansindex[pindex]) and (p.Name <> plansnames[pindex]) then
      raise Exception.Create('Error reading spreadsheet, wrong grid');
  end;


begin
  if fn <> '' then begin
    floading := True;
    plancount := 0;
    for k := 1 to maxplan do begin
      plansnames[k] := '';
      plansindex[k] := 0;
    end;
    try
      mi := TMemoryStream.Create;
      f := TFileStream.Create(fn, fmOpenRead);
      f.ReadBuffer(b, 8);
      if compar(b, marca) or compar(b, marki) or compar(b, mark3) or
         compar(b, marbc) or compar(b, marbf) or compar(b, marf2) or
         compar(b, marf3) then raise Exception.Create('File not suported!');
      mode := none;
      if compar(b, mbdco) then mode := contin;
      if compar(b, mbdfh) then mode := fithum;
      if compar(b, mbdfo) then mode := fitox;
      if mode = none then raise Exception.Create('Unrecognized file format');
      Child := TFormInterf.Create(Application);
      Child.childmode:= mode;
      ah := TAbDeflateHelper.Create;
      ah.Options := ah.Options or $10;
      pindex := 0;
      decsep := FormatSettings.DecimalSeparator;
      FormatSettings.DecimalSeparator := '.';
      try
          mi := TmemoryStream.Create;
          mc := TmemoryStream.Create;
          buf := TStringList.Create;
          Savecomps := TSaveComps.Create(Child);
          with SaveComps.SavedProperties do begin
            Add('Text');
            Add('Caption');
            Add('ItemIndex');
            Add('PageIndex');
            Add('Checked');
            Add('Down');
            Add('Lines');
            Add('Value');
            SaveComps.OnLoadComponentEvent:= SaveCompsLoadComponentEvent;
          end;

          f.ReadBuffer(nr, 4);
          case mode of
            contin: if nr <> recform2 then raise Exception.Create('Invalid form record, expected contin type');
            fithum: if nr <> recform3 then raise Exception.Create('Invalid form record, expected fithum type');
            fitox: if nr <> recform4 then raise Exception.Create('Invalid form record, expected fitox type');
          end;
          c := Child.ComponentCount + 12;
    //
          FormProg.Prog.Max := c;
          FormProg.Prog.Min := 0;
          FormProg.Prog.Position := 0;
          FormProg.Labl.Caption := 'Recovering project ...';
          FormProg.Show;

          i := 0;
          fnp := dirtemp+'\temp$$$'+IntToStr(procid);
          fnt := fnp+'.tmp';
          while FileExists(fnt) do begin
            inc(i);
            fnt := fnp+'-'+IntToStr(i)+'.tmp';
          end;
          f.ReadBuffer(l, 8);
          f.ReadBuffer(c, 4);
          mi.CopyFrom(f, l);
          mi.Position := 0;
          c1 := Inflate(mi, mc, ah);
          if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
          mc.Position := 0;
          buf.LoadFromStream(mc);
          buf.SaveToFile(fnt);
          mc.Clear;
          mi.Clear;
          SaveComps.Active := True;
          SaveComps.IniFileName := fnt;
          SaveComps.LoadComponentsProps;
          SaveComps.Active := False;
          Child.Caption := Child.TitEdit.Text+' '+fn;
          DeleteFile(fnt);

          f.ReadBuffer(nr, 4);
          while nr <> recend do begin
            f.ReadBuffer(l, 8);
            f.ReadBuffer(c, 4);
            case nr of
              recplanx: begin
                f.ReadBuffer(kk, 4);
                if kk > 0 then begin
                  inc(pindex);
                  recupplanx(kk);
                end else
                  raise Exception.Create('Error reading spreadsheet, index: '+IntToStr(kk));
              end;
              recgrafa: begin
                recupgrec(Child.DefGrafFit);
                HacerGraficoAuto(Child.DefGrafFit);
              end;
              recgrafd: begin
                recupgrec(Child.DefGrafDist);
                HacerGraficoAuto(Child.DefGrafDist);
              end;
              recgrafr: begin
                recupgrec(Child.DefGrafRes);
                HacerGraficoAuto(Child.DefGrafRes);
              end;
              recgrafv: begin
                recupgrec(Child.DefGrafVol);
                HacerGraficoAuto(Child.DefGrafVol);
              end;
              routmemo: begin
                if l > 0 then begin
                  mi.CopyFrom(f, l);
                  mi.Position := 0;
                  c1 := Inflate(mi, mc, ah);
                  if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
                  SetLength(st, mc.Size);
                  mc.Position := 0;
                  //mc.ReadBuffer(st[1], mc.Size);
                  Child.OutputMemo.Lines.LoadFromStream(mc);
                  mi.Clear;
                  mc.Clear;
                end;
              end;
              else raise Exception.Create('Record not recognized');
            end;       //case nr of
            f.ReadBuffer(nr, 4);
          end;       //while
    //      case index of
    //        1: Child.ColCheckPres := Child.PlanD.GetCheckBoxState(0, 1, State);
    //        2: begin
    //           Childf.ColCheckPres := Childf.PlanD.GetCheckBoxState(0, 1, State);
    //           Childf.competnica := Childf.CheckCompet.Checked;
    //           Childf2.ColCheckPres := Childf2.PlanD.GetCheckBoxState(0, 1, State);
    //           if Childf.competnica then
    //             Childf2.NumberOfIonsBox.ItemIndex := Childf.NumCationes.ItemIndex + 1
    //           else
    //             Childf2.NumberOfIonsBox.ItemIndex := 0;
    //           ni := Childf2.NumberOfIonsBox.ItemIndex + 1;
    //           Childf2.competnica := Childf2.NumberOfIonsBox.ItemIndex > 0;
    //           Childf2.NumberOfIonsBoxChange(MainForm);
    //           Childf2.ngau := Childf2.Npicosbox.ItemIndex + 1;
    //           nc := Childf2.EntNCurv.AsInteger;
    //           for j := 1 to nc do
    //             Childf2.npcurv[j] := Childf2.PlanCurves.Ints[1, j];
    //        end;
    //        3: with Childf2 do begin
    //           ColCheckPres := PlanD.GetCheckBoxState(0, 1, State);
    //           competnica := NumberOfIonsBox.ItemIndex > 0;
    //           NumberOfIonsBoxChange(MainForm);
    //           ngau := Npicosbox.ItemIndex + 1;
    //           NICPeakComboChange(MainForm);
    //           npnica := NICPeakCombo.ItemIndex + 2;
    //           nc := EntNCurv.AsInteger;
    //           for j := 1 to nc do
    //             npcurv[j] := PlanCurves.Ints[1, j];
    //           nion := NumberOfIonsBox.ItemIndex + 1;
    //           ncurvas := EntNCurv.AsInteger;
    //           indelectr := ElectroGroup.ItemIndex + 1;
    //        end;
    //        4: with Childf3 do begin
    //            ColCheckPres := Childf3.PlanD.GetCheckBoxState(0, 1, State);
    //            nc := EntNCurv.AsInteger;
    //            for j := 1 to nc do
    //              npcurv[j] := PlanCurves.Ints[1, j];
    //            numcomp := Round(NumberOfIonsBox.Value);
    //            ncurvas := EntNCurv.AsInteger;
    //            numspec := NumberOfSpeciesBox.AsInteger;
    //            indmodel := ModelGroup.ItemIndex + 1;
    //            // SpeciesTabExit(MainForm);
    //            if indmodel > 1 then j := indmodel - 1 else j := 1;
    //            stoicols := numcomp + 1 + j;
    //            numsurf := 0;
    //            for i := 1 to numcomp do begin
    //              surfcomp[i] := IsSpecial(ParseFormula(PlanGen.Cells[1, i + 1]));
    //              if surfcomp[i] then
    //                inc(numsurf);
    //            end;
    //            for i := 1 to nc do begin                       //count y's per curve
    //              nyspcurv[i] := 0;
    //              for k := 4 to PlanCurves.ColCount - 4 do begin
    //                PlanCurves.GetCheckBoxState(k, i, State);
    //                if State then inc(nyspcurv[i]);
    //              end;
    //              ncu := ncu + nyspcurv[i];
    //              nystots[i] := ncu;
    //            end;
    //            CurvesTabEnter(MainForm);
    //            ModelParamEnter(MainForm);
    //            PlanD.Recalc;
    //            PlanR.Recalc;
    //        end;
    //      end;
          MRUList.Add(fn, 0);
    //
      except
        on exc: Exception do
          MessageDlg('Project recovery failed! '+exc.Message, mtError, [mbOK], 0);
      end;

    finally
      mi.Free;
      mc.Free;
      buf.Free;
      f.Free;
      FormProg.Hide;
      Child.PlanD.Tag := 0;
//        Child.PlanD.Modified := False;
      Child.PlanC.Tag := 0;
//        Child.PlanC.Modified := False;
      Child.PlanR.Tag := 0;
//        Child.PlanR.Modified := False;
      Child.Invalidate;
      Application.ProcessMessages;
    end;
    FormatSettings.DecimalSeparator := decsep;

      //Child := TContinInt.Create(Application);
      //Child.Caption := OpenDialogProj.FileName;
      //Child.Invalidate;
      //s.ReadBuffer(Child.misdatos, SizeOf(TIntDatos));
      //s.ReadBuffer(Child.RGAjuste, SizeOf(TRecGraf));
      //s.ReadBuffer(Child.RGDistribucion, SizeOf(TRecGraf));
      //Child.ReponerDatos;
      //Child.RGAjuste.Graf := Child.GrafAjuste;
      //Child.RGAjuste.Planilla := Child.PlanR;
      //Child.RGDistribucion.Graf := Child.GrafDistrib;
      //Child.RGDistribucion.Planilla := Child.PlanC;
      //s.ReadBuffer(i, 8);
      //m.CopyFrom(s, i);
      //m.Position := 0;
      //Child.PlanD.LoadFromBinStream(m);
      //Child.PlanD.Recalc;
      //m.Clear;
      //s.ReadBuffer(i, 8);
      //m.CopyFrom(s, i);
      //m.Position := 0;
      //Child.PlanC.LoadFromBinStream(m);
      //Child.PlanC.Recalc;
      //m.Clear;
      //s.ReadBuffer(i, 8);
      //m.CopyFrom(s, i);
      //m.Position := 0;
      //Child.PlanR.LoadFromBinStream(m);
      //Child.PlanR.Recalc;
      //if Child.misdatos.grafajust then
      //  RehacerGrafico(Child.RGAjuste);
      //if Child.misdatos.grafdistr then
      //  RehacerGrafico(Child.RGDistribucion);
      //Child.Invalidate;
    floading := False;
    Child.myfilename:= fn;
  end;
end;


procedure TMainForm.Archivo1Click(Sender: TObject);
var
  b: boolean;
begin
  b := MDIChildCount > 0;
  Guardar1.Enabled := b;
  Cerrar1.Enabled := b;
  Importardatos1.Enabled := b;
  Importardistribucin1.Enabled := b;
  Grabardatos1.Enabled := b;
  Grabarresultados1.Enabled := b;
  Salvardistribucin1.Enabled := b;
  Abrirtodaslasplanillas1.Enabled := b;
  Guardartodaslasplanillas1.Enabled := b;
  Configurarimpresora1.Enabled := b;
  Parmetrosdeimpresin1.Enabled := b;
  Vistapreliminar1.Enabled := b;
  Imprimir1.Enabled := b;
//  Opendefinition1.Visible := ActiveMDIChild is TFitInterf3;
//  Savedefinition1.Visible := ActiveMDIChild is TFitInterf3;
end;


procedure TMainForm.BotImportDistrClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    Importar(TFormInterf(ActiveMDIChild).PlanC, 'distribution');
end;

procedure TMainForm.BotPararClick(Sender: TObject);
begin
  //if ActiveMDIChild is TContinInt then
  //  TContinInt(ActiveMDIChild).Parar1Click(Sender);
  //if ActiveMDIChild is TContinInterf then
  //  TContinInterf(ActiveMDIChild).Parar1Click(Sender);
  //if ActiveMDIChild is TFitInterf then
  //  TFitInterf(ActiveMDIChild).Parar1Click(Sender);
  //if ActiveMDIChild is TFitInterf2 then
  //  TFitInterf2(ActiveMDIChild).Parar1Click(Sender);
  //if ActiveMDIChild is TFitInterf3 then
  //  TFitInterf3(ActiveMDIChild).Parar1Click(Sender);
end;

procedure TMainForm.BotSalvDatClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    Exportar(TFormInterf(ActiveMDIChild).PlanD, 'data');
end;

procedure TMainForm.Borrararchivostemporarios1Click(Sender: TObject);
var
  fr: TSearchRec;
begin
  if MessageDlg('Erase all temporary files?', mtConfirmation, mbYesNo, 0) = mrYes then begin
    if FindFirst(dirtemp+'\*.*', 0, fr) = 0 then begin
      SysUtils.DeleteFile(dirtemp+'\'+fr.Name);
      while FindNext(fr) = 0 do SysUtils.DeleteFile(dirtemp+'\'+fr.Name);
    end;
    SysUtils.FindClose(fr);
  end;
end;

procedure TMainForm.BotCopiarClick(Sender: TObject);
begin
  //if ActiveMDIChild is TContinInt then
  //  TContinInt(ActiveMDIChild).CopyItemClick(Sender);
  //if ActiveMDIChild is TContinInterf then
  //  TContinInterf(ActiveMDIChild).CopyItemClick(Sender);
  //if ActiveMDIChild is TFitInterf then
  //  TFitInterf(ActiveMDIChild).CopyItemClick(Sender);
  //if ActiveMDIChild is TFitInterf2 then
  //  TFitInterf2(ActiveMDIChild).CopyItemClick(Sender);
  //if ActiveMDIChild is TFitInterf3 then
  //  TFitInterf3(ActiveMDIChild).CopyItemClick(Sender);
end;


procedure TMainForm.Cerrar1Click(Sender: TObject);
begin
  ActiveMDIChild.Close;
end;


procedure TMainForm.FileNewContin(Sender: TObject);
var
  fs: TFormatSettings;
begin
  //GetLocaleFormatSettings(LOCALE_USER_DEFAULT, fs);
  CreateMDIChild('CONTIN '+DateTimeToStr(Now), contin);
end;

procedure TMainForm.FileNewHumic(Sender: TObject);
begin
  CreateMDIChild('FIT '+DateTimeToStr(Now), fithum);
end;

procedure TMainForm.Cut(Sender: TObject);
begin
 //
end;

procedure TMainForm.FileNewOxide(Sender: TObject);
begin
  CreateMDIChild('FIT '+DateTimeToStr(Now), fitox);

end;

function TMainForm.Traercuenta: string;
begin
  inc(runcount);
  Result := IntToStr(runcount);
end;

procedure TMainForm.Configurarimpresora1Click(Sender: TObject);
begin
  PrinterSetup.Execute;
end;

procedure TMainForm.Exportar(Plan: TsWorkSheetGrid; ptit: string);
var
  fmt: TsSpreadsheetFormat;
begin
  with SaveDialog do begin
    Title := 'Save file '+ptit;
    if Execute and (FileName <> '') then begin
        try
          Plan.WorkbookSource := sWorkbookSource1;
          case FilterIndex of
            1: fmt := sfOOXML;                // Note: Indexes are 1-based here!
            2: fmt := sfExcel8;
            3: fmt := sfOpenDocument;
            4: begin
              CSVParams.Delimiter:= #9;
              fmt := sfCSV;
            end;
            5: begin
              CSVParams.Delimiter:= ' ';
              fmt := sfCSV;
            end;
            6: begin
              CSVParams.Delimiter:= ';';
              fmt := sfCSV;
            end;
            7: begin
              CSVParams.Delimiter:= ',';
              fmt := sfCSV;
            end;
          end;
          sWorkbookSource1.SaveToSpreadsheetFile(FileName, fmt);
        except
          on exc: Exception do begin
              MessageDlg(exc.Message, mtError, [mbOK], 0);
              exit;
          end;
        end;
    end;
  end;
end;

procedure TMainForm.Importar(Plan: TsWorkSheetGrid; ptit: string);

begin
  with OpenDlg do begin
    Title := 'Save file '+ptit;
    if Execute and (FileName <> '') then begin
        Plan.WorkbookSource := sWorkbookSource1;
        try
          sWorkbookSource1.AutodetectFormat := false;
          case FilterIndex of
            1: sWorkbookSource1.AutoDetectFormat := true;         // All spreadsheet files
            2: sWorkbookSource1.AutoDetectFormat := true;         // All Excel files
            3: sWorkbookSource1.FileFormat := sfOOXML;            // Excel 2007+
            4: sWorkbookSource1.FileFormat := sfExcel8;           // Excel 97-2003
            5: sWorkbookSource1.FileFormat := sfExcel5;           // Excel 5.0
            6: sWorkbookSource1.FileFormat := sfExcel2;           // Excel 2.1
            7: sWorkbookSource1.FileFormat := sfOpenDocument;     // Open/LibreOffice
            8: sWorkbookSource1.FileFormat := sfCSV;              // Text files
          end;
          sWorkbookSource1.FileName := FileName;  // This loads the file
        except
          on exc: Exception do begin
              MessageDlg(exc.Message, mtError, [mbOK], 0);
              exit;
          end;
        end;
    end;
  end;
end;

procedure TMainForm.N32bitsgenrico1Click(Sender: TObject);
begin
  continexec := dirprogr + '\' + exec32;
  fitexec := dirprogr + '\' + fexec32;
//  CopyFile(PChar(dirprogr + '\' + dll32), PChar(dirprogr + '\' + dll), False);
//  N32bitsgenrico1.Checked := True;
end;

procedure TMainForm.N64bits1Click(Sender: TObject);
begin
  continexec := dirprogr + '\' + exec64;
  fitexec := dirprogr + '\' + fexec64;
//  CopyFile(PChar(dirprogr + '\' + dll64), PChar(dirprogr + '\' + dll), False);
end;

procedure TMainForm.Opendefinition1Click(Sender: TObject);
begin
  //if ActiveMDIChild is TFitInterf3 then
  //  TFitInterf3(ActiveMDIChild).AbrirDefinicion(Sender);
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.BotCorrerClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
  TFormInterf(ActiveMDIChild).Ejecutar1Click(Sender);
end;

procedure TMainForm.BotGenClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    TFormInterf(ActiveMDIChild).BotGenClick(Sender);
end;

procedure TMainForm.BotGrafDatosClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    TFormInterf(ActiveMDIChild).GraficarDatos1Click(Sender);
end;

procedure TMainForm.BotGuardarClick(Sender: TObject);
var
  k: integer;
begin
  if ActiveMDIChild is TFormInterf then begin
    if not SaveDlgProj.Execute then exit;
    SalvaProyecto(SaveDlgProj.FileName);
  end;
end;

procedure TMainForm.GrafResultClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    TFormInterf(ActiveMDIChild).GraficarResultados1Click(Sender);
end;

procedure TMainForm.ImportarDatosClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    Importar(TFormInterf(ActiveMDIChild).PlanD, 'data');
end;

procedure TMainForm.MRUListClick(Sender: TObject; const RecentName,
  ACaption: string; UserData: PtrInt);
begin
  AbrirProyecto(RecentName);
end;

procedure TMainForm.Parmetrosdeimpresin1Click(Sender: TObject);
begin
  //if ActiveMDIChild is TContinInterf then
  //  TContinInterf(ActiveMDIChild).PrintSet(Sender);
  //if ActiveMDIChild is TFitInterf then
  //  TFitInterf(ActiveMDIChild).PrintSet(Sender);
  //if ActiveMDIChild is TFitInterf2 then
  //  TFitInterf2(ActiveMDIChild).PrintSet(Sender);
  //if ActiveMDIChild is TFitInterf3 then
  //  TFitInterf3(ActiveMDIChild).PrintSet(Sender);
end;

procedure TMainForm.Previa1Click(Sender: TObject);
begin
  if MDIChildCount > 0 then
    Previous;
end;

procedure TMainForm.BotPegarClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    TFormInterf(ActiveMDIChild).PasteItemClick(Sender);
end;

procedure TMainForm.BotSalvarResultadosClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    Exportar(TFormInterf(ActiveMDIChild).PlanR, 'results');
end;

procedure TMainForm.Siguiente1Click(Sender: TObject);
begin
  if MDIChildCount > 0 then
    Next;
end;

procedure TMainForm.BotPrintClick(Sender: TObject);
begin
  //if ActiveMDIChild is TContinInt then
  //  TContinInt(ActiveMDIChild).PlanAct.Print;
  //if ActiveMDIChild is TContinInterf then
  //  TContinInterf(ActiveMDIChild).PlanAct.Print;
  //if ActiveMDIChild is TFitInterf then
  //  TFitInterf(ActiveMDIChild).PlanAct.Print;
  //if ActiveMDIChild is TFitInterf2 then
  //  TFitInterf2(ActiveMDIChild).PlanAct.Print;
  //if ActiveMDIChild is TFitInterf3 then
  //  TFitInterf3(ActiveMDIChild).PlanAct.Print;
end;

procedure TMainForm.BotCortarClick(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    TFormInterf(ActiveMDIChild).CutItemClick(Sender);
end;


procedure TMainForm.Abrirtodaslasplanillas1Click(Sender: TObject);
begin
  //if ActiveMDIChild is TContinInt then
  //  TContinInt(ActiveMDIChild).AbrirTodo1Click(Sender);
  //if ActiveMDIChild is TContinInterf then
  //  TContinInterf(ActiveMDIChild).AbrirTodo1Click(Sender);
  //if ActiveMDIChild is TFitInterf then
  //  TFitInterf(ActiveMDIChild).AbrirTodo1Click(Sender);
  //if ActiveMDIChild is TFitInterf2 then
  //  TFitInterf2(ActiveMDIChild).AbrirTodo1Click(Sender);
  //if ActiveMDIChild is TFitInterf3 then
  //  TFitInterf3(ActiveMDIChild).AbrirTodo1Click(Sender);
end;

procedure TMainForm.Guardartodaslasplanillas1Click(Sender: TObject);
begin
  //if ActiveMDIChild is TContinInt then
  //  TContinInt(ActiveMDIChild).SalvarTodo1Click(Sender);
  //if ActiveMDIChild is TContinInterf then
  //  TContinInterf(ActiveMDIChild).SalvarTodo1Click(Sender);
  //if ActiveMDIChild is TFitInterf then
  //  TFitInterf(ActiveMDIChild).SalvarTodo1Click(Sender);
  //if ActiveMDIChild is TFitInterf2 then
  //  TFitInterf2(ActiveMDIChild).SalvarTodo1Click(Sender);
  //if ActiveMDIChild is TFitInterf3 then
  //  TFitInterf3(ActiveMDIChild).SalvarTodo1Click(Sender);
end;

procedure TMainForm.ApplicationEvents1Hint(Sender: TObject);
begin
    StatusBar.SimpleText := Application.Hint;
end;


procedure TMainForm.FormCreate(Sender: TObject);
var
  i: integer;
begin
  marcas[1] := marca;
  marcas[2] := marki;
  marcas[3] := mark3;
  marcas[4] := marbc;
  marcas[5] := marbf;
  marcas[6] := marf2;
  marcas[7] := marf3;
  marcas[8] := mbdco;
  marcas[9] := mbdfh;
  marcas[10] := mbdfo;
  //SaveComps := TSaveComps.Create(MainForm);
   //with SaveComps.SavedProperties do begin
   //  Add('Text');
   //  Add('Caption');
   //  Add('ItemIndex');
   //  Add('PageIndex');
   //  Add('Checked');
   //  Add('Down');
   //  Add('Lines');
   //  Add('Value');
   //end;
end;

procedure TMainForm.Guardar0Click(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then with TFormInterf(ActiveMDIChild) do begin
    if myfilename <> '' then
      SalvaProyecto(myfilename);
  end;
end;

procedure TMainForm.Fin1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.BotEnabled;
begin
  BotOpen.Enabled := True;
  BotSave.Enabled := True;
  BotImportDat.Enabled := True;
  BotImportDistr.Enabled := True;
  BotSalvDat.Enabled := True;
  BotSalvarResultados.Enabled := True;
  BotPrint.Enabled := True;
  BotGen.Enabled := True;
  BotGrafDatos.Enabled := True;
  BotCorrer.Visible := True;
  BotCorrer.Enabled := True;
  BotParar.Enabled := True;
  BotGrafResult.Enabled := True;
  BotCortar.Enabled := True;
  BotCopiar.Enabled := True;
  BotPegar.Enabled := True;
  Ejecutable1.Enabled := True;
end;

procedure TMainForm.BotDisabled;
begin
  BotOpen.Enabled := False;
  BotSave.Enabled := False;
  BotImportDat.Enabled := False;
  BotImportDistr.Enabled := False;
  BotSalvDat.Enabled := False;
  BotSalvarResultados.Enabled := False;
  BotPrint.Enabled := False;
  BotGen.Enabled := False;
  BotGrafDatos.Enabled := False;
  BotCorrer.Enabled := False;
  BotParar.Enabled := False;
  BotGrafResult.Enabled := False;
  BotCortar.Enabled := False;
  BotCopiar.Enabled := False;
  BotPegar.Enabled := False;
  Ejecutable1.Enabled := False;
end;

//procedure TMainForm.RecuperarEstado(f: TFileStream; Child: TFormInterf);
//
//var
//  i, c: integer;
//  fn1, fn3: string;
//  buf: TStringList;
//  m: TMemoryStream;
//  l: int64;
//  Tabla: TsWorksheetGrid;
//  Graf: TChart;
//
//  st: string;
//
//begin
//  try
//    try
//      c := Self.ComponentCount + 7;
//      m := TmemoryStream.Create;
//      buf := TStringList.Create;
//      FormProg.Prog.Max := c;
//      FormProg.Prog.Min := 0;
//      FormProg.Prog.Position := 0;
//      FormProg.Labl.Caption := 'Recovering project ...';
//      FormProg.Show;
//      fn1 := dirprogr+'\temp1$$$.INI';
//      f.ReadBuffer(l, 8);
//      m.CopyFrom(f, l);
//      m.Position := 0;
//      buf.LoadFromStream(m);
//      buf.SaveToFile(fn1);
//      m.Clear;
//      //Child.SaveComps1.Active := True;
//      //Child.SaveComps1.IniFileName := fn1;
//      //Child.SaveComps1.LoadComponentsProps;
//      //Child.SaveComps1.Active := False;
//
//      //f.ReadBuffer(Child.DefGrafFit, SizeOf(TRecGrafNew));        // OJO CONVERSIONES
//      //f.ReadBuffer(Child.RGDistribucion, SizeOf(TRecGraf));
//      //f.ReadBuffer(Child.RGResid, SizeOf(TRecGraf));
//      //f.ReadBuffer(Child.RGAjuste, SizeOf(TRecGraf));
//      //f.ReadBuffer(Child.RGGraf2, SizeOf(TRecGraf2));
//      for i := 1 to 3 do begin
//        case i of
//          1: Tabla := Child.PlanD;
//          2: Tabla := Child.PlanC;
//          3: Tabla := Child.PlanR;
//        end;
//        f.ReadBuffer(l, 8);
//        if l > 0 then begin
//          m.CopyFrom(f, l);
//          m.Position := 0;
//          Tabla.LoadFromStream(m);
//          Tabla.AutoCalc:= True;
//          //ActualizarDatos(Tabla, i);
//        end else Tabla.Clear;
//        m.Clear;
//        FormProg.Prog.Position := FormProg.Prog.Position + 1;
//      end;
//      m.Clear;
//      fn3 := dirprogr+'\temp3$$$.tmp';
//      for i := 1 to 4 do begin
//        case i of
//          1: Graf := Child.GrafAjuste;
//          2: Graf := Child.GrafDistrib;
//          3: Graf := Child.GrafResid;
//          4: Graf := Child.GrafAjuste;
//        end;
//        f.ReadBuffer(l, 8);
//        if l > 0 then begin
//          m.CopyFrom(f, l);
//          m.Position := 0;
//          m.SaveToFile(fn3);
//  //        Graf.LoadData(fn3, False);
//          //case i  of
//          //  1: begin
//          //    Child.DefGrafFit.Graf := Graf;
//          //    Child.DefGrafFit.Planilla := Child.PlanR;
//          //    //if Child.RGGraf2.grafajust then
//          //    //  RehacerGrafico(Child.RGAjuste);
//          //  end;
//          //  2: begin
//          //    Child.DefGrafDist.Graf := Graf;
//          //    Child.DefGrafDist.Planilla := Child.PlanR;
//          //    //if Child.RGGraf2.grafdistr then
//          //    //  RehacerGrafico(Child.RGDistribucion);
//          //  end;
//          //  3: begin
//          //    Child.RGResid.Graf := Graf;
//          //    Child.RGresid.Planilla := Child.PlanR;
//          //    //if Child.RGGraf2.grafajust then
//          //    //  RehacerGrafico(Child.RGResid);
//          //  end;
//          //  4: begin
//          //    //Child.RGFiteo.Graf := Graf;
//          //    //Child.RGFiteo.Planilla := Child.PlanR;
//          //    //if Child.RGGraf2.graffiteo then
//          //    //  RehacerGrafico1(Child.RGFiteo, Child.RGGraf2);
//          //  end;
//          //end;
//        end;
//        m.Clear;
//        DeleteFile(fn3);
//        FormProg.Prog.Position := FormProg.Prog.Position + 1;
//      end;
//      if f.Position < f.Size then begin
//        f.ReadBuffer(l, 8);
//        SetLength(st, l);
//        if l > 0 then
//          f.ReadBuffer(st[1], l);
//        Child.OutputMemo.Lines.Text := st;
//      end;
//      //if Child.CONTIN1.Checked then Child.CONTIN1Click(Child);
//      //if Child.FIT1.Checked then Child.FIT1Click(Child);
//    except
//      on exc: Exception do begin
//        MessageDlg('Project recovery failed! '+exc.Message, mtError, [mbOK], 0);
//      end;
//    end;
//  finally
//    f.Free;
//    m.Free;
//    buf.Free;
//    DeleteFile(fn1);
//    DeleteFile(fn3);
//    FormProg.Hide;
//    Child.Invalidate;
//    Application.ProcessMessages;
//  end;
//end;

//procedure TMainForm.RecuperarEstado4(f: TFileStream; index: integer; filename: string);
//var
//  i, j, k, c, c1, n, ncu, col1, col2, colt, colh, ni, nc, kk: integer;
//  nr: Trecbind;
//  fnp, fnt: string;
//  buf: TStringList;
//  mi, mc: TMemoryStream;
//  l: int64;
//  //Tabla: TAdvSpreadGrid;
//  //Graf: TRChart;
//  //st: string;
//  //Child: TContinInterf;
//  //Childf: THInterfFit;
//  //Childf2: TFitInterf2;
//  //Childf3: TFitInterf3;
//  State: boolean;
//  b: buf8;
//  ah: TAbDeflateHelper;
//  hand: THandle;
//  decsep: char;
//
//  procedure recupgrec(var r: TRecgraf3);
//  var
//    grafr0: TRecGraf03;
//    i: integer;
//  begin
//    try
//      mi.CopyFrom(f, l);
//      mi.Position := 0;
//      c1 := Inflate(mi, mc, ah);
//      if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
//      mc.Position := 0;
//      if mc.Size = SizeOf(TRecgraf3) then
//         mc.ReadBuffer(r, SizeOf(TRecgraf3));
//    except
//      try
//        mc.Position := 0;
//        mc.ReadBuffer(grafr0, SizeOf(TRecgraf03));
//            r.Graf := grafr0.Graf;
//            r.Planilla := grafr0.Planilla;
//            r.grafpres := grafr0.grafpres;
//            r.Params.numcurv := grafr0.Params.numcurv;
//            r.Params.titugraf := grafr0.Params.titugraf;
//            r.Params.titux := grafr0.Params.titux;
//            r.Params.tituy1 := grafr0.Params.tituy1;
//            r.Params.tituy2 := grafr0.Params.tituy2;
//            r.Params.ejedoble := grafr0.Params.ejedoble;
//            r.Params.escautomx := grafr0.Params.escautomx;
//            r.Params.escautomy1 := grafr0.Params.escautomy1;
//            r.Params.escautomy2 := grafr0.Params.escautomy2;
//            r.Params.elogx := grafr0.Params.elogx;
//            r.Params.elogy1 := grafr0.Params.elogy1;
//            r.Params.elogy2 := grafr0.Params.elogy2;
//            r.Params.exmin := grafr0.Params.exmin;
//            r.Params.exmax := grafr0.Params.exmax;
//            r.Params.ey1min := grafr0.Params.ey1min;
//            r.Params.ey2min := grafr0.Params.ey2min;
//            r.Params.ey1max := grafr0.Params.ey1max;
//            r.Params.ey2max := grafr0.Params.ey2max;
////            for i := 1 to 16 do
// //             r.Params.CurvParams[i] := grafr0.Params.CurvParams[i];
//      except
//        on e: Exception do MessageDlg('Graf data recovery failed! '+e.Message, mtError, [mbOK], 0);
//      end;
//    end;
//    mi.Clear;
//    mc.Clear;
//  end;
//
//  procedure recupgrec2(var r: TRecgraf3);
//  var
//    grafr0: TRecGraf03;
//    r2: TRecGraf23;
//    i: integer;
//  begin
//    try
//      mi.CopyFrom(f, l);
//      mi.Position := 0;
//      c1 := Inflate(mi, mc, ah);
//      if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
//      mc.Position := 0;
//      mc.ReadBuffer(r2, SizeOf(TRecgraf23));
//      r.Graf := r2.Graf;
//      r.Planilla := r2.Planilla;
//      r.grafpres := r2.grafpres;
//      r.Params.numcurv := r2.Params.numcurv;
//      r.Params.titugraf := r2.Params.titugraf;
//      r.Params.titux := r2.Params.titux;
//      r.Params.tituy1 := r2.Params.tituy1;
//      r.Params.tituy2 := r2.Params.tituy2;
//      r.Params.ejedoble := r2.Params.ejedoble;
//      r.Params.escautomx := r2.Params.escautomx;
//      r.Params.escautomy1 := r2.Params.escautomy2;
//      r.Params.escautomy1 := r2.Params.escautomy2;
//      r.Params.elogx := r2.Params.elogx;
//      r.Params.elogy1 := r2.Params.elogy1;
//      r.Params.elogy2 := r2.Params.elogy2;
//      r.Params.exmin := r2.Params.exmin;
//      r.Params.exmax := r2.Params.exmax;
//      r.Params.ey1min := r2.Params.ey1min;
//      r.Params.ey1max := r2.Params.ey1max;
//      r.Params.ey2min := r2.Params.ey2min;
//      r.Params.ey2max := r2.Params.ey2max;
//  //    for i := 1 to 32 do
//  //      r.Params.CurvParams[i] := r2.Params.CurvParams[i]
//    except
//      try
//        mc.Position := 0;
//        mc.ReadBuffer(grafr0, SizeOf(TRecgraf03));
//            r.Graf := grafr0.Graf;
//            r.Planilla := grafr0.Planilla;
//            r.grafpres := grafr0.grafpres;
//            r.Params.numcurv := grafr0.Params.numcurv;
//            r.Params.titugraf := grafr0.Params.titugraf;
//            r.Params.titux := grafr0.Params.titux;
//            r.Params.tituy1 := grafr0.Params.tituy1;
//            r.Params.tituy2 := grafr0.Params.tituy2;
//            r.Params.ejedoble := grafr0.Params.ejedoble;
//            r.Params.escautomx := grafr0.Params.escautomx;
//            r.Params.escautomy1 := grafr0.Params.escautomy1;
//            r.Params.escautomy2 := grafr0.Params.escautomy2;
//            r.Params.elogx := grafr0.Params.elogx;
//            r.Params.elogy1 := grafr0.Params.elogy1;
//            r.Params.elogy2 := grafr0.Params.elogy2;
//            r.Params.exmin := grafr0.Params.exmin;
//            r.Params.exmax := grafr0.Params.exmax;
//            r.Params.ey1min := grafr0.Params.ey1min;
//            r.Params.ey2min := grafr0.Params.ey2min;
//            r.Params.ey1max := grafr0.Params.ey1max;
//            r.Params.ey2max := grafr0.Params.ey2max;
//  //          for i := 1 to 16 do
//  //            r.Params.CurvParams[i] := grafr0.Params.CurvParams[i];
//      except
//        on e: Exception do MessageDlg('Graf data recovery failed! '+e.Message, mtError, [mbOK], 0);
//      end;
//    end;
//    mi.Clear;
//    mc.Clear;
//  end;
//
//  procedure recupgrecM(var r: TRecgrafM);
//  var
//    grafr0: TRecGraf03;
//    r2: TRecGraf23;
//    i: integer;
//  begin
//    try
//      mi.CopyFrom(f, l);
//      mi.Position := 0;
//      c1 := Inflate(mi, mc, ah);
//      if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
//      mc.Position := 0;
//      mc.ReadBuffer(r2, SizeOf(TRecgraf23));
//      r.Graf := r2.Graf;
//      r.Planilla := r2.Planilla;
//      r.grafpres := r2.grafpres;
//      r.Params.numcurv := r2.Params.numcurv;
//      r.Params.titugraf := r2.Params.titugraf;
////      r.Params.titux := r2.Params.titux;
////      r.Params.tituy1 := r2.Params.tituy1;
////      r.Params.tituy2 := r2.Params.tituy2;
////      r.Params.ejedoble := r2.Params.ejedoble;
////      r.Params.escautomx := r2.Params.escautomx;
////      r.Params.escautomy1 := r2.Params.escautomy2;
////      r.Params.escautomy1 := r2.Params.escautomy2;
////      r.Params.elogx := r2.Params.elogx;
////      r.Params.elogy1 := r2.Params.elogy1;
////      r.Params.elogy2 := r2.Params.elogy2;
////      r.Params.exmin := r2.Params.exmin;
////      r.Params.exmax := r2.Params.exmax;
////      r.Params.ey1min := r2.Params.ey1min;
////      r.Params.ey1max := r2.Params.ey1max;
////      r.Params.ey2min := r2.Params.ey2min;
////      r.Params.ey2max := r2.Params.ey2max;
////      for i := 1 to 32 do
//  //      r.Params.CurvParams[i] := r2.Params.CurvParams[i]
//    except
//      try
//        mc.Position := 0;
//        mc.ReadBuffer(grafr0, SizeOf(TRecgraf03));
//            r.Graf := grafr0.Graf;
//            r.Planilla := grafr0.Planilla;
//            r.grafpres := grafr0.grafpres;
//            r.Params.numcurv := grafr0.Params.numcurv;
//            r.Params.titugraf := grafr0.Params.titugraf;
////            r.Params.titux := grafr0.Params.titux;
////            r.Params.tituy1 := grafr0.Params.tituy1;
////            r.Params.tituy2 := grafr0.Params.tituy2;
////            r.Params.ejedoble := grafr0.Params.ejedoble;
////            r.Params.escautomx := grafr0.Params.escautomx;
////            r.Params.escautomy1 := grafr0.Params.escautomy1;
////            r.Params.escautomy2 := grafr0.Params.escautomy2;
////            r.Params.elogx := grafr0.Params.elogx;
////            r.Params.elogy1 := grafr0.Params.elogy1;
////            r.Params.elogy2 := grafr0.Params.elogy2;
////            r.Params.exmin := grafr0.Params.exmin;
////            r.Params.exmax := grafr0.Params.exmax;
////            r.Params.ey1min := grafr0.Params.ey1min;
////            r.Params.ey2min := grafr0.Params.ey2min;
////            r.Params.ey1max := grafr0.Params.ey1max;
////            r.Params.ey2max := grafr0.Params.ey2max;
////            for i := 1 to 16 do
//  //            r.Params.CurvParams[i] := grafr0.Params.CurvParams[i];
//      except
//        on e: Exception do MessageDlg('Graf data recovery failed! '+e.Message, mtError, [mbOK], 0);
//      end;
//    end;
//    mi.Clear;
//    mc.Clear;
//  end;
//
//
//  procedure recupgraf(g: TChart; var r: TRecgraf3; p: TsWorksheetGrid);
//  begin
//    try
//      mi.CopyFrom(f, l);
//      mi.Position := 0;
//      c1 := Inflate(mi, mc, ah);
//      if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
//      mc.Position := 0;
//      mc.SaveToFile(fnt);
// //     g.LoadData(fnt, False);
//      r.Graf := g;
//      r.Planilla := p;
//      if r.grafpres then
//   //     RehacerGraf(r);
//    except
//      on e: Exception do MessageDlg('Graph recovery failed! '+e.Message, mtError, [mbOK], 0);
//    end;
//    mi.Clear;
//    mc.Clear;
//    DeleteFile(fnt);
//  end;
//
//    procedure recupgrafM(g: TChart; var r: TRecgrafM; p: TsWorksheetGrid);
//  begin
//    try
//      mi.CopyFrom(f, l);
//      mi.Position := 0;
//      c1 := Inflate(mi, mc, ah);
//      if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
//      mc.Position := 0;
//      mc.SaveToFile(fnt);
//  //    g.LoadData(fnt, False);
//      r.Graf := g;
//      r.Planilla := p;
//   //   if r.grafpres then
//   //     RehacerGraf(r);
//    except
//      on e: Exception do MessageDlg('Graph recovery failed! '+e.Message, mtError, [mbOK], 0);
//    end;
//    mi.Clear;
//    mc.Clear;
//    DeleteFile(fnt);
//  end;
//
//  procedure recupplan (p: TsWorksheetGrid);
//  begin
//    if l>0 then begin
//      try
//        mi.CopyFrom(f, l);
//        mi.Position := 0;
//        c1 := Inflate(mi, mc, ah);
//        if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
//        mc.Position := 0;
//  //      p.LoadFromBinStream(mc);
//        //p.Recalc;
//      except
//        on e: Exception do MessageDlg('Worksheet recovery failed! '+e.Message, mtError, [mbOK], 0);
//      end;
//    end {else p.Clear};
//    mi.Clear;
//    mc.Clear;
//  end;
//
//  procedure recupplanx (ind: integer);
//  var
//    p: TsWorksheetGrid;
//  begin
////    case index  of
//      //3:  p := TAdvStringGrid(Childf2.Components[plansindex[pindex]]);
//      //4:  p := TAdvStringGrid(Childf3.Components[plansindex[pindex]]);
//  //  end;
//    if l>0 then begin
//      try
//        mi.CopyFrom(f, l);
//        mi.Position := 0;
//        c1 := Inflate(mi, mc, ah);
//        if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
//        mc.Position := 0;
//        //p.Clear;
//        //p.LoadFromBinStream(mc);
////        p.Recalc;
//      except
//        on e: Exception do MessageDlg('Worksheet recovery failed! '+e.Message, mtError, [mbOK], 0);
//      end;
//    end {else p.Clear};
//    mi.Clear;
//    mc.Clear;
//    //if (ind <> plansindex[pindex]) and (p.Name <> plansnames[pindex]) then
//    //  raise Exception.Create('Error reading spreadsheet, wrong grid');
//  end;
//
//begin
//  ah := TAbDeflateHelper.Create;
//  ah.Options := ah.Options or $10;
//  pindex := 0;
//  decsep := FormatSettings.DecimalSeparator;
//  FormatSettings.DecimalSeparator := '.';
////  try
////    try
////      mi := TmemoryStream.Create;
////      mc := TmemoryStream.Create;
////      buf := TStringList.Create;
////
////      f.ReadBuffer(nr, 4);
////      case index of
////        1: begin
////            if nr = recform2 then
//// //             Child := TContinInterf.Create(Application)
////            else
////              raise Exception.Create('File error: Invalid type!');
//////            c := Child.ComponentCount + 12;
////
////        end;
////        2: begin
////            if nr = recform3 then begin
////            //  Childf := THInterfFit.Create(Application);    //OJO
////            //  Childf2 := THInterfFit2.Create(Application)
////            //end else
////              raise Exception.Create('File error: Invalid type!');
//////            c := Childf2.ComponentCount + 12;
////        end;
////        3: begin
////            if nr = recform3 then
//////              Childf2 := THInterfFit2.Create(Application)
////            else
////              raise Exception.Create('File error: Invalid type!');
////            c := Childf2.ComponentCount + 12;
////        end;
////        4: begin
////            if nr = recform3 then
////              Childf3 := THInterfFit3.Create(Application)
////            else
////              raise Exception.Create('File error: Invalid type!');
////            c := Childf3.ComponentCount + 12;
////        end;
////      end;
////
////      FormProg.Prog.Maximum := c;
////      FormProg.Prog.Minimum := 0;
////      FormProg.Prog.Position := 0;
////      FormProg.Labl.Caption := 'Recovering project ...';
////      FormProg.Show;
////
////      i := 0;
////      fnp := dirtemp+'\temp$$$'+IntToStr(procid);
////      fnt := fnp+'.tmp';
////      while FileExists(fnt) do begin
////        inc(i);
////        fnt := fnp+'-'+IntToStr(i)+'.tmp';
////      end;
////      f.ReadBuffer(l, 8);
////      f.ReadBuffer(c, 4);
////      mi.CopyFrom(f, l);
////      mi.Position := 0;
////      c1 := Inflate(mi, mc, ah);
////      if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
////      mc.Position := 0;
////      buf.LoadFromStream(mc);
////      buf.SaveToFile(fnt);
////      mc.Clear;
////      mi.Clear;
////      case index of
////        1: begin
////          Child.SaveComps1.Active := True;
////          Child.SaveComps1.IniFileName := fnt;
////          Child.SaveComps1.LoadComponentsProps;
////          Child.SaveComps1.Active := False;
////          Child.Caption := Child.TitEdit.Text+' '+filename;
////        end;
////        2: begin
////          Childf.SaveComps1.Active := True;
////          Childf.SaveComps1.IniFileName := fnt;
////          Childf.SaveComps1.LoadComponentsProps;
////          Childf.SaveComps1.Active := False;
////          //Childf.Caption := Childf.TitFitEdit.Text+' '+filename;
////          Childf2.SaveComps1.Active := True;
////          Childf2.SaveComps1.IniFileName := fnt;
////          Childf2.SaveComps1.LoadComponentsProps;
////          Childf2.SaveComps1.Active := False;
////          Childf2.Caption := Childf2.TitFitEdit.Text+' '+filename;
////          Childf2.DistrNICA2.PageIndex := 5;
////        end;
////        3: begin
////          Childf2.SaveComps1.Active := True;
////          Childf2.SaveComps1.IniFileName := fnt;
////          Childf2.SaveComps1.LoadComponentsProps;
////          Childf2.SaveComps1.Active := False;
////          Childf2.Caption := Childf2.TitFitEdit.Text+' '+filename;
////        end;
////        4: begin
////          Childf3.SaveComps1.Active := True;
////          Childf3.SaveComps1.IniFileName := fnt;
////          Childf3.SaveComps1.LoadComponentsProps;
////          Childf3.SaveComps1.Active := False;
////          Childf3.Caption := Childf3.TitFitEdit.Text+' '+filename;
////        end;
////      end;
////      DeleteFile(fnt);
////
////      f.ReadBuffer(nr, 4);
////      while nr <> recend do begin
////        f.ReadBuffer(l, 8);
////        f.ReadBuffer(c, 4);
////        case nr of
////          recgrafa: begin
////            if index <> 1 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            recupgrec(Child.RG3Ajuste);
////          end;
////          recgrafd: begin
////            if index <> 1 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            recupgrec(Child.RG3Distrib);
////          end;
////          recgrafr: begin
////            if index <> 1 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            recupgrec(Child.RG3Resid);
////          end;
////          recgraff: begin
////            if index < 2 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            case index of
////              2: begin
////                 recupgrec2(Childf2.RG3Fit);
////              end;
////              3: recupgrec(Childf2.RG3Fit);
////              4: recupgrecM(Childf3.RGMFit);
////            end;
////          end;
////          recgrafv: begin
////            if index < 3 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            recupgrec(Childf2.RG3Vol);
////          end;
////          rgrafa: begin
////            if index <> 1 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            recupgraf(Child.GrafAjuste, Child.RG3Ajuste, Child.PlanR);
////          end;
////          rgrafd: begin
////            if index <> 1 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            recupgraf(Child.GrafDistrib, Child.RG3Distrib, Child.PlanR);
////          end;
////          rgrafr: begin
////            if index <> 1 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            recupgraf(Child.GrafResid, Child.RG3Resid, Child.PlanR);
////          end;
////          rgraff: begin
////            if index < 2 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            case index of
////              2: begin
////                recupgraf(Childf.GrafFit, Childf.RG3Fit, Childf.PlanR);
////                recupgraf(Childf2.GrafFit, Childf2.RG3Fit, Childf2.PlanR);
////              end;
////              3: recupgraf(Childf2.GrafFit, Childf2.RG3Fit, Childf2.PlanR);
////              4: recupgrafM(Childf3.GrafFit, Childf3.RGMFit, Childf3.PlanR);
////            end;
////          end;
////          rgrafv: begin
////            if index <> 3 then raise Exception.Create('File error: Invalid component '+IntToStr(Ord(nr)));
////            recupgraf(Childf2.GrafVolume, Childf2.RG3Vol, Childf2.PlanR);
////          end;
////          recpland: begin
////            case index of
////              1: recupplan(Child.PlanD);
////              2: begin
////                recupplan(Childf.PlanD);
////                with Childf.PlanD do begin
////                 SelectRange(0, ColCount-1, 0, RowCount-1);
////                 CopyToClipboard;
////                end;
////                Childf2.PlanD.PasteFromClipboard;
////              end;
////              3: recupplan(Childf2.PlanD);
////              4: recupplan(Childf3.PlanD);
////            end;
////          end;
////          recplanc: begin
////            case index of
////              1: recupplan(Child.PlanC);
////              2: begin
////                recupplan(Childf.PlanC);
////                with Childf.PlanC do begin
////                 SelectRange(0, ColCount-1, 0, RowCount-1);
////                 CopyToClipboard;
////                end;
////                Childf2.PlanC.PasteFromClipboard;
////              end;
////              3: recupplan(Childf2.PlanC);
////            end;
////          end;
////          recplanr: begin
////            case index of
////              1: recupplan(Child.PlanR);
////              2: begin
////                recupplan(Childf.PlanR);
////                with Childf.PlanR do begin
////                 SelectRange(0, ColCount-1, 0, RowCount-1);
////                 CopyToClipboard;
////                end;
////                Childf2.PlanR.PasteFromClipboard;
////              end;
////              3: recupplan(Childf2.PlanR);
////              4: recupplan(Childf3.PlanR);
////            end;
////          end;
////          recplanv: begin
////            recupplan(Childf2.PlanVDef);
////          end;
////          routmemo: begin
////            if l > 0 then begin
////              mi.CopyFrom(f, l);
////              mi.Position := 0;
////              c1 := Inflate(mi, mc, ah);
////              if c1 <> c then raise Exception.Create('Error in CRC - '+IntToStr(Ord(nr)));
////              SetLength(st, mc.Size);
////              mc.Position := 0;
////              //mc.ReadBuffer(st[1], mc.Size);
////              Child.OutputMemo.Lines.LoadFromStream(mc);
////              mi.Clear;
////              mc.Clear;
////            end;
////          end;
////          recplanx: begin
////            f.ReadBuffer(kk, 4);
////            if kk > 0 then begin
////              inc(pindex);
////              recupplanx(kk);
////            end else
////              raise Exception.Create('Error reading spreadsheet, index: '+IntToStr(kk));
////          end;
////        end;
////        f.ReadBuffer(nr, 4);
////      end;
////      case index of
////        1: Child.ColCheckPres := Child.PlanD.GetCheckBoxState(0, 1, State);
////        2: begin
////           Childf.ColCheckPres := Childf.PlanD.GetCheckBoxState(0, 1, State);
////           Childf.competnica := Childf.CheckCompet.Checked;
////           Childf2.ColCheckPres := Childf2.PlanD.GetCheckBoxState(0, 1, State);
////           if Childf.competnica then
////             Childf2.NumberOfIonsBox.ItemIndex := Childf.NumCationes.ItemIndex + 1
////           else
////             Childf2.NumberOfIonsBox.ItemIndex := 0;
////           ni := Childf2.NumberOfIonsBox.ItemIndex + 1;
////           Childf2.competnica := Childf2.NumberOfIonsBox.ItemIndex > 0;
////           Childf2.NumberOfIonsBoxChange(MainForm);
////           Childf2.ngau := Childf2.Npicosbox.ItemIndex + 1;
////           nc := Childf2.EntNCurv.AsInteger;
////           for j := 1 to nc do
////             Childf2.npcurv[j] := Childf2.PlanCurves.Ints[1, j];
////        end;
////        3: with Childf2 do begin
////           ColCheckPres := PlanD.GetCheckBoxState(0, 1, State);
////           competnica := NumberOfIonsBox.ItemIndex > 0;
////           NumberOfIonsBoxChange(MainForm);
////           ngau := Npicosbox.ItemIndex + 1;
////           NICPeakComboChange(MainForm);
////           npnica := NICPeakCombo.ItemIndex + 2;
////           nc := EntNCurv.AsInteger;
////           for j := 1 to nc do
////             npcurv[j] := PlanCurves.Ints[1, j];
////           nion := NumberOfIonsBox.ItemIndex + 1;
////           ncurvas := EntNCurv.AsInteger;
////           indelectr := ElectroGroup.ItemIndex + 1;
////        end;
////        4: with Childf3 do begin
////            ColCheckPres := Childf3.PlanD.GetCheckBoxState(0, 1, State);
////            nc := EntNCurv.AsInteger;
////            for j := 1 to nc do
////              npcurv[j] := PlanCurves.Ints[1, j];
////            numcomp := Round(NumberOfIonsBox.Value);
////            ncurvas := EntNCurv.AsInteger;
////            numspec := NumberOfSpeciesBox.AsInteger;
////            indmodel := ModelGroup.ItemIndex + 1;
////            // SpeciesTabExit(MainForm);
////            if indmodel > 1 then j := indmodel - 1 else j := 1;
////            stoicols := numcomp + 1 + j;
////            numsurf := 0;
////            for i := 1 to numcomp do begin
////              surfcomp[i] := IsSpecial(ParseFormula(PlanGen.Cells[1, i + 1]));
////              if surfcomp[i] then
////                inc(numsurf);
////            end;
////            for i := 1 to nc do begin                       //count y's per curve
////              nyspcurv[i] := 0;
////              for k := 4 to PlanCurves.ColCount - 4 do begin
////                PlanCurves.GetCheckBoxState(k, i, State);
////                if State then inc(nyspcurv[i]);
////              end;
////              ncu := ncu + nyspcurv[i];
////              nystots[i] := ncu;
////            end;
////            CurvesTabEnter(MainForm);
////            ModelParamEnter(MainForm);
////            PlanD.Recalc;
////            PlanR.Recalc;
////        end;
////      end;
////      MRUList.Add(filename);
////
////    except
////      on exc: Exception do
////        MessageDlg('Project recovery failed! '+exc.Message, mtError, [mbOK], 0);
////    end;
////
////  finally
////    mi.Free;
////    mc.Free;
////    buf.Free;
////    f.Free;
////    FormProg.Hide;
////    case index of
////      1: begin
////        Child.PlanD.Tag := 0;
////        Child.PlanD.Modified := False;
////        Child.PlanC.Tag := 0;
////        Child.PlanC.Modified := False;
////        Child.PlanR.Tag := 0;
////        Child.PlanR.Modified := False;
////        Child.Invalidate;
////      end;
////      2: begin
////        if not Childf2.competnica then begin
////          Childf2.PlanGen.ComboIndex[4, 2] := Childf.ColTFit.ItemIndex + 1;
////          Childf2.PlanGen.ComboIndex[5, 2] := Childf.ColYFit.ItemIndex + 1;
////          Childf2.PlanGen.SetCheckBoxState(3, 2, True);
////          if Childf.pT.Checked then
////            Childf2.PlanGen.SetRadioIdx(2, 2, 0)
////          else
////            Childf2.PlanGen.SetRadioIdx(2, 2, 1);
////          Childf2.PlanGen.SetCheckBoxState(6, 2, Childf.InvSignBox.Checked);
////          Childf2.PlanGen.SetCheckBoxState(7, 2, Childf.CheckLogy.Checked);
////        end else begin   //main ion in old window is #2 in new window
////          colt := Childf.ColTFit.ItemIndex + 1;
////          Childf2.PlanGen.ComboIndex[4, 3] := colt;
////          col1 := Childf.ColYFit.ItemIndex + 1;
////          Childf2.PlanGen.ComboIndex[5, 3] := col1;
////          Childf2.PlanGen.Ints[1, 3] := Childf.ChargeMainIon.AsInteger;
////          Childf2.PlanGen.SetCheckBoxState(3, 3, True);
////          if Childf.pT.Checked then
////            Childf2.PlanGen.SetRadioIdx(2, 3, 0)
////          else
////            Childf2.PlanGen.SetRadioIdx(2, 3, 1);
////          Childf2.PlanGen.SetCheckBoxState(6, 3, Childf.InvSignBox.Checked);
////          Childf2.PlanGen.SetCheckBoxState(7, 3, Childf.CheckLogy.Checked);
////          // ion 2 in old window is H+
////          if Childf.ActivCompetGroup.ItemIndex = 0 then begin
////            Childf2.PlanGen.SetCheckBoxState(3, 2, False);
////            Childf2.PlanGen.Floats[4, 2] := Childf.EntCompetpX.AsFloat;
////            if ni > 2 then begin
////              Childf2.PlanGen.Floats[4, 4] := Childf.EntCompetpX2.AsFloat;
////              Childf2.PlanGen.SetCheckBoxState(3, 4, False);
////            end;
////          end else begin
////            Childf2.PlanGen.SetCheckBoxState(3, 2, True);
////            colh := Childf.ColX.ItemIndex + 1;
////            Childf2.PlanGen.ComboIndex[4, 2] := colh;
////            if ni > 2 then begin
////              Childf2.PlanGen.SetCheckBoxState(3, 4, True);
////              Childf2.PlanGen.ComboIndex[4, 4] := Childf.ColX2.ItemIndex + 1;
////            end;
////          end;
////          Childf2.PlanD.AddColumn;
////          col2 := Childf2.PlanD.ColCount-1;
////          Childf2.PlanGen.ComboIndex[5, 2] := col2;
////          Childf2.PlanGen.SetCheckBoxState(3, 2, True);
////          if Childf.pXActivGroup.ItemIndex = 0 then begin
////            Childf2.PlanGen.SetRadioIdx(2, 2, 0);
////            if ni > 2 then
////              Childf2.PlanGen.SetRadioIdx(2, 4, 0);
////          end else begin
////            Childf2.PlanGen.SetRadioIdx(2, 2, 1);
////            if ni > 2 then
////              Childf2.PlanGen.SetRadioIdx(2, 4, 1);
////          end;
////          Childf2.PlanGen.SetCheckBoxState(6, 2, False);
////          Childf2.PlanGen.SetCheckBoxState(7, 2, False);
////          if ni > 2 then begin
////            Childf2.PlanGen.SetCheckBoxState(6, 4, False);
////            Childf2.PlanGen.SetCheckBoxState(7, 4, False);
////          end;
////          j := 1;
////          for i := 1 to nc do begin
////            if Childf2.PlanD.Floats[colh, j] = 0 then begin    //H+ binding curve
////              for k := 0 to Childf2.PlanCurves.Ints[1, i] - 1 do begin
////                Childf2.PlanD.Cells[col2, k+j] := Childf2.PlanD.Cells[col1, k+j];
////                Childf2.PlanD.Cells[col1, k+j] := '';
////                Childf2.PlanD.Cells[colh, k+j] := Childf2.PlanD.Cells[colt, k+j];
////                Childf2.PlanD.Cells[colt, k+j] := '';
////                if Childf.pT.Checked and (Childf.pXActivGroup.ItemIndex = 1) then
////                  Childf2.PlanD.Floats[colh, k+j] := Power(10, -Childf2.PlanD.Floats[colh, k+j]);
////                if not Childf.pT.Checked and (Childf.pXActivGroup.ItemIndex = 0) then
////                  Childf2.PlanD.Floats[colh, k+j] := -Log10(Childf2.PlanD.Floats[colh, k+j]);
////              end;
////              Childf2.PlanCurves.ComboIndex[5, i] := 0;
////              Childf2.PlanCurves.SetCheckBoxState(6, i,True);
////            end else begin
////              Childf2.PlanCurves.ComboIndex[5, i] := 1;
////            end;
////            j := j + Childf2.npcurv[i]
////          end;
////          if not Childf2.competnica then begin
////
////          end else begin
////            Childf2.Entq1nic.AsFloat := Childf.Entq1.AsFloat;
////            Childf2.Entmh1.AsFloat := Childf.Entnh1.AsFloat;
////            Childf2.Entmh2.AsFloat := Childf.Entnh2.AsFloat;
////            Childf2.PlanResults.Floats[7,2] := Childf.SalQ1.AsFloat;
////            Childf2.PlanResults.Floats[7,4] := Childf.SalQ2.AsFloat;
////            Childf2.PlanResults.Floats[7,3] := Childf.SalQ3.AsFloat;
////            Childf2.PlanResults.Floats[7,5] := Childf.SalQ4.AsFloat;
////            Childf2.PlanResults.Floats[7,6] := Childf.SalLogKc1.AsFloat;
////            Childf2.PlanResults.Floats[7,8] := Childf.SalLogKc2.AsFloat;
////            Childf2.PlanResults.Floats[7,7] := Childf.Salw1.AsFloat;
////            Childf2.PlanResults.Floats[7,9] := Childf.Salw2.AsFloat;
////            Childf2.PlanResults.Floats[7,10] := Childf.SalLogKc3.AsFloat;
////            Childf2.PlanResults.Floats[7,12] := Childf.SalLogKc4.AsFloat;
////            Childf2.PlanResults.Floats[7,11] := Childf.Salw3.AsFloat;
////            Childf2.PlanResults.Floats[7,13] := Childf.Salw4.AsFloat;
////            if ni > 2 then begin
////              Childf2.PlanResults.Floats[7,14] := Childf.SalLogKM21.AsFloat;
////              Childf2.PlanResults.Floats[7,16] := Childf.SalLogKM22.AsFloat;
//// //             Childf2.SalnM11.AsFloat := Childf.Salw3.AsFloat;
//// //             Childf2.SalnM12.AsFloat := Childf.Salw4.AsFloat;
////            end;
////          end;
////        end;
////        Childf2.PlanD.Tag := 0;
////        Childf2.PlanD.Modified := False;
////        Childf2.PlanC.Tag := 0;
////        Childf2.PlanC.Modified := False;
////        Childf2.PlanR.Tag := 0;
////        Childf2.PlanR.Modified := False;
////        case Childf2.indelectr of
////         1: begin
////            Childf2.FiteoElectro.Visible := True;
////            Childf2.FiteoElectro.TabVisible := True;
////            Childf2.FiteoElectro.PageIndex := 2;
////            Childf2.FitDonnan.Visible := False;
////            Childf2.FitDonnan.TabVisible := False;
////         end;
////         2: begin
////            Childf2.FiteoElectro.Visible := False;
////            Childf2.FiteoElectro.TabVisible := False;
////            Childf2.FitDonnan.PageIndex := 3;
////            Childf2.FitDonnan.Visible := True;
////            Childf2.FitDonnan.TabVisible := True;
////         end;
////       end;
////       Childf2.Parametros.ActivePageIndex := 1;
////       Childf2.Visible := True;
////       Childf2.Parametros.ActivePageIndex := 0;
////        Childf.Free;
////      end;
////      3: begin
////       Childf2.PlanD.Tag := 0;
////       Childf2.PlanD.Modified := False;
////       Childf2.PlanC.Tag := 0;
////       Childf2.PlanC.Modified := False;
////       Childf2.PlanR.Tag := 0;
////       Childf2.PlanR.Modified := False;
////       case Childf2.indelectr of
////         1: begin
////            Childf2.FiteoElectro.Visible := True;
////            Childf2.FiteoElectro.TabVisible := True;
////            Childf2.FiteoElectro.PageIndex := 2;
////            Childf2.FitDonnan.Visible := False;
////            Childf2.FitDonnan.TabVisible := False;
////         end;
////         2: begin
////            Childf2.FiteoElectro.Visible := False;
////            Childf2.FiteoElectro.TabVisible := False;
////            Childf2.FitDonnan.Visible := True;
////            Childf2.FitDonnan.TabVisible := True;
////            Childf2.FitDonnan.PageIndex := 3;
////         end;
////       end;
//////       SendMessage(hand, WM_SETREDRAW, WPARAM(True), 0);
////       Childf2.Parametros.ActivePageIndex := 1;
////       Childf2.Visible := True;
////       Childf2.Parametros.ActivePageIndex := 0;
////      end;
////      4: begin
////       Childf3.PlanD.Tag := 0;
////       Childf3.PlanD.Modified := False;
////       Childf3.PlanR.Tag := 0;
////       Childf3.PlanR.Modified := False;
////       Childf3.Parametros.ActivePageIndex := 1;
////       Childf3.Visible := True;
////       Childf3.Parametros.ActivePageIndex := 0;
////      end;
////    end;
////    Application.ProcessMessages;
////  end;
//  FormatSettings.DecimalSeparator := decsep;
//end;
//
//procedure TMainForm.RecuperarEstado3(f: TFileStream);
//
////var
////  i, c, n: integer;
////  nr: Trecbind;
////  fn1, fn3: string;
////  buf: TStringList;
////  m: TMemoryStream;
////  z: TJclZlibDeCompressStream;
////  l: int64;
////  Tabla: TAdvSpreadGrid;
////  Graf: TRChart;
////  st: string;
////  Child: TContinInt;
////  State: boolean;
////  grafr0: TRecGraf03;
////  grafr1: TRecGraf3;
////
//begin
////  try
////    try
////      c := Self.ComponentCount + 12;
////      m := TmemoryStream.Create;
////{
////        f := TmemoryStream.Create;
////        z := TJclZlibDeCompressStream.Create(m);
////        m.CopyFrom(f1, f1.Size-8);
////        f.CopyFrom(z, z.Size);
////
////}
////      buf := TStringList.Create;
////      FormProg.Prog.Maximum := c;
////      FormProg.Prog.Minimum := 0;
////      FormProg.Prog.Position := 0;
////      FormProg.Labl.Caption := 'Recovering project ...';
////      FormProg.Show;
////      fn1 := dirprogr+'\temp1$$$.INI';
////      fn3 := dirprogr+'\temp3$$$.tmp';
////
////      f.ReadBuffer(n, 4);
////      if Trecbind(n) = recform1 then
////        Child := TContinInt.Create(Application)
////      else raise Exception.Create('File error: recform!');
////      f.ReadBuffer(l, 8);
////      m.CopyFrom(f, l);
////      m.Position := 0;
////      buf.LoadFromStream(m);
////      buf.SaveToFile(fn1);
////      m.Clear;
////      Child.SaveComps1.Active := True;
////      Child.SaveComps1.IniFileName := fn1;
////      Child.SaveComps1.LoadComponentsProps;
////      Child.SaveComps1.Active := False;
////
////      f.ReadBuffer(nr, 4);
////      while nr <> recend do begin
////        f.ReadBuffer(l, 8);
////        case nr of
////          recgrafa, recgrafd, recgrafr, recgraff: begin
////            if l <> SizeOf(TRecGraf3) then begin
////              if l <> SizeOf(TRecGraf03) then
////                raise Exception.Create('File error: l-recgraf!');
////              f.ReadBuffer(grafr0, l);       // old record format
////              grafr1.Graf := grafr0.Graf;
////              grafr1.Planilla := grafr0.Planilla;
////              grafr1.grafpres := grafr0.grafpres;
////              grafr1.Params.numcurv := grafr0.Params.numcurv;
////              grafr1.Params.titugraf := grafr0.Params.titugraf;
////              grafr1.Params.titux := grafr0.Params.titux;
////              grafr1.Params.tituy1 := grafr0.Params.tituy1;
////              grafr1.Params.tituy2 := grafr0.Params.tituy2;
////              grafr1.Params.ejedoble := grafr0.Params.ejedoble;
////              grafr1.Params.escautomx := grafr0.Params.escautomx;
////              grafr1.Params.escautomy1 := grafr0.Params.escautomy1;
////              grafr1.Params.escautomy2 := grafr0.Params.escautomy2;
////              grafr1.Params.elogx := grafr0.Params.elogx;
////              grafr1.Params.elogy1 := grafr0.Params.elogy1;
////              grafr1.Params.elogy2 := grafr0.Params.elogy2;
////              grafr1.Params.exmin := grafr0.Params.exmin;
////              grafr1.Params.exmax := grafr0.Params.exmax;
////              grafr1.Params.ey1min := grafr0.Params.ey1min;
////              grafr1.Params.ey2min := grafr0.Params.ey2min;
////              grafr1.Params.ey1max := grafr0.Params.ey1max;
////              grafr1.Params.ey2max := grafr0.Params.ey2max;
////              for i := 1 to 16 do
////                grafr1.Params.CurvParams[i] := grafr0.Params.CurvParams[i];
////              case nr of
////                recgrafa: Child.RG3Ajuste := grafr1;
////                recgrafr: Child.RG3Resid := grafr1;
////                recgrafd: Child.RG3Distrib := grafr1;
////                recgraff: Child.RG3Fit := grafr1;
////              end;
////            end else
////              case nr of
////                recgrafa: f.ReadBuffer(Child.RG3Ajuste, l);
////                recgrafr: f.ReadBuffer(Child.RG3Resid, l);
////                recgrafd: f.ReadBuffer(Child.RG3Distrib, l);
////                recgraff: f.ReadBuffer(Child.RG3Fit, l);
////              end;
////          end;
////          recpland: if l>0 then begin
////              m.CopyFrom(f, l);
////              m.Position := 0;
////              Child.PlanD.LoadFromBinStream(m);
////              Child.PlanD.Recalc;
////            end else Child.PlanD.Clear;
////          recplanc:  if l>0 then begin
////              m.CopyFrom(f, l);
////              m.Position := 0;
////              Child.PlanC.LoadFromBinStream(m);
////              Child.PlanC.Recalc;
////        end else Child.PlanC.Clear;
////          recplanr:  if l>0 then begin
////              m.CopyFrom(f, l);
////              m.Position := 0;
////              Child.PlanR.LoadFromBinStream(m);
////              Child.PlanR.Recalc;
////            end else Child.PlanR.Clear;
////          rgrafa: if l > 0 then begin
////            m.CopyFrom(f, l);
////            m.Position := 0;
////            m.SaveToFile(fn3);
////            Child.GrafAjuste.LoadData(fn3, False);
////            Child.RG3Ajuste.Graf := Child.GrafAjuste;
////            Child.RG3Ajuste.Planilla := Child.PlanR;
////            if Child.RG3Ajuste.grafpres then
////              RehacerGraf(Child.RG3Ajuste);
////          end;
////          rgrafd: if l > 0 then begin
////            m.CopyFrom(f, l);
////            m.Position := 0;
////            m.SaveToFile(fn3);
////            Child.GrafDistrib.LoadData(fn3, False);
////            Child.RG3Distrib.Graf := Child.GrafDistrib;
////            Child.RG3Distrib.Planilla := Child.PlanR;
////            if Child.RG3Distrib.grafpres then
////              RehacerGraf(Child.RG3Distrib);
////          end;
////          rgrafr: if l > 0 then begin
////            m.CopyFrom(f, l);
////            m.Position := 0;
////            m.SaveToFile(fn3);
////            Child.GrafResid.LoadData(fn3, False);
////            Child.RG3Resid.Graf := Child.GrafResid;
////            Child.RG3Resid.Planilla := Child.PlanR;
////            if Child.RG3Resid.grafpres then
////              RehacerGraf(Child.RG3Resid);
////          end;
////          rgraff: if l > 0 then begin
////            m.CopyFrom(f, l);
////            m.Position := 0;
////            m.SaveToFile(fn3);
////            Child.GrafFit.LoadData(fn3, False);
////            Child.RG3Fit.Graf := Child.GrafFit;
////            Child.RG3Fit.Planilla := Child.PlanR;
////            if Child.RG3Fit.grafpres then
////              RehacerGraf(Child.RG3Fit);
////          end;
////          routmemo: if l > 0 then begin
////            SetLength(st, l);
////            f.ReadBuffer(st[1], l);
////            Child.OutputMemo.Lines.Text := st;
////          end;
////        end;
////        FormProg.Prog.Position := FormProg.Prog.Position + 1;
////        m.Clear;
////        DeleteFile(fn3);
////        f.ReadBuffer(nr, 4);
////      end;
////      Child.FitGen.PageIndex := 10;
////      Child.ColCheckPres := Child.PlanD.GetCheckBoxState(0, 1, State);
////      if Child.CONTIN1.Checked then Child.CONTIN1Click(Child);
////      if Child.FIT1.Checked then Child.FIT1Click(Child);
////    except
////      on exc: Exception do begin
////        MessageDlg('Project recovery failed! '+exc.Message, mtError, [mbOK], 0);
////      end;
////    end;
////  finally
////    f.Free;
//////    f1.Free;
//////    z.Free;
////    m.Free;
////    buf.Free;
////    DeleteFile(fn1);
////    DeleteFile(fn3);
////    FormProg.Hide;
////    Child.PlanD.Tag := 0;
////    Child.PlanD.Modified := False;
////    Child.PlanC.Tag := 0;
////    Child.PlanC.Modified := False;
////    Child.PlanR.Tag := 0;
////    Child.PlanR.Modified := False;
////    Child.Invalidate;
////    Application.ProcessMessages;
////  end;
//end;

procedure TMainForm.SaveOutMemo;
begin
  if ActiveMDIChild is TFormInterf then begin
    if SaveOutMemoDlg.Execute then
      TFormInterf(ActiveMDIChild).OutPutMemo.Lines.SaveToFile(SaveOutMemoDlg.FileName);
  end;
end;

procedure TMainForm.SalvaProyecto(FileName: string);
var
  i, c, n, k: integer;
  dir1, fnt, fnp: string;
  buf: TStringList;
  b: buf8;
  mi, mc: TMemoryStream;
  f: TFileStream;
  ah: TAbDeflateHelper;
  l: int64;
  Tabla: TsWorksheetGrid;
  Graf: TChart;
  Child: TFormInterf;
  st: string;
  decsep: char;
  SaveComps: TSaveComps;


    procedure copymc(itag: TRecbind);
    begin
      f.WriteBuffer(itag, 4);
      mi.Position := 0;
      c := Deflate(mi, mc, ah);
      l := mc.Size;
      f.WriteBuffer(l, 8);
      f.WriteBuffer(c, 4);
      if l > 0 then
        f.CopyFrom(mc, 0);
      mc.Clear;
      mi.Clear;
      FormProg.Prog.Position := FormProg.Prog.Position + 1;
    end;
  //
    procedure copymcx(itag: TRecbind; ind: integer);
    begin
      f.WriteBuffer(itag, 4);
      mi.Position := 0;
      c := Deflate(mi, mc, ah);
      l := mc.Size;
      f.WriteBuffer(l, 8);
      f.WriteBuffer(c, 4);
      f.WriteBuffer(ind, 4);
      if l > 0 then
        f.CopyFrom(mc, 0);
      mc.Clear;
      mi.Clear;
      FormProg.Prog.Position := FormProg.Prog.Position + 1;
    end;
  //
    procedure salvarg(rg: TRecGrafNEW; itag: TRecbind);
    begin
      mi.WriteBuffer(rg, SizeOf(TRecGrafNEW));
      copymc(itag);
    end;
  //
  //procedure salvagrid(Tabla: TAdvSpreadGrid; itag: TRecbind);
  //begin
  //  Tabla.SaveToBinStream(mi);
  //  copymc(itag);
  //end;
  //
  procedure salvagridx(Tabla: TsWorksheetGrid; itag: TRecbind; ind: integer);
  begin
    Tabla.SaveToStream(mi);
    copymcx(itag, ind);
  end;
  //
  //procedure salvagraf(Graf: TRChart; itag: TRecbind);
  //begin
  //  Graf.SaveData(fnt);
  //  mi.LoadFromFile(fnt);
  //  copymc(itag);
  //  DeleteFile(fnt);
  //end;


begin
  Child := TFormInterf(ActiveMDIChild);
  plancount := 0;
  for k := 1 to maxplan do begin
    plansnames[k] := '';
    plansindex[k] := 0;
  end;
  ah := TAbDeflateHelper.Create;
  ah.Options := ah.Options or $10;
  decsep := FormatSettings.DecimalSeparator;
  FormatSettings.DecimalSeparator := '.';
  try
    SaveComps := TSaveComps.Create(Child);
    with SaveComps.SavedProperties do begin
      Add('Text');
      Add('Caption');
      Add('ItemIndex');
      Add('PageIndex');
      Add('Checked');
      Add('Down');
      Add('Lines');
      Add('Value');
      SaveComps.OnSToreComponentEvent:= SaveCompsStoreComponentEvent;
    end;
    try
      i := 0;
      fnp := dirtemp+'\temp$$$'+IntToStr(procid);
      fnt := fnp+'.tmp';
      while FileExists(fnt) do begin
        inc(i);
        fnt := fnp+'-'+IntToStr(i)+'.tmp';
      end;
      buf := TStringList.Create;
      f := TFileStream.Create(FileName, fmOpenWrite or fmCreate);
      c := Child.ComponentCount + 12;
      case Child.childmode of
        contin: begin
          b := mbdco;
          n := Ord(recform2);
        end;
        fithum: begin
          b := mbdfh;
          n := Ord(recform3);
        end;
        fitox: begin
          b := mbdfo;
          n := Ord(recform4);
        end;
      end;
      mi := TmemoryStream.Create;
      mc := TmemoryStream.Create;
      FormProg.Prog.Max := c;
      FormProg.Prog.Min := 0;
      FormProg.Prog.Position := 0;
      FormProg.Labl.Caption := 'Saving project ...';
      FormProg.Show;

      f.WriteBuffer(b, 8);

      SaveComps.Active := True;
      SaveComps.IniFileName := fnt;
      SaveComps.SaveComponentsProps;
      SaveComps.Active := False;
      buf.LoadFromFile(fnt);
      buf.SaveToStream(mi);
      mi.Position := 0;
      c := Deflate(mi, mc, ah);
      l := mc.Size;
      f.WriteBuffer(n, 4);
      f.WriteBuffer(l, 8);
      f.WriteBuffer(c, 4);
      f.CopyFrom(mc, 0);
      mc.Clear;
      mi.Clear;
      DeleteFile(fnt);

      //save spreadsheets, list compiled when saving components above
      for i := 1 to plancount do
        salvagridx(TsWorksheetGrid(Child.Components[plansindex[i]]), recplanx, plansindex[i]);

      //save graphics data
      salvarg(Child.DefGrafFit, recgrafa);
      salvarg(Child.DefGrafDist, recgrafd);
      salvarg(Child.DefGrafRes, recgrafr);

      case Child.childmode of
        contin: begin
        end;
        fithum: begin
          salvarg(Child.DefGrafVol, recgrafv);
        end;
        fitox: begin

        end;
      end;

      n := Ord(recend);
      f.WriteBuffer(n, 4);
      Child.PlanD.Tag := 0;
      Child.PlanC.Tag := 0;
      Child.PlanR.Tag := 0;
      MRUList.Add(FileName, 0);

//
  //try
  //  try
  //      case index of
  //        1: begin
  //          c := Child.ComponentCount + 12;
  //          b := marbc;
  //        end;
  //        2: begin
  //          c := Childf.ComponentCount + 12;
  //          b := marbf;
  //        end;
  //        3: begin
  //          c := Childf2.ComponentCount + 12;
  //          b := marf2;
  //        end;
  //        4: begin
  //          c := Childf3.ComponentCount + 12;
  //          b := marf3;
  //        end;
  //      end;
  //      mi := TmemoryStream.Create;
  //      mc := TmemoryStream.Create;
  //      FormProg.Prog.Maximum := c;
  //      FormProg.Prog.Minimum := 0;
  //      FormProg.Prog.Position := 0;
  //      FormProg.Labl.Caption := 'Saving project ...';
  //      FormProg.Show;
  //
  //      f.WriteBuffer(b, 8);
  //
  //      case index of
  //        1: begin
  //            Child.SaveComps1.Active := True;
  //            Child.SaveComps1.IniFileName := fnt;
  //            Child.SaveComps1.SaveComponentsProps;
  //            Child.SaveComps1.Active := False;
  //            n := Ord(recform2);
  //        end;
  //        2: begin
  //            Childf.SaveComps1.Active := True;
  //            Childf.SaveComps1.IniFileName := fnt;
  //            Childf.SaveComps1.SaveComponentsProps;
  //            Childf.SaveComps1.Active := False;
  //            n := Ord(recform3);
  //        end;
  //        3: begin
  //            Childf2.SaveComps1.Active := True;
  //            Childf2.SaveComps1.IniFileName := fnt;
  //            Childf2.SaveComps1.SaveComponentsProps;
  //            Childf2.SaveComps1.Active := False;
  //            n := Ord(recform3);
  //        end;
  //        4: with Childf3 do begin
  //            SaveComps1.Active := True;
  //            SaveComps1.IniFileName := fnt;
  //            SaveComps1.SaveComponentsProps;
  //            SaveComps1.Active := False;
  //            n := Ord(recform3);
  //        end;
  //      end;
  //      buf.LoadFromFile(fnt);
  //      buf.SaveToStream(mi);
  //      mi.Position := 0;
  //      c := Deflate(mi, mc, ah);
  //      l := mc.Size;
  //      f.WriteBuffer(n, 4);
  //      f.WriteBuffer(l, 8);
  //      f.WriteBuffer(c, 4);
  //      f.CopyFrom(mc, 0);
  //      mc.Clear;
  //      mi.Clear;
  //      DeleteFile(fnt);
  //
  //      case index of
  //        1: begin
  //            salvarg(Child.RG3Ajuste, recgrafa);
  //            salvarg(Child.RG3Distrib, recgrafd);
  //            salvarg(Child.RG3Resid, recgrafr);
  //
  //            salvagrid(Child.PlanD, recpland);
  //            salvagrid(Child.PlanC, recplanc);
  //            salvagrid(Child.PlanR, recplanr);
  //
  //            salvagraf(Child.GrafAjuste, rgrafa);
  //            salvagraf(Child.GrafDistrib, rgrafd);
  //            salvagraf(Child.GrafResid, rgrafr);
  //
  //            n := Ord(routmemo);
  //            f.WriteBuffer(n, 4);
  //            Child.OutPutMemo.Lines.SaveToStream(mi);
  //            mi.Position := 0;
  //            c := Deflate(mi, mc, ah);
  //            l := mc.Size;
  //            f.WriteBuffer(l, 8);
  //            f.WriteBuffer(c, 4);
  //            f.CopyFrom(mc, 0);
  //        end;
  //
  //        2: begin
  //            salvarg(Childf.RG3Fit, recgraff);
  //
  //            salvagrid(Childf.PlanD, recpland);
  //            salvagrid(Childf.PlanC, recplanc);
  //            salvagrid(Childf.PlanR, recplanr);
  //
  //            salvagraf(Childf.GrafFit, rgraff);
  //        end;
  //
  //        3: begin
  //            salvarg(Childf2.RG3Fit, recgraff);
  //            for i := 1 to plancount do
  //              salvagridx(TAdvSpreadGrid(Childf2.Components[plansindex[i]]),recplanx, plansindex[i]);
  //            salvagraf(Childf2.GrafFit, rgraff);
  //            salvarg(Childf2.RG3Vol, recgrafv);
  //            salvagraf(Childf2.GrafVolume, rgrafv);
  //        end;
  //
  //
  //        4: begin
  ////            salvarg(Childf3.RGMFit, recgraff);
  //            for i := 1 to plancount do
  //              salvagridx(TAdvSpreadGrid(Childf3.Components[plansindex[i]]),recplanx, plansindex[i]);
  //            salvagraf(Childf3.GrafFit, rgraff);
  //        end;
  //      end;
  //
  //      n := Ord(recend);
  //      f.WriteBuffer(n, 4);
  //
  //      case index of
  //        1: begin
  //          Child.PlanD.Tag := 0;
  //          Child.PlanC.Tag := 0;
  //          Child.PlanR.Tag := 0;
  //        end;
  //        2: begin
  //          Childf.PlanD.Tag := 0;
  //          Childf.PlanC.Tag := 0;
  //          Childf.PlanR.Tag := 0;
  //        end;
  //        3: begin
  //          Childf2.PlanD.Tag := 0;
  //          Childf2.PlanC.Tag := 0;
  //          Childf2.PlanR.Tag := 0;
  //        end;
  //        4: begin
  //          Childf3.PlanD.Tag := 0;
  //          Childf3.PlanR.Tag := 0;
  //        end;
  //      end;
  //      MRUList.Add(FileName);
  //
    except
        on exc: Exception do
            MessageDlg('Project save failed! '+exc.Message, mtError, [mbOK], 0)
    end;
    Child.Caption := Child.Caption + ' ' + FileName;
  finally
    SaveComps.Free;
    f.Free;
    mi.Free;
    mc.Free;
    buf.Free;
    FormProg.Hide;
    ah.Free;
    FormatSettings.DecimalSeparator := decsep;
    Application.ProcessMessages;
  end;
end;

procedure TMainForm.Salvardistribucin1Click(Sender: TObject);
begin
  if ActiveMDIChild is TFormInterf then
    Exportar(TFormInterf(ActiveMDIChild).PlanC, 'distribution');
end;


procedure TMainForm.Savedefinition1Click(Sender: TObject);
begin
  //if ActiveMDIChild is TFitInterf3 then
  //  TFitInterf3(ActiveMDIChild).SalvarDefinicion(Sender);
end;

procedure TMainForm.Vistapreliminar1Click(Sender: TObject);
begin
  //if ActiveMDIChild is TContinInt then
  //  with TContinInt(ActiveMDIChild) do begin
  //    PreviewDialog.Grid := PlanAct;
  //    PreviewDialog.Execute;
  //  end;
  //if ActiveMDIChild is TContinInterf then
  //  with TContinInterf(ActiveMDIChild) do begin
  //    PreviewDialog.Grid := PlanAct;
  //    PreviewDialog.Execute;
  //  end;
  //if ActiveMDIChild is TFitInterf then
  //  with TFitInterf(ActiveMDIChild) do begin
  //    PreviewDialog.Grid := PlanAct;
  //    PreviewDialog.Execute;
  //  end;
  //if ActiveMDIChild is TFitInterf2 then
  //  with TFitInterf2(ActiveMDIChild) do begin
  //    PreviewDialog.Grid := PlanAct;
  //    PreviewDialog.Execute;
  //  end;
  //if ActiveMDIChild is TFitInterf3 then
  //  with TFitInterf3(ActiveMDIChild) do begin
  //    PreviewDialog.Grid := PlanAct;
  //    PreviewDialog.Execute;
  //  end;
end;

procedure TMainForm.SaveCompsLoadComponentEvent(Sender: TObject;
  ComponentName: string; Count, Index: Integer; var Continue: Boolean);
begin
  if startingprog then
    exit;
//  Memo1.Lines.Add(ComponentName+'  '+IntToStr(Count)+'  '+IntToStr(Index));
  if Pos('Plan', ComponentName) > 0 then begin
    inc(plancount);
    plansnames[plancount] := ComponentName;
    plansindex[plancount] := Index;
  end;
  Continue := not(ComponentName = 'OutPutMemo') and (Pos('Label', ComponentName) = 0);
  FormProg.Prog.Position := FormProg.Prog.Position + 1;
  Application.ProcessMessages;
end;


procedure TMainForm.SaveCompsStoreComponentEvent(Sender: TObject;
  ComponentName: string; Count, Index: Integer; var Continue: Boolean);
begin
  if startingprog then
    exit;
//  Memo1.Lines.Add(ComponentName+'  '+IntToStr(Count)+'  '+IntToStr(Index));
  if Pos('Plan', ComponentName) > 0 then begin
    inc(plancount);
    plansnames[plancount] := ComponentName;
    plansindex[plancount] := Index;
  end;
  Continue := (Pos('OutPutMemo', ComponentName) = 0) and
    ((Pos('Label', ComponentName) = 0));
  FormProg.Prog.Position := FormProg.Prog.Position + 1;
  Application.ProcessMessages;
end;




end.
