unit unitinterf;

{$MODE Delphi}

interface

uses LCLIntf, LCLType, LMessages, Classes, Graphics, Forms, Controls, StdCtrls,
  Math, ComCtrls, ExtCtrls, Spin, Buttons, Menus, ActnList, StdActns, Process,
  SysUtils, DateUtils, Windows, fpspreadsheetgrid, fpspreadsheetctrls,
  fpsSearch, kedits, kgrids, TAGraph, TATransformations, TATools, TADataTools,
  ualtoancho, fpstypes, fpsutils, SynEdit, SynEditSearch, SynEditTypes,
  SynGutter, SynGutterBase, SynGutterChanges, SynGutterCodeFolding,
  SynGutterLineNumber, SynGutterMarks, ugrafdefs, fpspreadsheet, unitdefin,
  umemo1, umemo2, Dialogs, Grids, JvHtControls, rxctrls, Types, strutils,
  uformgrdetails;

type
  Tpmode = (none, contin, fithum, fitox);

type

  { TFormInterf }

  TFormInterf = class(TForm)
    ActionList1: TActionList;
    Agregarabajo1: TMenuItem;
    Agregaraladerecha1: TMenuItem;
    AgregarColumna1: TMenuItem;
    AgregarFila1: TMenuItem;
    Altura1: TMenuItem;
    Ampliar1: TMenuItem;
    Ancho1: TMenuItem;
    Autoajustar1: TMenuItem;
    Autoescala1: TMenuItem;
    Borrar1: TMenuItem;
    Borrarcolumnas1: TMenuItem;
    BorrarFilas1: TMenuItem;
    Buscar1: TMenuItem;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    FNext: TMenuItem;
    DistDistance: TDataPointDistanceTool;
    DistHint: TDataPointHintTool;
    DistCrosshair: TDataPointCrosshairTool;
    FitHint: TDataPointHintTool;
    FitCrosshair: TDataPointCrosshairTool;
    FitDistance: TDataPointDistanceTool;
    DistAxisLog: TLogarithmAxisTransform;
    DistPointClick: TDataPointClickTool;
    DistPan: TPanDragTool;
    DistZoomClick: TZoomClickTool;
    DistZoomDrag: TZoomDragTool;
    FitXAxisTransfLog: TLogarithmAxisTransform;
    FitYAxisTransfLog: TLogarithmAxisTransform;
    FitPointClick: TDataPointClickTool;
    FitPan: TPanDragTool;
    FitZoomClick: TZoomClickTool;
    FitZoomDrag: TZoomDragTool;
    ResHint: TDataPointHintTool;
    ResCrosshair: TDataPointCrosshairTool;
    ResDistance: TDataPointDistanceTool;
    VolHint: TDataPointHintTool;
    VolCrosshair: TDataPointCrosshairTool;
    VolDistance: TDataPointDistanceTool;
    VolXAxisTransfLog: TLogarithmAxisTransform;
    VolPan: TPanDragTool;
    VolPointClick: TDataPointClickTool;
    ResXAxisTransfLog: TLogarithmAxisTransform;
    CheckConste: TCheckBox;
    CheckDerivInf: TCheckBox;
    CheckDerivSup: TCheckBox;
    CheckEq1: TCheckBox;
    CheckIneq: TCheckBox;
    CheckLimInf: TCheckBox;
    CheckLimSup: TCheckBox;
    CheckTemp: TCheckBox;
    ColS: TComboBox;
    Control: TTabSheet;
    Copiargrfico1: TMenuItem;
    EntDerivInf: TKNumberEdit;
    EntDerivSup: TKNumberEdit;
    EntInteg: TKNumberEdit;
    EntLimInf: TKNumberEdit;
    EntLimSup: TKNumberEdit;
    Escalas1: TMenuItem;
    FindDialog: TFindDialog;
    FindDialog1: TFindDialog;
    GrabarcomoBMP1: TMenuItem;
    Color1: TMenuItem;
    Columnas1: TMenuItem;
    Columnas2: TMenuItem;
    Columnas3: TMenuItem;
    Coma1: TMenuItem;
    Copiar1: TMenuItem;
    CopyItem: TMenuItem;
    Correr2: TMenuItem;
    CorrerCONTIN1: TMenuItem;
    Cortar1: TMenuItem;
    CutItem: TMenuItem;
    Deshacer1: TMenuItem;
    Edit1: TMenuItem;
    EditCopy1: TEditCopy;
    EditCut1: TEditCut;
    EditPaste1: TEditPaste;
    Eliminarceldas1: TMenuItem;
    Filas1: TMenuItem;
    Filas2: TMenuItem;
    Filas3: TMenuItem;
    FileExit1: TAction;
    FileNew1: TAction;
    FileOpen1: TAction;
    FileSave1: TAction;
    FileSaveAs1: TAction;
    Fuente1: TMenuItem;
    Generardistribucin1: TMenuItem;
    GraficarDatos1: TMenuItem;
    GraficarDistribucion1: TMenuItem;
    GraficarResultados1: TMenuItem;
    Copiar2: TMenuItem;
    Imprimir2: TMenuItem;
    Grabar1: TMenuItem;
    EnableMark: TMenuItem;
    Desmarcar1: TMenuItem;
    Marcar1: TMenuItem;
    OutputBuscar: TMenuItem;
    ReplaceDialog1: TReplaceDialog;
    ResPointClick: TDataPointClickTool;
    ResPan: TPanDragTool;
    ResZoomClick: TZoomClickTool;
    VolYAxisTransfLog: TLogarithmAxisTransform;
    VolZoomClick: TZoomClickTool;
    ResZoomDrag: TZoomDragTool;
    VolZoomDrag: TZoomDragTool;
    Se1: TMenuItem;
    HelpAbout1: TAction;
    Insertarcolumnas1: TMenuItem;
    Insertardatos1: TMenuItem;
    Insertarenposicin1: TMenuItem;
    InsertarFilas1: TMenuItem;
    Label42: TLabel;
    Label6: TLabel;
    Limpiar1: TMenuItem;
    Llenar1: TMenuItem;
    Localizarpunto1: TMenuItem;
    MainMenu1: TMainMenu;
    MarcasColores1: TMenuItem;
    MenuItem1: TMenuItem;
    ModoNormal1: TMenuItem;
    ModoPan: TMenuItem;
    ModoZoomDrag: TMenuItem;
    ModoZoomPoint: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    NonNegChk: TCheckBox;
    Normalizardistr1: TMenuItem;
    Ordenar1: TMenuItem;
    Parametros: TPageControl;
    Parar2: TMenuItem;
    PasteItem: TMenuItem;
    Pegar1: TMenuItem;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    PopupMenu3: TPopupMenu;
    Procesar1: TMenuItem;
    Punto1: TMenuItem;
    Regraficar1: TMenuItem;
    SimuBind: TCheckBox;
    Timer1: TTimer;
    TitEdit: TEdit;
    TraeralaIzquierda1: TMenuItem;
    TraerhaciaArriba1: TMenuItem;
    Recalcular: TMenuItem;
    Reemplazar1: TMenuItem;
    Rehacer1: TMenuItem;
    Seleccin1: TMenuItem;
    Seleccin2: TMenuItem;
    Separadordecimal1: TMenuItem;
    Hojas: TPageControl;
    Splitter1: TSplitter;
    StatusBar: TStatusBar;
    PlDatos: TTabSheet;
    PlDistr: TTabSheet;
    PlResult: TTabSheet;
    PlanD: TsWorksheetGrid;
    PlanC: TsWorksheetGrid;
    PlanR: TsWorksheetGrid;
    Todo1: TMenuItem;
    Todo2: TMenuItem;
    VerarchivodeEntrada1: TMenuItem;
    VerarchivodeSalida1: TMenuItem;
    Verarchivoycorrer1: TMenuItem;
    Zoomprevio2: TMenuItem;
    procedure AdvancedCheckClick(Sender: TObject);
    procedure Agregarabajo1Click(Sender: TObject);
    procedure Agregaraladerecha1Click(Sender: TObject);
    procedure AgregarFila1Click(Sender: TObject);
    procedure Altura1Click(Sender: TObject);
    procedure Ampliar1Click(Sender: TObject);
    procedure Autoescala1Click(Sender: TObject);
    procedure Borrar1Click(Sender: TObject);
    procedure Borrarcolumnas1Click(Sender: TObject);
    procedure BorrarFilas1Click(Sender: TObject);
    procedure BotGrafAjusteClick(Sender: TObject);
    procedure BotGrafDistrClick(Sender: TObject);
    procedure BotGrafResidClick(Sender: TObject);
    procedure Buscar1Click(Sender: TObject);
    procedure Check1_1Click(Sender: TObject);
    procedure CheckALPSTChange(Sender: TObject);
    procedure CheckALPSTClick(Sender: TObject);
    procedure CheckCargasClick(Sender: TObject);
    procedure CheckDFMINClick(Sender: TObject);
    procedure CheckElectroClick(Sender: TObject);
    procedure CheckNNSGNClick(Sender: TObject);
    procedure CheckNQPROGClick(Sender: TObject);
    procedure CheckRSVMNXClick(Sender: TObject);
    procedure Columnas2Click(Sender: TObject);
    procedure Coma1Click(Sender: TObject);
    procedure CompetgroupClick(Sender: TObject);
    procedure ControlShow(Sender: TObject);
    procedure Copiar2Click(Sender: TObject);
    procedure Copiargrfico1Click(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure Cortar1Click(Sender: TObject);
    procedure CurvasAdicBoxChange(Sender: TObject);
    procedure DatosShow(Sender: TObject);
    procedure DatosTClick(Sender: TObject);
    procedure Deshacer1Click(Sender: TObject);
    procedure Desmarcar1Click(Sender: TObject);
    procedure ElectroGroupClick(Sender: TObject);
    procedure ElectroShow(Sender: TObject);
    procedure EnableMarkClick(Sender: TObject);
    procedure EntNCurvChange(Sender: TObject);
    procedure EntNFLAT22Change(Sender: TObject);
    procedure Escalas1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure FIonicaClick(Sender: TObject);
    procedure FNextClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseEnter(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Generardistribucin1Click(Sender: TObject);
    procedure GrabarcomoBMP1Click(Sender: TObject);
    procedure GrafAjusteMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GrafMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GrafDistribMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GraficarDatos1Click(Sender: TObject);
    procedure GraficarDistribucion1Click(Sender: TObject);
    procedure GraficarResultados1Click(Sender: TObject);
    procedure GrafMouseLeave(Sender: TObject);
    procedure GrafResidMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GrafResidMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GrafVolumeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GridGroupClick(Sender: TObject);
    procedure HojasChange(Sender: TObject);
    procedure HojasMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Insertarcolumnas1Click(Sender: TObject);
    procedure Insertarenposicin1Click(Sender: TObject);
    procedure InsertarFilas1Click(Sender: TObject);
    procedure IntrinsicGroupClick(Sender: TObject);
    procedure KernelGroupClick(Sender: TObject);
    procedure KernelShow(Sender: TObject);
    procedure Limpiar1Click(Sender: TObject);
    procedure Llenar1Click(Sender: TObject);
    procedure Localizarpunto1Click(Sender: TObject);
    procedure Marcar1Click(Sender: TObject);
    procedure Marcartodas1Click(Sender: TObject);
    procedure MarcasColores1Click(Sender: TObject);
    procedure ModoNormal1Click(Sender: TObject);
    procedure ModoPanClick(Sender: TObject);
    procedure ModoZoomDragClick(Sender: TObject);
    procedure ModoZoomPointClick(Sender: TObject);
    procedure Normalizardistr1Click(Sender: TObject);
    procedure NumberOfIonsBoxChange(Sender: TObject);
    procedure Ordenar1Click(Sender: TObject);
    procedure OutputBuscarClick(Sender: TObject);
    procedure ParametrosChange(Sender: TObject);
    procedure Parar2Click(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure PlanCMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PlanCSelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
    procedure PlanCurvesGetColHeaderText(Sender: TObject; AIndex: Integer;
      var AText: String);
    procedure PlanCurvesSelectEditor(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
    procedure PlanDClick(Sender: TObject);
    procedure PlanDMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PlanDSelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
    procedure PlanGenGetColHeaderText(Sender: TObject; AIndex: Integer;
      var AText: String);
    procedure PlanGenSelectEditor(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
    procedure PlanRMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PlanRSelectCell(Sender: TObject; aCol, aRow: Integer;
      var CanSelect: Boolean);
    procedure PlotVContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure Punto1Click(Sender: TObject);
    procedure raeralaIzquierda1Click(Sender: TObject);
    procedure RecalcularClick(Sender: TObject);
    procedure Reemplazar1Click(Sender: TObject);
    procedure Regraficar1Click(Sender: TObject);
    procedure Rehacer1Click(Sender: TObject);
    procedure ReplaceDialog1Find(Sender: TObject);
    procedure ReplaceDialog1Replace(Sender: TObject);
    procedure ReplaceDialog1Show(Sender: TObject);
    procedure rGroupClick(Sender: TObject);
    procedure Se1Click(Sender: TObject);
    procedure Seleccin1Click(Sender: TObject);
    procedure Seleccin2Click(Sender: TObject);
    procedure SimuBindClick(Sender: TObject);
    procedure SimuBindChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TipoPesoClick(Sender: TObject);
    procedure CutItemClick(Sender: TObject);
    procedure BotGenClick(Sender: TObject);
    procedure Todo1Click(Sender: TObject);
    procedure Todo2Click(Sender: TObject);
    procedure TraeralaIzquierda1Click(Sender: TObject);
    procedure TraerhaciaArriba1Click(Sender: TObject);
    procedure VerarchivodeSalida1Click(Sender: TObject);
    procedure Verarchivoycorrer1Click(Sender: TObject);
    procedure Ejecutar1Click(Sender: TObject);
    procedure PointClickPointClick(ATool: TChartTool; APoint: TPoint);
    procedure Zoomprevio2Click(Sender: TObject);
  private
    { Private declarations }
    lastc, lastr, searchc, searchr, findpos: cardinal;
    procedure FindNext(searchtext: string; Options: TFindOptions; var found, fin: boolean);
  public
    { Public declarations }
    childmode: Tpmode;
    myfilename: string;
    electromodel: integer;
    distrtype: integer;
    minalto, minancho: integer;
    ractD, cactD, ractC, cactC, ractR, cactR: cardinal;
    entnsgn: Array[1..4] of TKNumberEdit;
    entlsgn: Array[1..4, 1..4] of TKNumberEdit;
    entnflat: Array[1..4, 1..2] of TKNumberEdit;
    entnpcurv, entficurv: Array[1..nmaxcurv] of TKNumberEdit;
    entQ0s, finQ0s: Array[1..nmaxcurv] of TKNumberEdit;
    entchrg: Array[0..maxion] of TKNumberEdit;
    entconc: Array[0..maxion] of TComboBox;
    chkion: Array[0..maxion] of TCheckBox;
    datcurvOK: Array[0..nmaxcurv-1] of boolean;
    fuerzaionica: Array[1..nmaxcurv] of single;
    form1: TFormMemo1;
    form2: TFormMemo2;
    PlanAct : TsWorksheetGrid;
    GrafAct: TChart;
    RecAct: ^TRecGrafNEW;
    ToolsAct: TChartToolSet;
    TransfAct: TChartAxisTransformations;
    stinfo: TStartupinfo;
    prinfo: TProcessInformation;
    itim: integer;
    timecorr: double;
    datgau, fingau: Array[1..maxgau, 1..3] of TKNumberEdit;
    ajgau: Array[1..maxgau, 1..3] of TCheckBox;
    ncurvas: integer;
    npcurv: arraypuncurv;
    numion: integer;
    limsup, liminf, savin: Array[1..nmaxpar] of double;
    lsupenab, linfenab, lsupcheck, linfcheck: Array[1..nmaxpar] of boolean;
    GaussInf, GaussSup, savgau: Array[1..maxgau, 1..3] of double;
    GInfChecked, GSupChecked: Array[1..maxgau, 1..3] of boolean;
    ColCheckPres, q0independ, savinpr, savgaupr: boolean;
    DefGrafFit: TRecGrafNEW;
    DefGrafRes: TRecGrafNEW;
    DefGrafDist: TRecGrafNEW;
    DefGrafVol: TRecGrafNEW;

    function GeneraInCtn: boolean;
    function GetCheckState(r: integer): boolean;
    procedure Insertar(Modo: Integer);
    procedure Ejecutar(verarchivo: boolean);
    procedure Ancho1Click(Sender: TObject);
    procedure AgregarColumna1Click(Sender: TObject);
    procedure FuenteCeldas(t, b, l, r, ro, co: integer);
    procedure ColorCeldas(t, b, l, r, ro, co: integer);
    function GetDatCols: string;
    procedure Init;
    //procedure CheckIonCLick(ind: integer);
    //procedure PrintSet(Sender: TObject);
  end;


const
    //active pages for each type
    numpagcon = 10;
    pagcontin: Array[1..numpagcon] of string = ('Control','Datos','Grilla','Kernel','Electro','Regularizador','Picos',
                                'Ajuste','Distribucion','Output');
    numpagfith = 10;
    pagfithum: Array[1..numpagfith] of string = ('FitGen','Curves','FiteoElectro','FitDonnan','Intrinseca','DistrNICA',
                                'HojaFitRes','Ajuste','PlotV','Output');

    //fit worksheets definitions
type
  coltype = (cninguno, ctext, cnumber, cactcombo, ccolcombo, cvarfix, cvarfix2, csigncombo, clogcombo,
            cyesnocombo, climcombo, ccombo);

const
    ncolsplangen = 8;
    colsplangen: Array[1..ncolsplangen] of coltype = (ctext, cnumber, cactcombo, cvarfix, cvarfix2,
                       ccolcombo, csigncombo, clogcombo);
    ncolsplancurv = 7;
    colsplancurv: Array[1..ncolsplancurv] of coltype = (cnumber, ctext, ctext, cyesnocombo,
                       ccombo, cyesnocombo, ctext);
    //combos items
    itlimcombo = '--,<,≤';
    itactcombo = 'Act, Log Act, pAct';
    itvarfix = 'Column,Fixed value';
    itsigncombo = '+,-';
    itlogcombo = 'Normal,Log10';
    ityesnocombo =  'No,Yes';

const
  colornot = $d0d0ff;

implementation

{$R *.frm}

uses Main, TASeries, TAtypes, TAFuncSeries, UFormGraf, UEscalas, UFormNormaliz,
     UFormOrd, UFormLlenar, UFormGen, uplanauxil;

var
  fitcount: integer = 0;
  simulando: boolean = False;


procedure TFormInterf.BotGenClick(Sender: TObject);
begin
    if not GeneraInCtn then exit;
    form1.BitBtn1.Visible := False;
    form1.BitBtn2.Visible := False;
    form1.BitBtn3.Visible := True;
    form1.Show;
end;

function TFormInterf.GetCheckState(r: integer): boolean;
begin
    Result := not PlanD.BackgroundColor[1, r] = colornot;
end;

procedure TFormInterf.TipoPesoClick(Sender: TObject);
begin
  ColW.Enabled := TipoPeso.ItemIndex = 3;
end;

procedure TFormInterf.DatosTClick(Sender: TObject);
var
    flag: boolean;
begin
    flag := DatosT.ItemIndex = 0;
    ColT.Enabled := flag;
    flag := not flag;
    EntIntT1.Enabled := flag;
    EntTin1.Enabled := flag;
    EntTfin1.Enabled := flag;
    EntIntT2.Enabled := flag;
    EntTin2.Enabled := flag;
    EntTfin2.Enabled := flag;
    EntIntT3.Enabled := flag;
    EntTin3.Enabled := flag;
    EntTfin3.Enabled := flag;
end;

procedure TFormInterf.CheckCargasClick(Sender: TObject);
begin
  ColQ.Enabled := CheckCargas.Checked;
end;


//*****************************************************************
procedure TFormInterf.RecalcularClick(Sender: TObject);
begin
  PlanAct.AutoCalc:= True;
end;

function gridnextcell(Grid: TsWorkSheetGrid; const dir: boolean; var r, c: cardinal; var round: boolean): boolean;
begin
  round := False;
  Result := True;
  if dir then begin
      inc(r);
      if r >= Grid.RowCount then begin
        r := 1;
        inc(c);
        if c >= Grid.ColCount then
          if MessageDlg('End of worksheet reached','Restart from beginning?',
                         mtConfirmation, mbYesNo,0) = mrYes then begin
            c := 1;
            round := True;
          end else begin
            Result := False;
            exit;
          end;
      end;
  end else begin
    dec(r);
    if r < 1 then begin
      r := Grid.RowCount-1;
      dec(c);
      if c < 1 then
        if MessageDlg('Top of worksheet reached','Restart from end?',
                       mtConfirmation, mbYesNo,0) = mrYes then begin
          c := Grid.ColCount-1;
          round := True;
        end else begin
          Result := False;
          exit;
        end;
    end;
  end;
end;


procedure TFormInterf.Reemplazar1Click(Sender: TObject);
begin
  searchr := PlanAct.Row;
  searchc := PlanAct.Col;
  ReplaceDialog1.Execute;
end;

procedure TFormInterf.Regraficar1Click(Sender: TObject);
begin
  if Parametros.ActivePage = Ajuste then
        if GrafAct = GrafAjuste then
            RehacerGrafico(DefGrafFit)
        else
            RehacerGrafico(DefGrafRes);
  if Parametros.ActivePage = Distribucion then
    RehacerGrafico(DefGrafDist);
end;

procedure TFormInterf.Rehacer1Click(Sender: TObject);
begin
  //PlanAct.UndoRedo.Redo;
end;

procedure TFormInterf.ReplaceDialog1Find(Sender: TObject);
var
  r, c: cardinal;
  found, term, dir, round: boolean;
  searchtext, celltext: string;
begin
  with Sender as TReplaceDialog do begin
      if frEntireScope in Options then begin
        searchc := 1;
        searchr := 1;
      end;
      if (findpos > 0) and (searchr = lastr) and (searchc = lastc) then  begin
        dir := frDown in Options;
        r := searchr;
        c := searchc;
        term := not gridnextcell(PlanAct, dir, r, c, round);
        if term then exit;
        searchr := r;
        searchc := c;
      end;
      if frMatchCase in Options then
          searchtext := UpperCase(FindText)
      else
          searchtext := FindText;
      term := False;
      repeat
        if frMatchCase in Options then
            celltext := UpperCase(PlanAct.Cells[searchc, searchr])
        else
            celltext := PlanAct.Worksheet.ReadAsText(searchr-1, searchc-1);
        findpos := PosEx(searchtext, celltext);
        found := findpos > 0;
        if found then begin
            lastr := searchr;
            lastc := searchc;
            PlanAct.Worksheet.SelectCell(searchr-1, searchc-1);
        end else begin
            r := searchr;
            c := searchc;
            dir := frDown in Options;
            term := not gridnextcell(PlanAct, dir, r, c, round);
            if not term then begin
              searchc := c;
              searchr := r;
            end;
        end;
      until found or term;
  end;
end;

procedure TFormInterf.ReplaceDialog1Replace(Sender: TObject);
var
  r, c: cardinal;
  found, term, rep: boolean;
  searchtext, celltext: string;

  function MakeReplace(opt: TFindOptions; RepText: string): boolean;
  var
    s1, s2, s3: string;
  begin
    with PlanAct do begin
        Worksheet.SelectCell(searchr-1, searchc-1);
        if frPromptOnReplace in ReplaceDialog1.Options then
              if MessageDlg('Replace', 'Replace this?', mtConfirmation, mbYesNo, 0, mbYes) <> mrYes then exit;
        if frMatchCase in opt then
            celltext := UpperCase(Worksheet.ReadAsText(searchr-1, searchc-1))
        else
            celltext := Worksheet.ReadAsText(searchr-1, searchc-1);
        findpos := PosEx(searchtext, celltext, 1);
        if findpos > 0 then begin
            s1 := LeftStr(celltext, findpos - 1);
            s3 := Copy(celltext, findpos + Length(searchtext), Length(celltext));
            s2 :=  s1 + RepText + s3;
            Cells[searchc, searchr] := s2;
            if searchc > 1 then Worksheet.SelectCell(1, searchc-1) else Worksheet.SelectCell(2, searchc-1);
            Worksheet.SelectCell(searchr-1, searchc-1);
        end;
    end;
  end;
begin
  rep := False;
  with ReplaceDialog1 do begin
    repeat
      searchtext := FindText;
      if (findpos > 0) and (searchr = lastr) and (searchc = lastc) then
          rep := MakeReplace(Options, ReplaceText)
      else begin
          FindNext(searchtext, Options, found, term);
          if term then exit;
          rep := MakeReplace(Options, ReplaceText);
      end;
    until rep;
    if frReplaceAll in Options then begin
      repeat
        FindNext(searchtext, Options, found, term);
        if term then begin
          CloseDialog;
          exit;
        end;
      until found;
      MakeReplace(Options, ReplaceText);
      repeat
          FindNext(searchtext, Options, found, term);
          if found then MakeReplace(Options, ReplaceText);
       until term;
       if term then CloseDialog;
    end;

  end;
end;

procedure TFormInterf.ReplaceDialog1Show(Sender: TObject);
begin
  ReplaceDialog1.Position:= Point(Form1.Left + Form1.Width + 10, Form1.Top + 50);
end;


procedure TFormInterf.FindNext(searchtext: string; Options: TFindOptions; var found, fin: boolean);
var
  r, c: cardinal;
  dir, round: boolean;
  celltext: string;
begin
  repeat
      dir := frDown in Options;
      r := searchr;
      c := searchc;
      fin := not gridnextcell(PlanAct, dir, r, c, round);
      if fin then exit;
      searchr := r;
      searchc := c;
      if frMatchCase in Options then
          celltext := UpperCase(PlanAct.Worksheet.ReadAsText(searchr-1, searchc-1))
      else
          celltext := PlanAct.Worksheet.ReadAsText(searchr-1, searchc-1);
      findpos := PosEx(searchtext, celltext);
      found := findpos > 0;
  until found;
end;


procedure TFormInterf.FIonicaClick(Sender: TObject);
begin
    if FIonica.ItemIndex = 1 then begin
      //ChargeCompeIon.Enabled := True;
      EntFionica.Enabled := False;
      ColE.Enabled := True;
{      for i := 0 to maxion do begin
        entchrg[i].Enabled := True;
        entconc[i].Enabled := True;
      end; }
    end else begin
      //ChargeCompeIon.Enabled := False;
      EntFionica.Enabled := True;
      ColE.Enabled := False;
{      for i := 0 to maxion do begin
        entchrg[i].Enabled := False;
        entconc[i].Enabled := False;
      end;}
    end;
end;


procedure TFormInterf.FNextClick(Sender: TObject);
var
  fo, fi: boolean;
begin
  FindNext(FindDialog1.FindText, FindDialog1.Options, fo, fi);
  if fo then begin
    PlanAct.Worksheet.SelectCell(searchr-1, searchc-1);
    lastr := searchr;
    lastc := searchc;
  end;
end;

//procedure TFormInterf.Grabar1Click(Sender: TObject);
//begin
  //if SaveDlgOutM.Execute then
  //  OutPutMemo.Lines.SaveToFile(SaveDlgOutM.FileName);
//end;

//procedure TFormInterf.GrabarComo1Click(Sender: TObject);
//begin
  //if SaveDialogT.Execute then
  //  OutputMemo.Lines.SaveToFile(SaveDialogT.FileName);
//end;

procedure TFormInterf.GrabarcomoBMP1Click(Sender: TObject);
begin
  //if SavePicD.Execute then
  //  case SavePicD.FilterIndex of
  //    1: GrafAct.CopyToBMP(SavePicD.FileName, False);
  //    2: GrafAct.CopyToWMF(SavePicD.FileName, False);
  //  end;
end;

//procedure TFormInterf.GrabarDistribucin1Click(Sender: TObject);
//begin
//    MainForm.Exportar(PlanC, 'distribution');
//end;

//procedure TFormInterf.Filas2Click(Sender: TObject);
//var
//  t, b, l, r: integer;
//begin
  //with PlanAct do begin
  //  t := Selection.Top;
  //  b := Selection.Bottom;
  //  l := 1;
  //  r := ColCount-1;
  //  FuenteCeldas(t, b, l, r, Row, Col);
  //end;
//end;

//procedure TFormInterf.Filas3Click(Sender: TObject);
//var
//  t, b, l, r: integer;
//begin
  //with PlanAct do begin
  //  t := Selection.Top;
  //  b := Selection.Bottom;
  //  l := 1;
  //  r := ColCount-1;
  //  ColorCeldas(t, b, l, r, Row, Col);
  //end;
//end;


//procedure TFormInterf.Importar1Click(Sender: TObject);
//begin
//    MainForm.Importar(PlanD, 'data file');
//end;

//procedure TFormInterf.Imprimir2Click(Sender: TObject);
//var
//  r: TRect;
//  i: Integer;
//begin
//  with Printer do begin
//    r := Rect(200,200,(Pagewidth - 200),(PageHeight - 200));
//    BeginDoc;
//    Canvas.Brush.Style := bsClear;
//    for i := 0 to OutPutMemo.Lines.Count do
//      Canvas.TextOut(200,200 + (i * Canvas.TextHeight(OutPutMemo.Lines.Strings[i])),
//          OutPutMemo.Lines.Strings[i]);
//    Canvas.Brush.Color := clBlack;
//    Canvas.FrameRect(r);
//    EndDoc;
//  end;
//end;

//procedure TFormInterf.BotImportDistr1Click(Sender: TObject);
//begin
//    MainForm.Importar(PlanC, 'distribution file');
//end;
//
//
procedure TFormInterf.Buscar1Click(Sender: TObject);
var
  r, c: cardinal;
  roun, dir: boolean;
begin
  with FindDialog1 do begin
    if (findpos > 0) and (lastr = searchr) and (lastc = searchc) then begin
        r := searchr;
        c := searchc;
        dir := frDown in Options;
        if not gridnextcell(PlanAct, dir, r, c, roun) then exit;
        searchr := r;
        searchc := c;
    end else begin
      searchr := PlanAct.Row;
      searchc := PlanAct.Col;
    end;
    Execute;
  end;
end;



procedure TFormInterf.Deshacer1Click(Sender: TObject);
begin
//  PlanAct.UndoRedo.Undo;
end;

procedure TFormInterf.Desmarcar1Click(Sender: TObject);
begin
  PlanD.BackgroundColors[1, ractD, PlanD.ColCount-1, ractD] := clWhite;
end;

procedure TFormInterf.ElectroGroupClick(Sender: TObject);
begin
  electromodel := ElectroGroup.ItemIndex;
  case electromodel of
    0: begin                           //EPN
       FiteoElectro.Visible := True;
       FiteoElectro.TabVisible := True;
       FitDonnan.Visible := False;
       FitDonnan.TabVisible := False;
//       for i := 3 to 6 do begin
         //FinParam[i].Visible := True;
         //LabFin[i].Visible := True;
//       end;
       //LabFinD[1].Visible := False;
       //LabFinD[2].Visible := False;
    end;
    1: begin                          //EPN-DL
      FiteoElectro.Visible := True;
      FiteoElectro.TabVisible := True;
      FitDonnan.Visible := False;
      FitDonnan.TabVisible := False;
    end;
    2: begin                           //Donnan V
       FiteoElectro.Visible := False;
       FiteoElectro.TabVisible := False;
       FitDonnan.Visible := True;
       FitDonnan.TabVisible := True;
//       for i := 3 to 6 do begin
         //FinParam[i].Visible := False;
//         LabFin[i].Visible := False;
 //      end;
 //      LabFinD[1].Visible := True;
 //      LabFinD[2].Visible := True;
 //      LabFinD[3].Visible := True;
       //FinParam[3].Visible := True;
    end;
  end;
end;

//procedure TFormInterf.Deshacer2Click(Sender: TObject);
//begin
//  OutputMemo.Undo;
//end;


procedure TFormInterf.EntNFLAT22Change(Sender: TObject);
begin

end;

//procedure TFormInterf.DistribucionShow(Sender: TObject);
//begin
//  GrafDistrib.Height := Distribucion.Height - chicuad1.Height - BotGrafDistr.Height - 4;
//  GrafDistrib.AutoRedraw := True;
//  GrafDistrib.AutoRedraw := False;
//end;

procedure TFormInterf.Generardistribucin1Click(Sender: TObject);
begin
    if not GeneraInCtn then exit;
    form1.BitBtn1.Visible := False;
    form1.BitBtn2.Visible := False;
    form1.BitBtn3.Visible := True;
    form1.Show;
end;

procedure TFormInterf.BotGrafAjusteClick(Sender: TObject);
begin
//    HacerGraficoAutom(PlanR, 5, 6, 7, -1, -1, 0, 1, 0, 0,
  //      True, True, True, 'Ajuste', 'c', 'Q');
  HacerGraficoAuto(DefGrafFit);
end;

procedure TFormInterf.BotGrafDistrClick(Sender: TObject);
begin
//    HacerGraficoAutom(PlanR, 1, 2, -1, -1, -1, 2, 0, 0, 0,
//        False, False, False, 'Distribución hallada', 'log K', 'f(log K)');
  HacerGraficoAuto(DefGrafDist);
end;

procedure TFormInterf.BotGrafResidClick(Sender: TObject);
begin
  HacerGraficoAuto(DefGrafRes);
end;

function TFormInterf.GeneraInCtn: boolean;
const
    fmtstd = ' %-6s%5d%15.6f';
    fmtstd2 = ' %-6s%5d%15.6f%15.6f';
    fmtstd3 = ' %-6s%5d%15.5e';

var
    c, cd, d, i, j, jj, jinic, jg, n, nt, ny, ny1, ap, iwt, ny2, cq, ce, cr, cp, ngrid: integer;
    en, ne, iu20, gin, gfin: single;
    st, ru1, ru2, ru6, ru7, ru9, ruser: double;
    fifija, rvar: boolean;
    s: string;
    DecSepSav: char;

    function RowCheck(r, c, d: integer): boolean;
    var
      stat: boolean;
    begin
      if ColCheckPres then begin
        //if not PlanD.GetCheckBoxState(0, i, Stat) then
        //  raise Exception.Create('CheckBox not found!');
        Result := GetCheckState(r);
      end else Result := True;
      Result := Result and (PlanD.Cells[c, i] <> '') and
        ((PlanD.Cells[d, i] <> '') or simulando);
    end;

begin
  Result := False;
  DecSepSav := DecimalSeparator;
  DecimalSeparator := '.';
  form1.BitBtn1.Visible := True;
  form1.BitBtn2.Visible := True;
  form1.BitBtn3.Visible := False;
  Form1.Memo1.ReadOnly := False;
  with Form1.Memo1.Lines do begin
    Clear;
    // generar lineas de control
    Append(' '+TitEdit.Text);
    Append(Format(fmtstd, ['LAST  ',0,1.0]));

    //Restricciones
    ap := Control.PageIndex;
    try
      if NonNegChk.Checked then
          Append(Format(fmtstd, ['NONNEG',0,1.0]))
      else
          Append(Format(fmtstd, ['NONNEG',0,-1.0]));
      if CheckConste.Checked then Append(Format(fmtstd, ['NLINF ', 0, 1.0]))
            else Append(Format(fmtstd, ['NLINF ', 0, 0.0]));

      if CheckIneq.Checked then Append(Format(fmtstd, ['DOUSNQ', 0, 1.0]));
      ru1 := 0.0;
      ru2 := 0.0;
      ru6 := 0.0;
      ru7 := 0.0;
      ru9 := 0.0;
      ne := 0;
      iu20 := 0;
      if CheckEq1.Checked then begin
        ne := ne+1;
        iu20 := iu20 + 4;
        ru6 := EntInteg.Value;
      end;
      if CheckLimInf.Checked then begin
        ne := ne+1;
        iu20 := iu20 + 2;
        ru2 := EntLimInf.Value;
      end;
      if CheckLimSup.Checked then begin
        ne := ne+1;
        iu20 := iu20 + 1;
        ru1 := EntLimSup.Value;
      end;
      if CheckDerivInf.Checked then begin
        ne := ne+1;
        iu20 := iu20 + 8;
        ru7 := EntDerivInf.Value;
      end;
      if CheckDerivSup.Checked then begin
        ne := ne+1;
        iu20 := iu20 + 16;
        ru9 := EntDerivSup.Value;
      end;
      Append(Format(fmtstd, ['NEQ   ', 0, ne]));
      Append(Format(fmtstd, ['IUSER ', 20, iu20]));
      Append(Format(fmtstd, ['RUSER ', 1, ru1]));
      Append(Format(fmtstd, ['RUSER ', 2, ru2]));
      Append(Format(fmtstd, ['RUSER ', 6, ru6]));
      Append(Format(fmtstd, ['RUSER ', 7, ru7]));
      Append(Format(fmtstd, ['RUSER ', 9, ru9]));
      if CheckTemp.Checked then
        Append(Format(fmtstd, ['IUNIT ', 0, 8.0]));
      if SimuBind.Checked then begin
        Append(Format(fmtstd, ['LUSER ', 30, 1.0]));
        Append(Format(fmtstd, ['DOUSIN', 0, 1.0]));
      end;
      simulando := SimuBind.Checked;

      //Regularizador
      ap := Regularizador.PageIndex;
      st := EntRegOrder.Value;
      Append(Format(fmtstd, ['NORDER', 0, st]));
      st := EntNENDZ1.Value;
      Append(Format(fmtstd, ['NENDZ ', 1, st]));
      st := EntNENDZ2.Value;
      Append(Format(fmtstd, ['NENDZ ', 2, st]));
      if CheckNQPROG.Checked then begin
        st := EntNQPROG1.Value;
        Append(Format(fmtstd, ['NQPROG', 1, st]));
        st := EntNQPROG2.Value;
        Append(Format(fmtstd, ['NQPROG', 2, st]));
      end;
      if CheckRSVMNX.Checked then begin
        Append(' RSVMNX');
        s := '';
        st := EntRSVMNX11.Value;
        s := s + ' ' + FloatToStrF(st, ffExponent, 4, 2);
        st := EntRSVMNX21.Value;
        s := s + ' ' +  FloatToStrF(st, ffExponent, 4, 2);
        st := EntRSVMNX12.Value;
        s := s + ' ' +  FloatToStrF(st, ffExponent, 4, 2);
        st := EntRSVMNX22.Value;
        s := s + ' ' +  FloatToStrF(st, ffExponent, 4, 2);
        Append(s);
//        Append(Format(' %10.2e%10.2e%10.2e%10.2e', [st, ru1, ru6, ru7]));
      end;
      if CheckALPST.Checked then begin
        st := EntALPST1.Value;
        Append(Format(fmtstd, ['ALPST ', 1, st]));
        st := EntALPST2.Value;
        Append(Format(fmtstd, ['ALPST ', 2, st]));
      end;
      if CheckDFMIN.Checked then begin
        st := EntDFMIN.Value;
        Append(Format(fmtstd, ['DFMIN ', 1, st]));
      end;

      //Parametros de análisis de picos restringidos
      ap := Picos.PageIndex;
      if CheckNNSGN.Checked then begin
        st := EntNNSGN1.Value;
        Append(Format(fmtstd, ['NNSGN ', 1, st]));
        st := EntNNSGN2.Value;
        Append(Format(fmtstd, ['NNSGN ', 2, st]));
        for i := 1 to 4 do begin
          st := entnsgn[i].Value;
          Append(Format(fmtstd, ['NSGN  ', i, st]));
        end;
        s := '';
        for j := 1 to 4 do
          for i := 1 to 4 do begin
            jg := Trunc(entlsgn[j,i].Value);
            s := s + Format('%5d', [jg]);
          end;
        Append(' LSIGN ');
        Append(s);
        s := '';
        for i := 1 to 2 do
          for j := 1 to 4 do begin
            jg := Trunc(entnflat[j,i].Value);
            s := s + Format('%5d', [jg]);
          end;
        Append(' NFLAT ');
        Append(s);
        st := EntSRMIN.Value;
        Append(Format(fmtstd, ['SRMIN ', 0, st]));
        st := EntMQPITR.Value;
        Append(Format(fmtstd, ['MQPITR', 0, st]));
      end;

      //Grilla
      ap := Grilla.PageIndex;
      st := EntNG.Value;
      ngrid := Trunc(st);
      Append(Format(fmtstd, ['NG    ', 0, st]));
      st := MetCuadra.ItemIndex+1;
      Append(Format(fmtstd, ['IQUAD ', 0, st]));
      if EntLambda1.Value > EntLambda2.Value then
          raise Exception.Create('Error in grid range: lambda 1 > lambda 2');
      gin := EntLambda1.Value;
      gfin := EntLambda2.Value;
      Append(Format(fmtstd3, ['GMNMX ', 1, gin]));
      Append(Format(fmtstd3, ['GMNMX ', 2, gfin]));
      st := TipoGrilla.ItemIndex+1;
      Append(Format(fmtstd, ['IGRID ', 0, st]));

      //Kernel
      ap := Kernel.PageIndex;
      j := KernelGroup.ItemIndex;
      case j of
        0: Append(Format(fmtstd, ['IUSER ', 21, 0.0]));
        1, 2, 3: begin
            if (j = 2) or (j = 3) then begin
              ruser := j-1;
              Append(Format(fmtstd3, ['IUSER ', 23, ruser]));
              if rGroup.ItemIndex = 0 then begin
                ruser := EditR.Value;
                Append(Format(fmtstd3, ['RUSER ', 5, ruser]));
                rvar := False;
              end else begin
                Append(Format(fmtstd, ['LUSER ', 9, 1.0]));
                rvar := True;
              end;
            end else
              Append(Format(fmtstd, ['IUSER ', 23, 0.0]));
            ruser := EntActivComp.Value;
            if pXoAct.ItemIndex = 0 then ruser := Power(10, -ruser);
            Append(Format(fmtstd3, ['RUSER ', 4, ruser]));
            case CompetGroup.ItemIndex of
                0: begin             //Langmuir-Freundlich
                    Append(Format(fmtstd, ['IUSER ', 21, 1.0]));
                    ruser := EntK1.Value;
                    ruser := Power(10, ruser);
                    Append(Format(fmtstd3, ['RUSER ', 51, ruser]));
                    ruser := Entm1.Value;
                    Append(Format(fmtstd3, ['RUSER ', 52, ruser]));
                    ruser := EntQ1.Value;
                    Append(Format(fmtstd3, ['RUSER ', 53, ruser]));
                end;
{
                  1: begin            //Igual con factor
                      Append(Format(fmtstd, ['IUSER ', 21, 2.0]));
                      ruser := EntActivComp.Value;
                      if pXoAct.ItemIndex = 0 then ruser := Power(10, -ruser);
                      Append(Format(fmtstd3, ['RUSER ', 4, ruser]));
                      ruser := EditFactor.Value;
                      Append(Format(fmtstd3, ['RUSER ', 51, ruser]));
                  end;

}                1: begin             //Tipo NICA
                    Append(Format(fmtstd, ['IUSER ', 21, 3.0]));
                    ruser := EntNICAdesde.Value;
                    ru1 := ruser;
                    Append(Format(fmtstd3, ['RUSER ', 11, ruser]));
                    ruser := EntNICAhasta.Value;
                    if ruser <= ru1 then
                      raise Exception.Create('Error in grid range: from >= to');
                    Append(Format(fmtstd3, ['RUSER ', 12, ruser]));
                    ru2 := ruser;
                    ruser := EntNICApuntos.Value;
                    if ruser <= 0 then
                      raise Exception.Create('Error in grid range: Number of points');
                    ruser := (ru2-ru1)/(ruser-1);
                    Append(Format(fmtstd3, ['RUSER ', 13, ruser]));
                    ruser := EntK1.Value;
                    Append(Format(fmtstd3, ['RUSER ', 51, ruser]));
                    ruser := Entm1.Value;
                    Append(Format(fmtstd3, ['RUSER ', 52, ruser]));
                    ruser := EntQ1.Value;
                    Append(Format(fmtstd3, ['RUSER ', 53, ruser]));
                    ruser := Entm1.Value;
                    Append(Format(fmtstd3, ['RUSER ', 54, ruser]));
                    ruser := Entm2.Value;
                    Append(Format(fmtstd3, ['RUSER ', 55, ruser]));
                    ruser := EntQ2.Value;
                    Append(Format(fmtstd3, ['RUSER ', 56, ruser]));
                end;
                2: begin         //Distribución discreta
                    jinic := 50;
                    jg := GridGroup.ItemIndex;
                    ruser := jg+4;
                    Append(Format(fmtstd3, ['IUSER ', 21, ruser]));
                    case jg of
                      0: begin
                          if (ColGridDistr.ItemIndex < 0) or (ColGridDistr.ItemIndex > PlanC.ColCount)
                                then raise Exception.Create('Invalid distribution column');
                          c := ColGridDistr.ItemIndex + 1;
                          ny := PlanC.RowCount-1;    //????
                          ny1 := ny;
                          for i := 1 to ny1 do begin
                            FormatSettings.DecimalSeparator := DecSepSav;
                            if ConvStrToFloat(PlanC, c, i, st) then begin
                                FormatSettings.DecimalSeparator := '.';
                                jj := i+jinic;
                                Append(Format(fmtstd3, ['RUSER ', jj, st]));
                            end else dec(ny);
                          end;
                          jinic := jj;
                      end;
                      1: begin
                          ru1 := EntNICADesde.Value;
                          ru2 := EntNICAHasta.Value;
                          if ru2 <= ru1 then
                            raise Exception.Create('Error in grid range: from >= to');
                          ruser := EntNICApuntos.Value;
                          ny := Trunc(ruser);
                          if ruser <= 0 then
                            raise Exception.Create('Error in grid range: Number of points');
                          ru6 := (ru2-ru1)/(ruser-1);
                          Append(Format(fmtstd3, ['RUSER ', 11, ru1]));
                          Append(Format(fmtstd3, ['RUSER ', 12, ru2]));
                          Append(Format(fmtstd3, ['RUSER ', 13, ru6]));
                          Append(Format(fmtstd, ['IUSER ', 22, ruser]));
                      end;
                    end;
                    if (ColDistrBox.ItemIndex < 0) or (ColDistrBox.ItemIndex > PlanC.ColCount)
                          then raise Exception.Create('Invalid distribution column');
                    c := ColDistrBox.ItemIndex + 1;
                    for i := 1 to ny do begin
                        FormatSettings.DecimalSeparator := DecSepSav;
                        ConvStrToFloat(PlanC, c, i, st);
                        FormatSettings.DecimalSeparator := '.';
                        jj := i+jinic;
                        Append(Format(fmtstd3, ['RUSER ', jj, st]));
                    end;
                    ruser := ny;
                    jinic := jj;
                    Append(Format(fmtstd, ['IUSER ', 22, ruser]));
                    DecimalSeparator := DecSepSav;
                    Append(Format(fmtstd, ['DOUSIN', 0, 1.0]));
                end;
            end;     // case CompetGroup
        end;
      end;  // case j

      //Distribución dato para simulación
      if SimuBind.Checked then begin
        if PlanC.RowCount <= ngrid then raise
          Exception.Create('Given distribution does not match grid');
        if (ColS.ItemIndex < 0) or (ColS.ItemIndex > PlanC.ColCount)
          then raise Exception.Create('Ivalid distribution column');
        cd := ColS.ItemIndex + 1;
        for i := 1 to ngrid do begin
          FormatSettings.DecimalSeparator := DecSepSav;
          ConvStrToFloat(PlanC, cd, i, st);
          FormatSettings.DecimalSeparator := '.';
          jj := i+jinic;
          if jj > 1600 then raise
            Exception.Create('Number of points exceeds capacity');
          Append(Format(fmtstd3, ['RUSER ', jj, st]));
        end;
      end;


      //Electrostática
      if CheckElectro.Checked then begin
          Append(Format(fmtstd, ['LUSER ', 2, 1.0]));
          Append(Format(fmtstd, ['DOUSIN', 0, 1.0]));
          ruser := EntChi.Value;
          Append(Format(fmtstd3, ['RUSER ', 20, ruser]));
          ruser := Entf.Value;
          Append(Format(fmtstd3, ['RUSER ', 21, ruser]));
          ruser := EntQmax.Value;
          Append(Format(fmtstd3, ['RUSER ', 17, ruser]));
          ruser := EntQ0.Value;
          Append(Format(fmtstd3, ['RUSER ', 18, ruser]));
          ruser := Entdens.Value;
          Append(Format(fmtstd3, ['RUSER ', 19, ruser]));
          ruser := EntV2.Value;
          Append(Format(fmtstd3, ['RUSER ', 22, ruser]));
          ruser := Entgf.Value;
          Append(Format(fmtstd3, ['RUSER ', 23, ruser]));
//          ruser := Enth.Value;
          ruser := 0;
          Append(Format(fmtstd3, ['RUSER ', 27, ruser]));
          ruser := 1;// EntM.Value;
          Append(Format(fmtstd3, ['RUSER ', 26, ruser]));
          ruser := Entwpsi.Value;
          Append(Format(fmtstd3, ['RUSER ', 47, ruser]));
          Append(Format(fmtstd3, ['RUSER ', 28, 0.018]));  //v molar del agua
          ruser := ChargeMainIon.Value;
          Append(Format(fmtstd3, ['IUSER ', 24, ruser]));
          ruser := ChargeCompeIon.Value;
          Append(Format(fmtstd3, ['IUSER ', 25, ruser]));
          if ElecBindBox.Checked then
            Append(Format(fmtstd, ['LUSER ', 4, 1.0]));
          fifija := Fionica.ItemIndex = 0;
          if Check1_1.Checked then begin
            Append(Format(fmtstd, ['LUSER ', 3, -1.0]));
            if not fifija then begin
              if (ColE.ItemIndex < 0) or (ColE.ItemIndex > PlanD.ColCount)
                then raise Exception.Create('E column invalid');
              Append(Format(fmtstd, ['LUSER ', 6, 1.0]));
  {            ruser := CounterMain.ItemIndex;
              if (ruser < 0) or (ruser > maxion) then
                  raise Exception.Create('Hay que seleccionar un contraión del ion que se enlaza');
              Append(Format(fmtstd3, ['IUSER ', 42, ruser]));
              if j > 0 then begin
                ruser := CounterCompet.ItemIndex;
                Append(Format(fmtstd3, ['IUSER ', 43, ruser]));
                if (ruser < 0) or (ruser > maxion) then
                  raise Exception.Create('Hay que seleccionar un contraión del ion que compite');
              end;     }
    {          for i := 0 to maxion do begin
                  ruser := round(entchrg[i].Value);
                  if ruser <> 0 then begin
                    Append(Format(fmtstd3, ['IUSER ', 25+i, ruser]));
                    ruser := entconc[i].Value;
                    Append(Format(fmtstd3, ['RUSER ', 25+i, ruser]));
                  end;
              end;          }
            end else begin
              Append(Format(fmtstd, ['LUSER ', 6, -1.0]));
              ruser := EntFionica.Value;
              Append(Format(fmtstd3, ['RUSER ', 25, ruser]));
            end;
          end else begin
              for i := 0 to 5 do
                if chkion[i].Checked and
                (entconc[i].ItemIndex < 0) or (entconc[i].ItemIndex > PlanD.ColCount)
                  then raise Exception.Create('Concentration column '+IntToStr(i+1)+' invalid');
              Append(Format(fmtstd, ['LUSER ', 3, 1.0]));
              for i := 0 to 5 do
                if chkion[i].Checked then begin
                  Append(Format(fmtstd, ['LUSER ', 10+i, 1.0]));
                  ruser := entchrg[i].Value;
                  Append(Format(fmtstd3, ['IUSER ', 10+i, ruser]));
                end;
          end;
      end else begin
          Append(Format(fmtstd, ['LUSER ', 2, -1.0]));
      end;


      Append(Format(fmtstd, ['IUSROU', 1, 0.0]));
      Append(Format(fmtstd, ['IUSROU', 2, 2.0]));
//      if j=1 then begin
//            Append(' RSVMNX');
//            Append('  1.000E00  1.000E00  1.100E00  1.100E00');
//      end;

      // Peso estadístico
      ap := Datos.PageIndex;
      iwt := TipoPeso.ItemIndex + 1;
      iu20 := iwt;
      Append(Format(fmtstd, ['IWT   ', 0, iu20]));

      // Datos
      ap := Datos.PageIndex;
      nt := 0;
      ny := 0;
      if CheckCargas.Checked then begin
        if (ColQ.ItemIndex < 0) or (ColQ.ItemIndex > PlanD.ColCount)
            then raise Exception.Create('Q column invalid');
        cq := ColQ.ItemIndex + 1;
        Append(Format(fmtstd, ['LUSER ', 8, 1.0]));
      end;
      n := TipoDatos.ItemIndex;
      Append(Format(fmtstd, ['IUSER ', 29, 1.0*n]));
      if (ColY.ItemIndex < 0) or (ColY.ItemIndex > PlanD.ColCount)
            then raise Exception.Create('Y column invalid');
      d := ColY.ItemIndex + 1;
      if DatosT.ItemIndex <> 0 then begin
          if EntIntT1.Value > 0 then inc(nt);
          if EntIntT2.Value > 0 then inc(nt);
          if EntIntT3.Value > 0 then inc(nt);
          if nt = 0 then raise Exception.Create('Number of t data must not be 0');
          Append(Format(fmtstd, ['NINTT ', 0, 1.0*nt]));
          Append(' END');
          n := Trunc(EntIntT1.Value);
          if n > 0 then begin
            st := EntTin1.Value;
            en := EntTfin1.Value;
            if en <= st then raise Exception.Create('Error in data 1: final < initial');
            Append(Format(fmtstd2, ['NSTEND', n, st, en]));
            ny := ny + n;
          end;
          n := Trunc(EntIntT2.Value);
          if n > 0 then begin
            st := EntTin2.Value;
            en := EntTfin2.Value;
            if en <= st then raise Exception.Create('Error in data 2: final < initial');
            Append(Format(fmtstd2, ['NSTEND', n, st, en]));
            ny := ny + n;
          end;
          n := Trunc(EntIntT3.Value);
          if n > 0 then begin
            st := EntTin3.Value;
            en := EntTfin3.Value;
            if en <= st then raise Exception.Create('Error in data 3: final < initial');
            Append(Format(fmtstd2, ['NSTEND', n, st, en]));
            ny := ny + n;
          end;
          j := 0;
          s := ' ';
          for i := 1 to ny do begin
              if (PlanD.Cells[d, i] = '') and (not simulando) then
                raise Exception.Create('Missing data in row'+IntToStr(i));
              DecimalSeparator := DecSepSav;
              ConvStrToFloat(PlanD, d, i, st);
              if CambSig.Checked then st := -st;
              DecimalSeparator := '.';
              s := s + Format('%-15.6e', [st]);
              inc(j);
              if j >= 5 then begin
                  Append(s);
                  s := ' ';
                  j := 0;
              end;
          end;
      end else begin
          if (ColT.ItemIndex < 0) or (ColT.ItemIndex > PlanD.ColCount)
            then raise Exception.Create('T column invalid');
          Append(Format(fmtstd, ['NINTT ', 0, 0.0]));
          Append(' END');
          c := ColT.ItemIndex + 1;
          if ColCheckPres then begin
            ny := 0;
            for i := PlanD.FixedRows to PlanD.RowCount - 1 do
              if GetCheckState(i) then inc(ny);
          end else
            ny := PlanD.RowCount-1;
          for i := PlanD.FixedRows to PlanD.RowCount - 1 do
            if ColCheckPres and GetCheckState(i) then begin
                if (PlanD.Cells[c, i] = '') or ((PlanD.Cells[d, i] = '') and not simulando) then
                  dec(ny);
            end else
                if (PlanD.Cells[c, i] = '') or ((PlanD.Cells[d, i] = '') and not simulando) then
                  dec(ny);
          Append(Format(' %-6s%5d', ['NY    ', ny]));
          j := 0;
          s := ' ';
          if ColCheckPres then begin
            ny2 := 0;
            for i := PlanD.FixedRows to PlanD.RowCount-1 do begin
              if RowCheck(i, c, d) then begin
                inc(ny2);
                DecimalSeparator := DecSepSav;
                ConvStrToFloat(PlanD, c, i, st);
                if logT.Checked then st := Power(10, -st);
                DecimalSeparator := '.';
                s := s + Format('%-15.6e', [st]);
                inc(j);
                if j >= 5 then begin
                    Append(s);
                    s := ' ';
                    j := 0;
                end;
              end;
            end;
            if ny <> ny2 then
              raise Exception.Create('Error in number of data points!');
          end else
            for i := PlanD.FixedRows to PlanD.RowCount-1 do
              if (PlanD.Cells[c, i] <> '') and
                  ((PlanD.Cells[d, i] <> '') or simulando) then begin
                DecimalSeparator := DecSepSav;
                ConvStrToFloat(PlanD, c, i, st);
                if logT.Checked then st := Power(10, -st);
                DecimalSeparator := '.';
                s := s + Format('%-15.6e', [st]);
                inc(j);
                if j >= 5 then begin
                    Append(s);
                    s := ' ';
                    j := 0;
                end;
              end;
          if s <> ' ' then Append(s);
      end;
      s := ' ';
      j := 0;
      if ColCheckPres then begin
        ny2 := 0;
        for i := PlanD.FixedRows to PlanD.RowCount-1 do begin
          if GetCheckState(i) and (PlanD.Cells[c, i] <> '') and
              ((PlanD.Cells[d, i] <> '') or simulando) then begin
            inc(ny2);
            DecimalSeparator := DecSepSav;
            ConvStrToFloat(PlanD, d, i, st);
            if CambSig.Checked then st := -st;
            DecimalSeparator := '.';
            s := s + Format('%-15.6e', [st]);
            inc(j);
            if j >= 5 then begin
                Append(s);
                s := ' ';
                j := 0;
            end;
          end;
        end;
        if ny <> ny2 then
          raise Exception.Create('Error in number of data points!');
      end else
        for i := 1 to ny do
          if RowCheck(i, c, d) then begin
            DecimalSeparator := DecSepSav;
            ConvStrToFloat(PlanD, d, i, st);
            if CambSig.Checked then st := -st;
            DecimalSeparator := '.';
            s := s + Format('%-15.6e', [st]);
            inc(j);
            if j >= 5 then begin
                Append(s);
                s := ' ';
                j := 0;
            end;
          end;
      if s <> ' ' then Append(s);

      //Datos de fuerza iónica
      if CheckElectro.Checked and not fifija then begin
        ce := ColE.ItemIndex + 1;
        s := '';
        j := 0;
        for i := PlanD.FixedRows to PlanD.RowCount-1 do begin
            if RowCheck(i, c, d) then begin
              DecimalSeparator := DecSepSav;
              ConvStrToFloat(PlanD, ce, i, st);
              DecimalSeparator := '.';
              s := s + Format('%-15.6e', [st]);
              inc(j);
              if j >= 5 then begin
                  Append(s);
                  s := ' ';
                  j := 0;
              end;
            end;
        end;
        if s <> ' ' then Append(s);
      end;

{
            c := ColE.ItemIndex + 1;
            j := 0;
            s := ' ';
            for i := 1 to ny do begin
                FormatSettings.DecimalSeparator := DecSepSav;
                ConvStrToFloat(PlanD, c, i, st);
                FormatSettings.DecimalSeparator := '.';
                s := s + Format('%-15.6e', [st]);
                inc(j);
                if j >= 5 then begin
                    Append(s);
                    s := ' ';
                    j := 0;
                end;
            end;
            if s <> ' ' then Append(s);

}
    //Datos de carga del húmico
      if CheckCargas.Checked then begin
        s := '';
        j := 0;
        for i := PlanD.FixedRows to PlanD.RowCount-1 do begin
          if RowCheck(i, c, d) then begin
            DecimalSeparator := DecSepSav;
            ConvStrToFloat(PlanD, cq, i, st);
            DecimalSeparator := '.';
            s := s + Format('%-15.6e', [st]);
            inc(j);
            if j >= 5 then begin
                Append(s);
                s := ' ';
                j := 0;
            end;
          end;
        end;
        if s <> ' ' then Append(s);
      end;

      //Datos de r variable
       if rvar and (rGroup.ItemIndex = 1) then begin
           if (ColR.ItemIndex < 0) or (ColR.ItemIndex > PlanD.ColCount)
                 then raise Exception.Create('R column invalid');
           cr := ColR.ItemIndex + 1;
           j := 0;
           s := ' ';
           for i := PlanD.FixedRows to PlanD.RowCount-1 do begin
             if RowCheck(i, c, d) then begin
               DecimalSeparator := DecSepSav;
               ConvStrToFloat(PlanD, cr, i, st);
               if pXoAct.ItemIndex = 0 then
                  st := Power(10, -st);
               DecimalSeparator := '.';
               s := s + Format('%-15.6e', [st]);
               inc(j);
               if j >= 5 then begin
                   Append(s);
                   s := ' ';
                   j := 0;
               end;
             end;
           end;
           if s <> ' ' then Append(s);
       end;

       //Datos para P-B no 1:1


      //Datos de peso estadístico
      ap := Datos.PageIndex;
      if iwt = 4 then begin
        if (ColW.ItemIndex < 0) or (ColW.ItemIndex > PlanD.ColCount)
              then raise Exception.Create('W column invalid');
        cp := ColW.ItemIndex + 1;
        j := 0;
        s := ' ';
        for i := PlanD.FixedRows to PlanD.RowCount-1 do
          if RowCheck(i, c, d) then begin
            DecimalSeparator := DecSepSav;
            ConvStrToFloat(PlanD, cp, i, st);
            DecimalSeparator := '.';
            s := s + Format('%-15.6e', [st]);
            inc(j);
            if j >= 5 then begin
                Append(s);
                s := ' ';
                j := 0;
            end;
          end;
        if s <> ' ' then Append(s);
      end;
      Result := True;
    except
      on exc: Exception do begin
        Parametros.ActivePageIndex := ap;
        MessageDlg(exc.Message, mtError, [mbOK], 0);
      end;
    end;
  end;
  DecimalSeparator := DecSepSav;
end;


procedure TFormInterf.FormCreate(Sender: TObject);
var
  i: integer;

begin
  lastc := 1;
  lastr := 1;
  searchc := 1;
  searchr := 1;
  savinpr := False;
  savgaupr := False;
//  Hojas.ActivePageIndex := 0;
  PlanAct := PlanD;
end;

procedure TFormInterf.Init;
var
  i: integer;

  function foundpage(var a: Array of string; n: integer; st: string): boolean;
  var
    j: integer;
  begin
    Result := False;
    for j := 0 to n-1 do
      if a[j] = st then begin
        Result := True;
        exit;
      end;
  end;


begin
  case childmode of
       contin: begin
    //       MainForm.OpenDialog.FilterIndex := 4;
           TitEdit.Text := 'CONTIN '+DateTimeToStr(Now);
    //       Self.ClientHeight := Kernel.Top + NICABox.Top + NICABox.Height + StatusBar.Height+10;
    //       Self.ClientWidth := Parametros.Left + Kernel.Left + Kernel.Width + 80;
           minalto := 450;
           minancho := 740;
   //        Parametros.ShowTabs:= False;
   //        Parametros.ShowTabs:= True;
           entnsgn[1] := EntNSGN1;
           entnsgn[2] := EntNSGN2;
           entnsgn[3] := EntNSGN3;
           entnsgn[4] := EntNSGN4;
           entlsgn[1,1] := EntLSIGN11;
           entlsgn[1,2] := EntLSIGN12;
           entlsgn[1,3] := EntLSIGN13;
           entlsgn[1,4] := EntLSIGN14;
           entlsgn[2,1] := EntLSIGN21;
           entlsgn[2,2] := EntLSIGN22;
           entlsgn[2,3] := EntLSIGN23;
           entlsgn[2,4] := EntLSIGN24;
           entlsgn[3,1] := EntLSIGN31;
           entlsgn[3,2] := EntLSIGN32;
           entlsgn[3,3] := EntLSIGN33;
           entlsgn[3,4] := EntLSIGN34;
           entlsgn[4,1] := EntLSIGN41;
           entlsgn[4,2] := EntLSIGN42;
           entlsgn[4,3] := EntLSIGN43;
           entlsgn[4,4] := EntLSIGN44;
           entnflat[1,1] := EntNFLAT11;
           entnflat[1,2] := EntNFLAT21;
           entnflat[2,1] := EntNFLAT12;
           entnflat[2,2] := EntNFLAT22;
           entnflat[3,1] := EntNFLAT31;
           entnflat[3,2] := EntNFLAT32;
           entnflat[4,1] := EntNFLAT41;
           entnflat[4,2] := EntNFLAT42;


           //entchrg[0] := EntZ1;
           //entchrg[1] := EntZ2;
           //entchrg[2] := EntZ3;
           //entchrg[3] := EntZ4;
           //entchrg[4] := EntZ5;
           //entchrg[5] := EntZ6;
           //
           //entconc[0] := ColC1;
           //entconc[1] := ColC2;
           //entconc[2] := ColC3;
           //entconc[3] := ColC4;
           //entconc[4] := ColC5;
           //entconc[5] := ColC6;
           //
           //chkion[0] := CheckIon1;
           //chkion[1] := CheckIon2;
           //chkion[2] := CheckIon3;
           //chkion[3] := CheckIon4;
           //chkion[4] := CheckIon5;
           //chkion[5] := CheckIon6;


           //    Planillas.Anchors := Planillas.Anchors + [akRight, akBottom];
       //    Parametros.Anchors := [akRight, akTop];
           //StatusBar.Anchors := [akRight, akBottom, akLeft];
       //    StatusBar.Align := alBottom;
           for i := 0 to Parametros.PageCount-1 do begin
             if foundpage(pagcontin, numpagcon, Parametros.Page[i].Name) then begin
               Parametros.Page[i].Visible:= True;
               Parametros.Page[i].TabVisible:=True;
             end else begin
               Parametros.Page[i].Visible:= False;
               Parametros.Page[i].TabVisible:=False;
             end;
           end;
           //Control.Visible := True;
           //Control.TabVisible:= True;
           //Datos.Visible := True;
           //Datos.TabVisible:= True;
           //Grilla.Visible := True;
           //Grilla.TabVisible:= True;
           //Kernel.Visible := True;
           //Kernel.TabVisible:= True;
           //Electro.Visible := True;
           //Electro.TabVisible:= True;
           //Regularizador.Visible := True;
           //Regularizador.TabVisible:= True;
           //Picos.Visible := True;
           //Picos.TabVisible:= True;
           //Ajuste.Visible := True;
           //Ajuste.TabVisible:= True;
           //Distribucion.Visible := True;
           //Distribucion.TabVisible:= True;
           //Output.Visible := True;
           //Output.TabVisible:= True;
           Parametros.ActivePage := Control;
       end;
       fithum: begin
         //FitGen.Visible:= True;
         //FitGen.TabVisible:= True;
         //Curves.Visible:= True;
         //Curves.TabVisible:= True;
         //FitGen.Visible:= True;
         //FitGen.TabVisible:= True;
         //FiteoElectro.Visible:= True;
         //FiteoElectro.TabVisible:= True;
         //Intrinseca.Visible:= True;
         //Intrinseca.TabVisible:= True;
         //HojaFitRes.Visible:= True;
         //HojaFitRes.TabVisible:= True;
         //Ajuste.Visible:= True;
         //Ajuste.TabVisible:= True;
         for i := 0 to Parametros.PageCount-1 do begin
           if foundpage(pagfithum, numpagfith, Parametros.Page[i].Name) then begin
             Parametros.Page[i].Visible:= True;
             Parametros.Page[i].TabVisible:=True;
           end else begin
             Parametros.Page[i].Visible:= False;
             Parametros.Page[i].TabVisible:=False;
           end;
         end;
         Parametros.ActivePage := FitGen;
         with PlanGen do begin
           FixedColWidth:= 40;
           for i := 1 to 8 do
             ColWidths[i] := 72;
           Cells[1, 2] := 'H+';
           Cells[2, 2] := '1';
           Cells[1, 3] := 'Me1';
           Cells[1, 4] := 'Me2';
         end;
         with PlanGen do begin
           TitEdit.Text := 'FIT '+DateTimeToStr(Now);
           for i := 1 to ColCount - 1 do begin
             Cells[3, i] := 'Act';
             Cells[4, i] := 'Column';
             Cells[5, i] := 'A';
             Cells[6, i] := 'B';
             Cells[7, i] := '+';
             Cells[8, i] := 'Normal';
           end;
         end;
       end;
       fitox: begin
       end;
  end;
  Invalidate;
end;

procedure TFormInterf.FormMouseEnter(Sender: TObject);
begin
  if corriendo or corriendof or corriendos then
    Screen.Cursor := crHourGlass
  else
    Screen.Cursor := crDefault;
end;

procedure TFormInterf.FormShow(Sender: TObject);
var
  i: integer;

begin
  //case childmode of
  //  contin: begin
  //  end;
  //  fithum: begin
  //  end;
  //  fitox: begin
  //
  //  end;
  //end;
  if corriendo or corriendof or corriendos then begin
    MainForm.BotDisabled;
    MainForm.BotParar.Enabled := True;
  end else begin
    MainForm.BotEnabled;
    MainForm.BotParar.Enabled := False;
  end;
  MainForm.BotCorrer.Visible := True;
//  MainForm.BotCorrerFit.Visible := False;
end;

procedure TFormInterf.Ejecutar1Click(Sender: TObject);
begin
  Ejecutar(False);
end;

procedure TFormInterf.PointClickPointClick(ATool: TChartTool; APoint: TPoint
  );
var
  sx, sy: string;
  indx: integer;
begin
  indx := TDataPointClickTool(ATool).PointIndex;
  sx := FloatToStrF(GrafAct.XImageToGraph(APoint.X), ffGeneral, 6, 2);
  sy := FloatToStrF(GrafAct.YImageToGraph(APoint.Y), ffGeneral, 6, 2);
  StatusBar.Panels[2].Text := 'Ind = '+IntToStr(indx)+'; X = '+sx+';   '+' Y = '+sy;

end;

procedure TFormInterf.ElectroShow(Sender: TObject);
begin
  CheckElectroClick(Sender);
end;

procedure TFormInterf.EnableMarkClick(Sender: TObject);
var
  i: integer;
begin
  if EnableMark.Checked then begin
    EnableMark.Checked:= False;
    Marcar1.Enabled:= False;
    Desmarcar1.Enabled:= False;
    ColCheckPres := False;
    for i := 1 to PlanD.RowCount - 1 do
      PlanD.BackgroundColors[1, ractD, PlanD.ColCount-1, ractD] := clWhite;
  end else begin
    EnableMark.Checked:= True;
    Marcar1.Enabled:= True;
    Desmarcar1.Enabled:= True;
    ColCheckPres := True;
  end;
end;

procedure TFormInterf.EntNCurvChange(Sender: TObject);
var
  v, i: integer;
begin
  v := EntNCurv.ValueAsInt;
  if (v <= 0) or (v > nmaxcurv) then exit;
  ncurvas := v;
  PlanCurves.BackgroundColors[1, 1, PlanCurves.ColCount-1, v] := clSkyBlue;
  PlanCurves.BackgroundColors[1, v+1, PlanCurves.ColCount-1, PlanCurves.RowCount-1] := clWhite;
  PlanCurves.Repaint;
end;

procedure TFormInterf.Escalas1Click(Sender: TObject);

begin
    FormEscalas.EntrarEscalas(GrafAct);
end;

procedure TFormInterf.FindDialog1Find(Sender: TObject);
var
  r, c: cardinal;
  found, term, dir, round: boolean;
  searchtext, celltext: string;
begin
  with Sender as TFindDialog do begin
    CloseDialog;
    if frEntireScope in Options then begin
      searchc := 1;
      searchr := 1;
    end;
    if frMatchCase in Options then
        searchtext := UpperCase(FindText)
    else
        searchtext := FindText;
    term := False;
    repeat
      if frMatchCase in Options then
          celltext := UpperCase(PlanAct.Cells[searchc, searchr])
      else
          celltext := PlanAct.Worksheet.ReadAsText(searchr-1, searchc-1);
      findpos := PosEx(searchtext, celltext);
      found := findpos > 0;
      if found then begin
          lastr := searchr;
          lastc := searchc;
          PlanAct.Worksheet.SelectCell(searchr-1, searchc-1);
      end else begin
          r := searchr;
          c := searchc;
          dir := frDown in Options;
          term := not gridnextcell(PlanAct, dir, r, c, round);
          if not term then begin
            searchc := c;
            searchr := r;
          end;
      end;
    until found or term;
  end;
end;

procedure TFormInterf.FindDialogFind(Sender: TObject);
var
  sso: TSynSearchOptions;
begin
  with FindDialog do begin
    if not (frDown in Options) then sso := sso + [ssoBackwards];
    if frMatchCase in Options then sso := sso + [ssoMatchCase];
    if frWholeWord in Options then sso := sso + [ssoWholeWord];
    if not (frFindNext in Options) then sso := sso + [ssoEntireScope];
    OutputMemo.SearchReplace(FindText, '', sso);
  end;
end;

procedure TFormInterf.Ejecutar(verarchivo: boolean);

var
  s: string;

begin
  if corriendo or corriendof or corriendos then exit;
  if PlanR.Tag <> 0 then
    if MessageDlg('There are unsaved results! - Sure?', mtWarning, mbOkCancel, 0) <> mrOk then exit;
  if not GeneraInCtn then exit;
  if verarchivo then begin
//    Form1.Panel1.Visible := True;
    if Form1.ShowModal <> mrOK then exit;
  end;
  s := IntToStr(procid) + '-' + MainForm.Traercuenta;
  archin := archin0 + s + '.dat';
  archout := archout0 + s + '.txt';
  archsal := archsal0 + s + '.txt';
  Form1.Memo1.Lines.SaveToFile(dirtemp + '\' + archin);
  Form1.Caption := 'CONTIN '+TitEdit.Text + ' '+archin;
  Form2.Caption := 'CONTIN '+TitEdit.Text + ' '+archin;
  Caption := 'CONTIN '+TitEdit.Text;
  SetCurrentDir(dirtemp);
  stinfo.cb := SizeOf(stinfo);
  //GrafAjuste.ClearGraf;
  //GrafResid.ClearGraf;
  //RGGraf2.grafajust := False;
  //GrafDistrib.ClearGraf;
  //RGGraf2.grafdistr := False;
//  LabelTime.Caption := '';
//  LabelTime1.Caption := '';
  chicuad.Value := 0;
  chicuad1.Value := 0;
  timecorr := Now;
  if not CreateProcess(nil, pChar(continexec + ' '+archin+' '+archout+' '+archsal),
        nil, nil, False, NORMAL_PRIORITY_CLASS+DETACHED_PROCESS, nil, nil, stinfo, prinfo) then begin
    MessageDlg('CreateProcess failed, Error '+IntToStr(GetLastError), mtError, [mbOK], 0);
    exit;
  end;
  MainForm.BotDisabled;
  Correr2.Enabled := False;
  MainForm.Archivo1.Enabled := False;
  Edit1.Enabled := False;
  //Ver1.Enabled := False;
  Procesar1.Enabled := False;
  MainForm.BotParar.Enabled := True;
  Parar2.Enabled := True;
  Screen.Cursor := crHourGlass;
  Application.ProcessMessages;
  itim := 0;
  corriendo := True;
  Timer1.Enabled := True;
end;



procedure TFormInterf.Timer1Timer(Sender: TObject);
var
    i, ng, nc, nf: integer;
    ecode: cardinal;
    ff: TextFile;
    a, b, c, d, d1, d2, d3, sum: double;
    st: string;
    showwin: boolean;
    resfit: boolean;
    ynzero: boolean;
    DecSepSav: char;

begin
    inc(itim);
    if itim > 200 then itim:= 1;
    if (itim mod 20) = 0 then begin
      if corriendo then
        Statusbar.Panels[0].Text := 'CONTIN running'+StringofChar('.', itim div 20);
    end;
    GetExitCodeProcess(prinfo.hProcess, ecode);
    if ecode = STILL_ACTIVE then exit;
    Timer1.Enabled := False;
 //   beep;
    timecorr := SecondSpan(Now, timecorr);
    StatusBar.Panels[0].Text := '';
    MainForm.BotEnabled;
    MainForm.Archivo1.Enabled := True;
    Edit1.Enabled := True;
    Procesar1.Enabled := True;
    MainForm.Ejecutable1.Enabled := True;
    Correr2.Enabled := True;
    //Ver1.Enabled := True;
    MainForm.BotParar.Enabled := False;
    Parar2.Enabled := False;
    Screen.Cursor := crDefault;
//    corriendo := False;
    showwin := False;
    Application.ProcessMessages;
    if ecode = 0 then begin
      PlanR.Clear;;
      PlanR.Tag := 0;
      Form2.Memo2.Lines.Clear;
      try
        if corriendo then begin
          corriendo := False;
          resfit := False;
          OutputMemo.Lines.LoadFromFile(dirtemp + '\' + archout);
          Form2.Memo2.Lines.LoadFromFile(dirtemp + '\' + archout);
          Form2.Caption := Caption + ' ' + archout;
          AssignFile(ff, dirtemp + '\' + archsal);
          Reset(ff);
          ReadLn(ff, st);
          if Pos('ERROR', st) <> 0 then begin
              ShowMessage(st+' in Contin');
              showwin := True;
                CloseFile(ff);
                exit;
          end else Reset(ff);
          if eof(ff) then begin
            ShowMessage('Error: empty output data file - check continout.txt');
            //Form2.Show;
            Parametros.ActivePageIndex := Output.PageIndex;
            CloseFile(ff);
            exit;
          end;
          with PlanR do begin
            ColCount := 14;
            Cells[1, 1] := 'log K';
            Cells[2, 1] := 'f(log K)';
            Cells[3, 1] := 'Error f';
            Cells[4, 1] := 'Constants';
            Cells[5, 1] := '  t';
            Cells[6, 1] := '  y';
            Cells[7, 1] := ' yfit';
            Cells[8, 1] := 'ProbRej';
            Cells[9, 1] := 'Residuals';
            Cells[10, 1] := 'Humic charge';
            Cells[11, 1] := 'Charge dens.';
            Cells[12, 1] := 'Fi 2';
            Cells[13, 1] := 'Psi';
            ReadLn(ff, ng, nc, nf);
            RowCount := Math.Max(ng, nf) + 2;
            for i := 2 to ng+1 do begin
                DecSepSav := FormatSettings.DecimalSeparator;
                FormatSettings.DecimalSeparator := '.';
                ReadLn(ff, a, b, c);
                FormatSettings.DecimalSeparator := DecSepSav;
                Cells[1, i] := FloatToStr(a);
                Cells[2, i] := FloatToStr(b);
                Cells[3, i] := FloatToStr(c);
            end;
            for i:= 2 to nc+1 do begin
                DecSepSav := FormatSettings.DecimalSeparator;
                FormatSettings.DecimalSeparator := '.';
                ReadLn(ff, a);
                FormatSettings.DecimalSeparator := DecSepSav;
                Cells[4, i] := FloatToStr(a);
            end;
//            cc := ColT.ItemIndex + 1;
//            cy := ColY.ItemIndex + 1;
            sum := 0;
            for i:= 2 to nf+1 do begin
                DecSepSav := FormatSettings.DecimalSeparator;
                FormatSettings.DecimalSeparator := '.';
                ReadLn(ff, a, b, c, d, d1, d2, d3);
                FormatSettings.DecimalSeparator := DecSepSav;
                Cells[5, i] := FloatToStr(a);
                Cells[6, i] := FloatToStr(b);
                Cells[7, i] := FloatToStr(c);
                Cells[10, i] := FloatToStr(d);
                Cells[11, i] := FloatToStr(d1);
                Cells[12, i] := FloatToStr(d2);
                Cells[13, i] := FloatToStr(d3);
                Cells[9, i] := FloatToStr(c - b);
                sum := sum + (c - b)*(c - b);
            end;
            ReadLn(ff, a, b);
            Cells[8, 2] := FloatToStr(a);
            Cells[8, 3] := FloatToStr(b);
            Tag := 1;
          end;
        end;
        CloseFile(ff);
        if showwin then Form2.Show;
      except
          on E: exception do begin
              ShowMessage('Error reading output files!');
              if showwin then Form2.Show;
              CloseFile(ff);
              corriendo := False;
              corriendof := False;
              corriendos := False;
              exit;
          end;
      end;
      RecGrafInit(DefGrafDist);
      with DefGrafDist do begin
        Planilla := PlanR;
        Graf := GrafDistrib;
        Params.numcurv := 1;
        Params.titugraf := 'Distribution found';
        Params.numaxis:= 2;
        Params.AxisParams[1].titu := 'log K';
        Params.AxisParams[1].elog := False;
        Params.AxisParams[1].escauto := True;
        Params.AxisParams[1].isy := False;
        Params.AxisParams[1].px := False;
        Params.AxisParams[2].titu := 'f(log K)';
        Params.AxisParams[2].px := False;
        Params.AxisParams[2].isy := True;
        Params.AxisParams[2].escauto:= True;
        Params.AxisParams[2].elog:= False;
        with Params.CurveParams[1] do begin
          active := True;
          colx := 1;
          coly := 2;
          firstx := 1;
          firsty := 1;
          tipocurv := 2;
          xaxis := 1;
          yaxis := 2;
          line := psSolid;
          npunt := ng;
          color := colorssel[1];
          color2 := color;
          Serie := TLineSeries.Create(Application);
        end;
      end;
      RehacerGrafico(DefGrafDist);
      RecGrafInit(DefGrafFit);
      with DefGrafFit do begin
        Graf := GrafAjuste;
        Planilla := PlanR;
        if simulando then begin
          with Params.CurveParams[1] do begin
            colx := 5;
            coly := 7;
            firstx := 1;
            firsty := 1;
            xaxis := 1;
            yaxis := 2;
            tipocurv := 0;
            line := psSolid;
            mark := psCircle;
            npunt := nf;
            color := colorssel[1];
            color2 := color;
            active := True;
            Serie := TLineSeries.Create(Application);
          end;
          ynzero := false;
          for i := 1 to PlanR.RowCount - 1 do
            ynzero := ynzero or (PlanR.Worksheet.ReadAsNumber(i, 6) <> 0);
          if ynzero then begin
            with Params.CurveParams[2] do begin
              colx := 5;
              coly := 6;
              firstx := 1;
              firsty := 1;
              xaxis := 1;
              yaxis := 2;
              tipocurv := 1;
              line := psDash;
              mark := psCross;
              npunt := nf;
              color := colorssel[1];
              color2 := color;
              active := True;
              Serie := TLineSeries.Create(Application);
            end;
            Params.numcurv := 2;
          end else
            Params.numcurv := 1;
          Params.titugraf := 'Simulation';
          Params.numaxis:= 2;
          Params.AxisParams[1].elog := True;
          Params.AxisParams[1].escauto := True;
          Params.AxisParams[1].isy := False;
          Params.AxisParams[1].px := False;
          Params.AxisParams[1].titu := 'c';
          Params.AxisParams[2].elog := False;
          Params.AxisParams[2].escauto:= True;
          Params.AxisParams[2].isy:= True;
          Params.AxisParams[2].px:= False;
          Params.AxisParams[2].titu:= 'Q';
        end else begin
          Params.numcurv := 2;
          Params.titugraf := 'Fitting';
          Params.numaxis:= 2;
          Params.AxisParams[1].elog := True;
          Params.AxisParams[1].escauto := True;
          Params.AxisParams[1].isy := False;
          Params.AxisParams[1].px := False;
          Params.AxisParams[1].titu := 'c';
          Params.AxisParams[2].elog := False;
          Params.AxisParams[2].escauto:= True;
          Params.AxisParams[2].isy:= True;
          Params.AxisParams[2].px:= False;
          Params.AxisParams[2].titu:= 'Q';
          with Params.CurveParams[1] do begin
            colx := 5;
            coly := 6;
            tipocurv := 0;
            firstx := 1;
            firsty := 1;
            xaxis := 1;
            yaxis := 2;
            line := psSolid;
            mark := psCircle;
            npunt := nf;
            color := colorssel[1];
            color2 := color;
            active := True;
            Serie := TLineSeries.Create(Application);
          end;
          with Params.CurveParams[2] do begin
            colx := 5;
            coly := 7;
            tipocurv := 1;
            firstx := 1;
            firsty := 1;
            xaxis := 1;
            yaxis := 2;
            line := psDash;
            npunt := nf;
            color := colorssel[1];
            color2 := color;
            active := True;
            Serie := TLineSeries.Create(Application);
          end;
        end;
      end;
      RehacerGrafico(DefGrafFit);
      if not simulando then begin
        RecGrafInit(DefGrafRes);
        with DefGrafRes do begin
          Params.numcurv := 1;
          Params. titugraf := 'Residuals';
          Params.numaxis:= 2;
          Params.AxisParams[1].titu := 'c';
          Params.AxisParams[1].escauto:= True;
          Params.AxisParams[1].elog:= True;
          Params.AxisParams[1].isy:= False;
          Params.AxisParams[1].px:= False;
          Params.AxisParams[2].titu := 'Qfit - Q';
          Params.AxisParams[2].escauto:=True;
          Params.AxisParams[2].elog:= False;
          Params.AxisParams[2].isy:= True;
          Params.AxisParams[2].px:= False;
          with Params.CurveParams[1] do begin
            colx := 5;
            coly := 9;
            tipocurv := 0;
            firstx := 1;
            firsty := 1;
            xaxis := 1;
            yaxis := 2;
            line := psSolid;
            npunt := nf;
            mark := psCircle;
            color := colorssel[1];
            color2 := color;
            active := True;
            Serie := TLineSeries.Create(Application);
          end;
        end;
        RehacerGrafico(DefGrafRes);
        Chicuad.Value := sum;
        Chicuad1.Value := sum;
      end;
      Parametros.ActivePageIndex := Ajuste.PageIndex;
      StatusBar.Panels[0].Text := 'Time: '+FloatToStrF(timecorr, ffGeneral, 7, 2)+' s';
    end else begin
        MessageDlg('Abnormal termination!', mtError, [mbOk], 0);
        corriendo := False;
        corriendof := False;
        corriendos := False;
    end;
end;


procedure TFormInterf.GrafAjusteMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  GrafAct := GrafAjuste;
  ToolsAct := FitChartTools;
  TransfAct := FitXAxisTransf;
  RecAct := @DefGrafFit;
end;

procedure TFormInterf.GrafMouseLeave(Sender: TObject);
begin
  StatusBar.Panels[1].Text := '';
end;

procedure TFormInterf.GrafMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var
    sx, sy: string;
begin
  if not (corriendo or corriendof or corriendos) and (Sender is TChart) then
    with TChart(Sender) do begin
        sx := FloatToStrF(XImageToGraph(X), ffGeneral, 6, 2);
        sy := FloatToStrF(YImageToGraph(Y), ffGeneral, 6, 2);
        StatusBar.Panels[1].Text := 'X = '+sx+';   '+' Y = '+sy;
    end;
end;

procedure TFormInterf.GrafDistribMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  GrafAct := GrafDistrib;
  ToolsAct := DistChartTools;
  TransfAct := DistXAxisTransf;
  RecAct := @DefGrafDist;
end;

//procedure TFormInterf.GrafClick(Sender: TObject);
//var
//  indx: integer;
//  dist: double;
//  itm: TrcChartItem;
//  sx, sy: string;
//begin
//  if not Localizarpunto1.Checked then exit;
//  with GrafAct do
//    if MouseAction = SDL_sdlBase.maNone then begin
//{
//        x := MousePosX;
//        y := MousePosY;
//        mdist := MaxDouble;
//        indx := -1;
//        for i := 0 to NumItems - 1 do begin
//          if DataContainer[i].ItemKind = tkMarkAt then begin
//            dist := sqr(DataContainer[i].x - x)+ sqr(DataContainer[i].y - y);
//            if dist < mdist then begin
//              mdist := dist;
//              indx := i;
//            end;
//          end;
//        end;
//
//}
//      indx := FindNearestItemScreen (MousePosX, MousePosY, tkMarkAt, 255, dist);
//      if indx >= 0 then begin
//        AutoRedraw := True;
//        itm := DataContainer[indx];
//        sx := FloatToStrF(itm.x, ffGeneral, 6, 2);
//        sy := FloatToStrF(itm.y, ffGeneral, 6, 2);
//        StatusBar.Panels[2].Text := 'Ind = '+IntToStr(indx)+'; X = '+sx+';   '+' Y = '+sy;
//        CrossHair1.PosX := itm.x;
//        CrossHair1.PosY := itm.y;
//        CrossHair1.Color := clMaroon;
//        CrossHair1.LineType := psDash;
//        CrossHair1.Mode := chBoth;
//        AutoRedraw := False;
//      end;
//    end;
//end;

procedure TFormInterf.GraficarDatos1Click(Sender: TObject);
begin
    HacerGraficoNew(PlanD);
end;

procedure TFormInterf.GraficarResultados1Click(Sender: TObject);
begin
    HacerGraficoNew(PlanR);
end;

procedure TFormInterf.GrafResidMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  GrafAct := GrafResid;
  ToolsAct := ResChartTools;
  TransfAct := ResXAxisTransf;
  RecAct := @DefGrafRes;
end;

procedure TFormInterf.GrafResidMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
//  GrafResid.XImageToGraph(X);
end;

procedure TFormInterf.GrafVolumeMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  GrafAct := GrafVolume;
  ToolsAct := VolChartTools;
  TransfAct := VolXAxisTransf;
  RecAct := @DefGrafVol;
end;

//procedure TFormInterf.GrafResidMouseLeave(Sender: TObject);
//begin
//  StatusBar.Panels[1].Text := '';
//end;

//procedure TFormInterf.GrafResidMouseMoveInChart(Sender: TObject;
//  InChart: Boolean; Shift: TShiftState; rMousePosX, rMousePosY: Double);
//var
//    sx, sy: string;
//begin
//  if not (corriendo or corriendof or corriendos) and InChart then begin
//    sx := FloatToStrF(rMousePosX, ffGeneral, 6, 2);
//    sy := FloatToStrF(rMousePosY, ffGeneral, 6, 2);
//    StatusBar.Panels[1].Text := 'X = '+sx+';   '+' Y = '+sy;
//  end;
//end;

procedure TFormInterf.GraficarDistribucion1Click(Sender: TObject);
begin
    HacerGraficoNew(PlanC);    //NO, gráfico acá
end;

//procedure TFormInterf.PlanDCellsChanged(Sender: TObject; R: TRect);
//begin
//    PlanD.Tag := 1;
//end;


procedure TFormInterf.VerarchivodeSalida1Click(Sender: TObject);
begin
    Form2.Memo2.Lines.Text := Outputmemo.Lines.Text;
    Form2.Caption := TitEdit.Text;
    Form2.Show;
end;

procedure TFormInterf.Verarchivoycorrer1Click(Sender: TObject);
begin
  Ejecutar(True);
end;

//procedure TFormInterf.PlanRCellsChanged(Sender: TObject; R: TRect);
//begin
//    PlanR.Tag := 1;
//end;
//
//
//procedure TFormInterf.PlanRGetFloatFormat(Sender: TObject; ACol, ARow: Integer;
//  var IsFloat: Boolean; var FloatFormat: string);
//begin
//  if (ACol = 0) or (ARow = 0) then
//    FloatFormat := '%d'
//  //else //if IsFloat then
//  //  FloatFormat := '%9.6g';
//end;

//procedure TFormInterf.PlanCCellsChanged(Sender: TObject; R: TRect);
//begin
//    PlanC.Tag := 1;
//end;
//
//procedure TFormInterf.AgregarFila1Click(Sender: TObject);
//begin
//    PlanAct.AddRow;
//    if ColCheckPres then
//      PlanAct.AddCheckBox(0, PlanAct.RowCount-1, True, False);
//    PlanAct.AutoSpreadHeaders;
//end;

//procedure TFormInterf.AjusteShow(Sender: TObject);
//begin
////  GrafAjuste.Height := Ajuste.Height - chicuad.Height - GrafResid.Height - 4;
////  GrafDistrib.Width := Ajuste.Width;
//  Panel2.Height := Ajuste.Height - BotGrafAjuste.Top - BotGrafAjuste.Height - 4;
//  GrafAjuste.AutoRedraw := True;
//  GrafAjuste.AutoRedraw := False;
//  GrafResid.AutoRedraw := True;
//  GrafResid.AutoRedraw := False;
//end;

procedure TFormInterf.Altura1Click(Sender: TObject);
var
  i: integer;
begin
  with FormAltoAncho do begin
    Caption := 'Row height';
    Alabel.Caption := 'Height';
    AltoAncho.Value := PlanAct.RowHeights[PlanAct.Row];
    ShowModal;
    case radio.ItemIndex of
      0: for i := PlanAct.Selection.Top to PlanAct.Selection.Bottom do
              PlanAct.RowHeights[i] := AltoAncho.Value;
      1: for i := 1 to PlanAct.RowCount - 1 do
              PlanAct.RowHeights[i] := AltoAncho.Value;
    end;
  end;
end;

procedure TFormInterf.AgregarFila1Click(Sender: TObject);
begin
     PlanAct.Worksheet.InsertRow(PlanAct.RowCount);
end;

procedure TFormInterf.Ampliar1Click(Sender: TObject);
begin
  HacerGraficoNew(RecAct.Planilla);
end;

procedure TFormInterf.Autoescala1Click(Sender: TObject);
begin
  GrafAct.Extent.UseXMax := False;
  GrafAct.Extent.UseXMin := False;
  GrafAct.Extent.UseYMax := False;
  GrafAct.Extent.UseYmin := False;
end;

procedure TFormInterf.Ancho1Click(Sender: TObject);
var
  i: integer;
begin
  with FormAltoAncho do begin
    Caption := 'Columna width';
    Alabel.Caption := 'Width';
    AltoAncho.Value := PlanAct.ColWidths[PlanAct.Col];
    ShowModal;
    case radio.ItemIndex of
      0: for i := PlanAct.Selection.Left to PlanAct.Selection.Right do
              PlanAct.ColWidths[i] := AltoAncho.Value;
      1: for i := 1 to PlanAct.ColCount - 1 do
              PlanAct.ColWidths[i] := AltoAncho.Value;
    end;
  end;
end;

//procedure TFormInterf.Autoajustar1Click(Sender: TObject);
//begin
//  PlanAct.AutoFitColumns;
//end;

//procedure TFormInterf.Autoescala1Click(Sender: TObject);
//begin
//  GrafAct.AutoRange(1, 5);
//end;

procedure TFormInterf.PlanRMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    PlanAct := PlanR;
end;

//procedure TFormInterf.PlanRRawCompare(Sender: TObject; ACol, Row1, Row2: Integer;
//  var Res: Integer);
//begin
//  if PlanAct.CellValue[Acol, Row1] < PlanAct.CellValue[Acol, Row2] then Res := -1
//  else
//    if PlanAct.CellValue[Acol, Row1] > PlanAct.CellValue[Acol, Row2] then Res := 1
//    else Res := 0;
//end;

procedure TFormInterf.PlanDMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  mouseCell: TPoint;
begin
  PlanAct := PlanD;
  if Button = mbRight then begin
    mouseCell := PlanD.MouseToCell(Point(X, Y));
    cactD := PlanD.GetWorksheetCol(mouseCell.X)+1;
    ractD := PlanD.GetWorksheetRow(mouseCell.Y)+1;
  end;
end;

procedure TFormInterf.PlanCMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  PlanAct := PlanC;
end;

procedure TFormInterf.InsertarFilas1Click(Sender: TObject);

var
    r1, r2, l, i: integer;
begin
    r1 := PlanAct.Selection.Top;
    r2 := PlanAct.Selection.Bottom;
    l := PlanAct.Selection.Left;
    for i := r1 to r2 do
      PlanAct.InsertRow(r2+i-1);
    PlanAct.Row := r1;
    PlanAct.Col := l;
end;

procedure TFormInterf.IntrinsicGroupClick(Sender: TObject);
begin
  distrtype := IntrinsicGroup.ItemIndex;
  case distrtype of
    0: begin
      Intrinseca.Visible := True;
      DistrNICA.Visible := True;
      Intrinseca.TabVisible := True;
      DistrNICA.TabVisible := True;
      Discrete.Visible := False;
      Discrete.TabVisible := False;
    end;
    1: begin
      Intrinseca.Visible := False;
      DistrNICA.Visible := False;
      Intrinseca.TabVisible := False;
      DistrNICA.TabVisible := False;
      Discrete.Visible := True;
      Discrete.TabVisible := True;
    end;
  end;
end;

procedure TFormInterf.Insertarenposicin1Click(Sender: TObject);
begin
    Insertar(3);
end;

procedure TFormInterf.BorrarFilas1Click(Sender: TObject);
var
    r1, r2, l, i: integer;
begin
    r1 := PlanAct.Selection.Top;
    r2 := PlanAct.Selection.Bottom;
    l := PlanAct.Selection.Left;
    for i:= r1 to r2 do
      PlanAct.Worksheet.RemoveRow(r1);
//    PlanAct.AutoSpreadHeaders;
    if r1 < PlanAct.RowCount then
      PlanAct.Row := r1
    else
      PlanAct.Row := PlanAct.RowCount-1;
    PlanAct.Col := l;
end;

//procedure TFormInterf.Abrir1Click(Sender: TObject);
//begin
//  MainForm.Abrir1Click(Sender);
//end;
//
//procedure TFormInterf.Abrirtodo1Click(Sender: TObject);
//var
//  co, ro, id: integer;
//begin
//  //with OpenDialogW do begin
//  //  FileName := '';
//  //  if Execute and (FileName <> '') then begin
//  //    try
//  //      with ExcelIOW do     // excel
//  //        XLSImport(FileName);
//  //      with Workbook do begin
//  //          ActiveSheet := 0;
//  //          PlanD.Assign(Workbook.Grid);
//  //          with PlanD do begin
//  //            for co := 1 to ColCount-1 do begin
//  //              if Cells[co, 1] <> '' then begin
//  //                  for ro := 1 to RowCount-2 do begin
//  //                      if Cells[co, ro] <> '' then begin
//  //                          id := 1;
//  //                          Floats[co,ro] := ScanFPNum(Cells[co,ro], True, 3, id);
//  //                      end;
//  //                  end;
//  //              end;
//  //            end;
//  //            FloatFormat := '%8g';
//  //            Tag := 0;
//  //            AutoSpreadHeaders;
//  //          end;
//  //          ActiveSheet := 1;
//  //          PlanC.Assign(Workbook.Grid);
//  //          with PlanC do begin
//  //            for co := 1 to ColCount-1 do begin
//  //              if Cells[co, 1] <> '' then begin
//  //                  for ro := 1 to RowCount-2 do begin
//  //                      if Cells[co, ro] <> '' then begin
//  //                          id := 1;
//  //                          Floats[co,ro] := ScanFPNum(Cells[co,ro], True, 3, id);
//  //                      end;
//  //                  end;
//  //              end;
//  //            end;
//  //            FloatFormat := '%8g';
//  //            Tag := 0;
//  //            AutoSpreadHeaders;
//  //          end;
//  //          ActiveSheet := 2;
//  //          PlanR.Assign(Workbook.Grid);
//  //          with PlanR do begin
//  //            for co := 1 to ColCount-1 do begin
//  //              if Cells[co, 1] <> '' then begin
//  //                  for ro := 1 to RowCount-2 do begin
//  //                      if Cells[co, ro] <> '' then begin
//  //                          id := 1;
//  //                          Floats[co,ro] := ScanFPNum(Cells[co,ro], True, 3, id);
//  //                      end;
//  //                  end;
//  //              end;
//  //            end;
//  //            FloatFormat := '%8g';
//  //            Tag := 0;
//  //            AutoSpreadHeaders;
//  //          end;
//  //      end;
//  //
//  //    except
//  //      on exc: Exception do begin
//  //        MessageDlg(exc.Message, mtError, [mbOK], 0);
//  //        exit;
//  //      end;
//  //    end;
//  //  end;
//  //end;
//  //
//end;

procedure TFormInterf.rGroupClick(Sender: TObject);
begin
  if rGroup.ItemIndex = 0 then begin
    EditR.Enabled := True;
    ColR.Enabled := false;
  end else begin
    EditR.Enabled := False;
    ColR.Enabled := True;
  end;
end;

procedure TFormInterf.Agregarabajo1Click(Sender: TObject);
begin
    Insertar(2);
end;

procedure TFormInterf.AdvancedCheckClick(Sender: TObject);
begin
  EntTol1.Visible := AdvancedCheck.Checked;
  EntTol2.Visible := AdvancedCheck.Checked;
  EntTol3.Visible := AdvancedCheck.Checked;
  EntTolIter.Visible := AdvancedCheck.Checked;
  EntDelta.Visible := AdvancedCheck.Checked;
  EntTau.Visible := AdvancedCheck.Checked;
  EntMaxIter.Visible := AdvancedCheck.Checked;
  EntWsor.Visible := AdvancedCheck.Checked;
end;

procedure TFormInterf.Agregaraladerecha1Click(Sender: TObject);
begin
    Insertar(1);
end;

procedure TFormInterf.AgregarColumna1Click(Sender: TObject);
begin
//    PlanAct.AddColumn;
//    PlanAct.AutoSpreadHeaders;
end;

procedure TFormInterf.Insertar(Modo: Integer);
var
  nr, nc, lr, lc: integer;
  sel: TsCellRangeArray;
  Grid1: TsWorksheetgrid;

begin
    Grid1 := TsWorksheetgrid.Create(nil);
    MainForm.Importar(Grid1, 'Data file to insert');
    PlanD.BeginUpdate;
    SetLength(sel, 1);
    nr := Grid1.RowCount-1;
    nc := Grid1.ColCount-1;
    sel[0] := Range(0, 0, nr-1, nc-1);
    CutCellsClipboard(Grid1.Worksheet);
    case Modo of
      1: begin        //Insertar a la  derecha
          lc := PlanD.ColCount;
          PlanD.ColCount := PlanD.ColCount + nc;
          PlanD.Col := lc;
          PasteCellsClipboard(Grid1.Worksheet, coCopyCell);
      end;
      2: begin      // Insertar abajo
          lr := PlanD.RowCount;
          PlanD.RowCount := PlanD.RowCount + nr;
          PlanD.Row := lr;
          PasteCellsClipboard(Grid1.Worksheet, coCopyCell);
      end;
      3: begin       //Insertar en el lugar
          PasteCellsClipboard(Grid1.Worksheet, coCopyCell);
      end;
    end;
    PlanD.EndUpdate;
    Grid1.Free;
end;

procedure TFormInterf.Insertarcolumnas1Click(Sender: TObject);
var
    i, r1, r2, r: integer;
begin
    r1 := PlanAct.Selection.Left;
    r2 := PlanAct.Selection.Right;
    for i := r1 to r2 do
      PlanAct.InsertCol(r2+i);
    PlanAct.Col := r1;
end;


procedure TFormInterf.Borrar1Click(Sender: TObject);
begin
  PlanAct.ClearSelections;
end;

procedure TFormInterf.TraeralaIzquierda1Click(Sender: TObject);
var
  t, l, b, r: integer;
  sel: TsCellRangeArray;

begin
  with PlanAct do begin
    sel := Worksheet.GetSelection;
    if Length(sel) = 0 then
      exit;
    t := sel[0].Row1;
    l := sel[0].Col1;
    b := sel[0].Row2;
    r := sel[0].Col2;
    ClearSelections;
    if r < ColCount-1 then begin
      sel[0].Row1:= t;
      sel[0].Row2:= b;
      sel[0].Col1:= r+1;
      sel[0].Col2:= ColCount-1;
      Worksheet.SetSelection(sel);
      CopyCellsClipboard(Worksheet);
      ClearSelections;
      Row := t;
      Col := l;
      PasteCellsClipboard(Worksheet, coCopyCell);
      Row := t;
      Col := l;
    end;
  end;
end;

procedure TFormInterf.TraerhaciaArriba1Click(Sender: TObject);
var
  t, l, b, r: integer;
  sel: TsCellRangeArray;

begin
  with PlanAct do begin
    sel := Worksheet.GetSelection;
    if Length(sel) = 0 then
      exit;
    t := sel[0].Row1;
    l := sel[0].Col1;
    b := sel[0].Row2;
    r := sel[0].Col2;
    ClearSelections;
    if b < RowCount-2 then begin
      sel[0].Row1:= b+1;
      sel[0].Row2:= RowCount-2;
      sel[0].Col1:= r+1;
      sel[0].Col2:= l;
      CopyCellsClipboard(Worksheet);
      ClearSelections;
      Row := t;
      Col := l;
      PasteCellsClipboard(Worksheet, coCopyCell);
      Row := t;
      Col := l;
    end;
  end;
end;

procedure TFormInterf.Borrarcolumnas1Click(Sender: TObject);
var
    i, r1, r2, r: integer;
    sel: TsCellRangeArray;
begin
  sel := PlanAct.Worksheet.GetSelection;
  if Length(sel) = 0 then
    exit;
  r1 := sel[0].Col1;
  r2 := sel[0].Col2;
  r := sel[0].Row1;
  for i := r1 to r2 do
    PlanAct.Worksheet.RemoveCol(r1+1);
  PlanAct.Row := r;
  PlanAct.Col := r1;
end;

procedure TFormInterf.CutItemClick(Sender: TObject);
begin
  CutCellsClipboard(PlanAct.Worksheet);
end;

procedure TFormInterf.ControlShow(Sender: TObject);
var
    i, n, it: integer;
begin
    n := PlanD.ColCount;
    it := ColS.ItemIndex;
    ColS.Items.Clear;
    for i := 1 to n do begin
        ColS.Items.Append(GetColString(PlanD.GetWorksheetCol(i)));
    end;
    if it <= ColS.Items.Count then
      ColS.ItemIndex := it
    else
      ColS.ItemIndex := 0;
    Application.ProcessMessages;
    Hojas.ActivePage := PlDatos;
end;

procedure TFormInterf.Copiar2Click(Sender: TObject);
begin
  OutPutMemo.CopyToClipboard;
end;

procedure TFormInterf.Copiargrfico1Click(Sender: TObject);
begin
  GrafAct.CopyToClipboardBitmap;
end;

procedure TFormInterf.CopyItemClick(Sender: TObject);
begin
  CopyCellsClipboard(PlanAct.Worksheet);
end;

//procedure TFormInterf.Crearcolnumeracin1Click(Sender: TObject);
//var
//  i: integer;
//begin
//  Crearcolnumeracin1.Checked := ColCheckPres;
//end;

procedure TFormInterf.Parar2Click(Sender: TObject);
begin
    if MessageDlg('Sure to abort calculation?', mtWarning, mbOkCancel, 0) = mrOk then begin
      Timer1.Enabled := False;
      TerminateProcess(prinfo.hProcess, 1);
      timecorr := SecondSpan(Now, timecorr);
      StatusBar.Panels[0].Text := '';
      MainForm.BotEnabled;
      MainForm.Archivo1.Enabled := True;
      Edit1.Enabled := True;
      //Ver1.Enabled := True;
      Procesar1.Enabled := True;
      MainForm.Ejecutable1.Enabled := True;
      Correr2.Enabled := True;
      MainForm.BotParar.Enabled := False;
      Parar2.Enabled := False;
      Screen.Cursor := crDefault;
      corriendo := False;
      corriendof := False;
      corriendos := False;
      Application.ProcessMessages;
    end;
end;

procedure TFormInterf.PasteItemClick(Sender: TObject);
begin
  PasteCellsClipboard(PlanAct.Worksheet, coCopyCell);
end;


procedure TFormInterf.FormActivate(Sender: TObject);
begin
  if corriendo or corriendof or corriendos then begin
    MainForm.BotDisabled;
    MainForm.BotParar.Enabled := True;
    Screen.Cursor := crHourGlass;
  end else begin
    MainForm.BotEnabled;
    MainForm.BotParar.Enabled := False;
    Screen.Cursor := crDefault;
  end;
end;

procedure TFormInterf.FormClose(Sender: TObject; var Action: TCloseAction);
var
  s: string;
  i: integer;
begin
    s := '';
    if (PlanD.Tag <> 0) then s := 'Data worksheet modified';
    if (PlanC.Tag <> 0) then begin
      if s = '' then s := 'Competitive distribution worksheet modified'
      else
        s := s + ';' + chr(10) + chr (13) + 'competitive distribution worksheet modified';
    end;
    if (PlanR.Tag <> 0) then begin
      if s = '' then s := 'Results worksheet modified'
      else
        s := s + ';' + chr(10) + chr (13) + 'results worksheet modified';
    end;
    if s <> '' then begin
      i:= MessageDlg(s  + chr(10) + chr (13) + 'Yes to close, No to minimize, Cancel to do nothing', mtWarning, mbYesNoCancel, 0);
      case i of
        mrYes: Action := caFree;
        mrNo: Action := caMinimize;
        mrCancel: Action := caNone;
      end;
    end else Action := caFree;
//    if Action = caFree then begin
//      Form1.Release;
//      Form2.Release;
//    end;
    if (Action = caFree) and (MainForm.MDIChildCount = 1) then
      with MainForm do begin
        BotDisabled;
        MainForm.BotOpen.Enabled := True;
      end;
end;

procedure TFormInterf.PlanRSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
    CanSelect := not (Arow = PlanR.RowCount-1);
end;

procedure TFormInterf.PlotVContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin

end;

procedure TFormInterf.PopupMenu1Popup(Sender: TObject);
begin

end;

procedure TFormInterf.PopupMenu2Popup(Sender: TObject);
var
    b: boolean;
begin
    if not (PopupMenu2.PopupComponent is TChart) then
        PopupMenu2.Close;
    b := False;
    ModoZoomDrag.Checked := ToolsAct.Item[0].Enabled;
    b := b or ModoZoomDrag.Checked;
    ModoZoomPoint.Checked := ToolsAct.Item[1].Enabled;
    b := b or ModoZoomPoint.Checked;
    ModoPan.Checked := ToolsAct.Item[2].Enabled;
    b := b or ModoPan.Checked;
    if not b then ModoNormal1.Checked := True;
end;

procedure TFormInterf.Punto1Click(Sender: TObject);
begin
  FormatSettings.DecimalSeparator := '.';
end;

procedure TFormInterf.raeralaIzquierda1Click(Sender: TObject);
begin

end;

//procedure TFormInterf.Salvartodo1Click(Sender: TObject);
//begin
  //with SaveDialogW do begin
  //  if Execute and (FileName <> '') then begin
  //      try
  //        If ExtractFileExt(FileName) = '' then FileName := FileName + '.xls';
  //         with Workbook do begin
  //            ActiveSheet := 0;
  //            Workbook.Grid.Assign(PlanD);
  //            ActiveSheet := 1;
  //            Workbook.Grid.Assign(PlanC);
  //            ActiveSheet := 2;
  //            Workbook.Grid.Assign(PlanR);
  //         end;
  //         ExcelIOW.XLSExport(FileName);
  //         PlanD.Tag := 0;
  //         PlanC.Tag := 0;
  //         PlanR.Tag := 0;
  //      except
  //          on exc: Exception do begin
  //              MessageDlg(exc.Message, mtError, [mbOK], 0);
  //              exit;
  //          end;
  //      end;
  //  end;
  //end;
//end;

//procedure TFormInterf.SaveComps1LoadComponentEvent(Sender: TObject;
//  ComponentName: string; Count, Index: Integer; var Continue: Boolean);
//begin
//  MainForm.SaveComps1LoadComponentEvent(Sender, ComponentName, Count, Index, Continue);
//end;
//
//procedure TFormInterf.SaveComps1StoreComponentEvent(Sender: TObject;
//  ComponentName: string; Count, Index: Integer; var Continue: Boolean);
//begin
//  MainForm.SaveComps1StoreComponentEvent(Sender, ComponentName, Count, Index, Continue);
//end;

procedure TFormInterf.FuenteCeldas(t, b, l, r, ro, co: integer);
var
  i, j: integer;
begin
  with PlanAct do begin
    FontDialog.Font := Font;
    if FontDialog.Execute then begin
      for i := l to r do
        for j := t to b do begin
          CellFontColor[i, j] := FontDialog.Font.Color;
  //        CellFontStyle[i, j] := FontDialog.Font.Style;
          CellFontSize[i, j] := FontDialog.Font.Size;
          CellFontName[i, j] := FontDialog.Font.Name;
        end;
    end;
    Row := ro;
    Col := co;
  end;
end;

procedure TFormInterf.ColorCeldas(t, b, l, r, ro, co: integer);
var
  i, j: integer;
begin
  with PlanAct do begin
    ColorDialog.Color := Color;
    if ColorDialog.Execute then begin
      for i := l to r do
        for j := t to b do begin
          BackgroundColor[i, j] := ColorDialog.Color;
        end;
    end;
    Row := ro;
    Col := co;
  end;
end;

procedure TFormInterf.Se1Click(Sender: TObject);
begin
  OutPutMemo.SelectAll;
end;

procedure TFormInterf.Seleccin1Click(Sender: TObject);
var
  t, b, l, r: integer;
begin
  with PlanAct do begin
    t := Selection.Top;
    b := Selection.Bottom;
    l := Selection.Left;
    r := Selection.Right;
    FuenteCeldas(t, b, l, r, Row, Col);
  end;
end;

procedure TFormInterf.Seleccin2Click(Sender: TObject);
var
  t, b, l, r: integer;
begin
  with PlanAct do begin
    t := Selection.Top;
    b := Selection.Bottom;
    l := Selection.Left;
    r := Selection.Right;
    ColorCeldas(t, b, l, r, Row, Col);
  end;
end;

//procedure TFormInterf.Seleccionarejecutable1Click(Sender: TObject);
//var
//  s: string;
//begin
//  with FileListForm do begin
//    FileList.Directory := dirprogr;
//    if ShowModal = mrOK then begin
//      s := FileList.FileName;
//      continexec := ExtractFileName(s);
//    end;
//  end;
//end;

procedure TFormInterf.SimuBindClick(Sender: TObject);
begin
  ColS.Enabled := SimuBind.Checked;
end;

procedure TFormInterf.SimuBindChange(Sender: TObject);
begin

end;

procedure TFormInterf.PlanDSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
    CanSelect := not (Arow = PlanD.RowCount-1);
end;

procedure TFormInterf.PlanGenGetColHeaderText(Sender: TObject; AIndex: Integer;
  var AText: String);
begin
  case AIndex-1 of
    0: AText := 'Ion';
    1: AText := 'Charge';
    2: AText := 'Activity';
    3: AText := 'Var/Fix';
    4: AText := 'Col/Value';
    5: AText := 'Bound data';
    6: AText := 'Sign';
    7: AText := 'Is Log?';
  end;
end;

function TFormInterf.GetDatCols: string;
var
  i: integer;
begin
  Result := GetColString(1);
  for i := 2 to PlanD.ColCount-1 do
    Result := Result + ',' + GetColString(i);
end;

procedure TFormInterf.PlanGenSelectEditor(Sender: TObject; aCol, aRow: Integer;
  var Editor: TWinControl);
begin
  case colsplangen[aCol] of
    cactcombo: begin
      Editor := PlanGen.EditorByStyle(cbsPickList);
      with Editor as TCustomComboBox do begin
        Style := csDropDownList;
        Items.CommaText:= itactcombo;
        ItemIndex := Items.IndexOf(PlanGen.Cells[aCol, aRow]);
      end;
    end;
    cvarfix: begin
      Editor := PlanGen.EditorByStyle(cbsPickList);
      with Editor as TCustomComboBox do begin
        Style := csDropDownList;
        Items.CommaText:= itvarfix;
        ItemIndex := Items.IndexOf(PlanGen.Cells[aCol, aRow]);
      end;
    end;
    cvarfix2: begin
      if PlanGen.Cells[aCol-1, aRow] = 'Column' then begin
        Editor := PlanGen.EditorByStyle(cbsPickList);
        with Editor as TCustomComboBox do begin
          Style := csDropDownList;
          Items.CommaText:= GetDatCols;
          ItemIndex := Items.IndexOf(PlanGen.Cells[aCol, aRow]);
        end;
      end;
    end;
    ccolcombo: begin
      Editor := PlanGen.EditorByStyle(cbsPickList);
      with Editor as TCustomComboBox do begin
        Style := csDropDownList;
        Items.CommaText:= GetDatCols;
        ItemIndex := Items.IndexOf(PlanGen.Cells[aCol, aRow]);
      end;
    end;
    csigncombo: begin
      Editor := PlanGen.EditorByStyle(cbsPickList);
      with Editor as TCustomComboBox do begin
        Style := csDropDownList;
        Items.CommaText:= itsigncombo;
        ItemIndex := Items.IndexOf(PlanGen.Cells[aCol, aRow]);
      end;
    end;
    clogcombo: begin
      Editor := PlanGen.EditorByStyle(cbsPickList);
      with Editor as TCustomComboBox do begin
        Style := csDropDownList;
        Items.CommaText:= itlogcombo;
        ItemIndex := Items.IndexOf(PlanGen.Cells[aCol, aRow]);
      end;
    end;
  end;
end;

procedure TFormInterf.HojasMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  case Hojas.ActivePageIndex of
    0: PlanAct := PlanD;
    1: PlanAct := PlanC;
    2: PlanAct := PlanR;
  end;
end;

procedure TFormInterf.PlanCSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
//    CanSelect := not (Arow = PlanC.RowCount-1);
end;

procedure TFormInterf.PlanCurvesGetColHeaderText(Sender: TObject;
  AIndex: Integer; var AText: String);
begin
  case AIndex of
    0: AText := 'Num.';
    1: AText := 'N. points';
    2: AText := 'Fixed I/M';
    3: AText := 'Q<SUB><FONT size = 8>0</FONT></SUB>/mol kg<SUP>-1</SUP>';
    4: AText := 'Fit Q<SUB><FONT size = 8>0</FONT></SUB>';
    5: AText := 'Binding ion';
    6: AText := 'Sgl. ion';
    7: AText := 'Curve label         ';
  end;
end;

procedure TFormInterf.PlanCurvesSelectEditor(Sender: TObject; aCol,
  aRow: Integer; var Editor: TWinControl);
var
  i: integer;
begin
  case colsplancurv[aCol] of
    cyesnocombo: begin
      Editor := PlanCurves.EditorByStyle(cbsPickList);
      with Editor as TCustomComboBox do begin
        Style := csDropDownList;
        Items.CommaText:= ityesnocombo;
        ItemIndex := Items.IndexOf(PlanGen.Cells[aCol, aRow]);
      end;
    end;
    ccombo: begin
      Editor := PlanCurves.EditorByStyle(cbsPickList);
      with Editor as TCustomComboBox do begin
        Style := csDropDownList;
        Items.Clear;
        for i := 1 to numion do begin
          Items.Append(PlanGen.Cells[1, i]);
        end;
        ItemIndex := Items.IndexOf(PlanGen.Cells[aCol, aRow]);
      end;
    end;
  end;

end;

procedure TFormInterf.PlanDClick(Sender: TObject);
begin

end;

procedure TFormInterf.KernelGroupClick(Sender: TObject);
begin
  case KernelGroup.ItemIndex of
    0: begin
        CompetGroup.Enabled := False;
        NICABox.Enabled := False;
        //EditFactor.Enabled := False;
        //LabelFactor.Enabled := False;
        rGroup.Enabled := False;
        ColDistrBox.Enabled := False;
        ColGridDistr.Enabled := False;
        EntNICADesde.Enabled := False;
//        LabelDesde.Enabled := False;
        EntNICAHasta.Enabled := False;
//        LabelHasta.Enabled := False;
        EntNICAPuntos.Enabled := False;
        EntNICAPuntos.Enabled := False;
        pXoAct.Enabled := False;
        EntActivComp.Enabled := False;
        ColR.Enabled := False;
        GridGroup.Enabled := False;
//        LabelColDistr.Enabled := False;
        //Labelr.Enabled := False;
        EditR.Enabled := False;
    end;
    1: begin
        CompetGroup.Enabled := True;
        rGroup.Enabled := False;
        ColR.Enabled := False;
        EditR.Enabled := False;
        pXoAct.Enabled := True;
        EntActivComp.Enabled := True;
        //rGroupClick(Sender);
        CompetGroupClick(Sender);
        //Labelr.Enabled := False;
        EditR.Enabled := False;
    end;
    2, 3: begin
        CompetGroup.Enabled := True;
        rGroup.Enabled := True;
        pXoAct.Enabled := True;
        EntActivComp.Enabled := True;
        rGroupClick(Sender);
        CompetGroupClick(Sender);
        //Labelr.Enabled := True;
        EditR.Enabled := True;
    end;
  end;
end;

procedure TFormInterf.ParametrosChange(Sender: TObject);
begin

end;

procedure TFormInterf.KernelShow(Sender: TObject);
var
    i, n, it, iy: integer;
begin
    n := PlanC.ColCount;
    it := ColGridDistr.ItemIndex;
    iy := ColDistrBox.ItemIndex;
    ColGridDistr.Items.Clear;
    ColDistrBox.Items.Clear;
    for i := 1 to n do begin
        ColGridDistr.Items.Append(Chr(Ord('@')+i));
        ColDistrBox.Items.Append(Chr(Ord('@')+i));
    end;
    if it <= ColGridDistr.Items.Count then
      ColGridDistr.ItemIndex := it
    else
      ColGridDistr.ItemIndex := 0;
    if iy <= ColDistrBox.Items.Count then
      ColDistrBox.ItemIndex := iy
    else
      ColDistrBox.ItemIndex := 0;
    Application.ProcessMessages;

end;

procedure TFormInterf.Limpiar1Click(Sender: TObject);
begin
  GrafAct.ClearSeries;
end;

procedure TFormInterf.Llenar1Click(Sender: TObject);
begin
  FormLlenar.ShowModal;
end;

procedure TFormInterf.MarcasColores1Click(Sender: TObject);
begin
  Formgrdetails.getcurvesdetails('Change curves details', RecAct.Params)
end;

procedure TFormInterf.Localizarpunto1Click(Sender: TObject);
begin
  Localizarpunto1.Checked := not Localizarpunto1.Checked;
  if Localizarpunto1.Checked then begin
     ToolsAct.Item[4].Enabled := True;
     ToolsAct.Item[6].Enabled := True;
     ToolsAct.Item[7].Enabled := False;
  end else begin
    StatusBar.Panels[2].Text := '';
    ToolsAct.Item[4].Enabled := False;
    ToolsAct.Item[6].Enabled := False;
    ToolsAct.Item[7].Enabled := True;
  end;
end;

procedure TFormInterf.Marcar1Click(Sender: TObject);
begin
  if ColCheckPres then PlanD.BackgroundColors[1, ractD, PlanD.ColCount-1, ractD] := $F0C0C0;
end;

procedure TFormInterf.OutputBuscarClick(Sender: TObject);
begin
  FindDialog.Execute;
end;

procedure TFormInterf.Marcartodas1Click(Sender: TObject);
var
  i: integer;
begin
  //PlanD.CheckAll(0);
  //for i := 1 to PlanD.RowCount - 1 do
  //  PlanD.RowColor[i] := clWhite;
end;

procedure TFormInterf.ModoNormal1Click(Sender: TObject);
begin
    ToolsAct.Item[2].Enabled:= False;
    ToolsAct.Item[0].Enabled:= False;
    ToolsAct.Item[1].Enabled:= False;
    ModoNormal1.Checked := True;
    Application.ProcessMessages;
end;

procedure TFormInterf.ModoZoomDragClick(Sender: TObject);
begin
    ToolsAct.Item[0].Enabled:= True;
    ToolsAct.Item[2].Enabled:= False;
    ToolsAct.Item[1].Enabled:= False;
    ModoZoomDrag.Checked := True;
    Application.ProcessMessages;
end;

procedure TFormInterf.ModoZoomPointClick(Sender: TObject);
begin
    ToolsAct.Item[1].Enabled:= True;
    ToolsAct.Item[0].Enabled:= False;
    ToolsAct.Item[2].Enabled:= False;
    ModoZoomPoint.Checked := True;
    Application.ProcessMessages;
end;

//procedure TFormInterf.Mostrarfilas1Click(Sender: TObject);
//var
//    r1, r2, i: integer;
//begin
//  with PlanAct do begin
//
//    r1 := Selection.Top;
//    r2 := Selection.Bottom;
//    if (r1 = r2) and (r1 = 1) then
//      r1 := 0;
//    r1 := RealRowIndex(r1);
//    r2 := RealRowIndex(r2);
//    for i := r1 to r2 do
//      if IsHiddenRow(i) then
//        UnHideRow(i);
//  end;
//end;

//procedure TFormInterf.Mostrartodo1Click(Sender: TObject);
//begin
//  PlanAct.UnHideRowsAll;
//end;

procedure TFormInterf.ModoPanClick(Sender: TObject);
begin
    ToolsAct.Item[2].Enabled:= True;
    ToolsAct.Item[0].Enabled:= False;
    ToolsAct.Item[1].Enabled:= False;
    ModoPan.Checked := True;
    Application.ProcessMessages;
end;

procedure TFormInterf.Zoomprevio2Click(Sender: TObject);
begin
  GrafAct.ZoomFull;
end;

procedure TFormInterf.Normalizardistr1Click(Sender: TObject);
var
  Child: TFormInterf;
begin
  Child := TFormInterf(MainForm.ActiveMDIChild);
  with FormNormaliz do begin
      Planilla := Child.PlanC;
      FormNormaliz.Show;
  end;
end;

procedure TFormInterf.NumberOfIonsBoxChange(Sender: TObject);
var
  i, j, n: integer;
begin
  n := NumberofIonsBox.ValueAsInt;
  if n = 1 then begin
    Intrinseca.Enabled := True;
    Intrinseca.TabVisible := True;
    DistrNICA.Enabled := False;
    DistrNICA.TabVisible := False;
  end else begin
    DistrNICA.Enabled := True;
    DistrNICA.TabVisible := True;
    Intrinseca.Enabled := False;
    Intrinseca.TabVisible := False;
    //for i := 1 to n do
    //  for j := 1 to 4 do begin
    //    EntDatNic[i, j].Visible := True;
    //    EnLimInfNic[i, j].Visible := True;
    //    EnLimSupNic[i, j].Visible := True;
    //    //finnic[i, j].Visible := True;
    //    //LabNic[i, j].Visible := True;
    //  end;
    //if n < maxion then
    //for i := n+1 to maxion do
    //  for j := 1 to 4 do begin
    //    EntDatNic[i, j].Visible := False;
    //    EnLimInfNic[i, j].Visible := False;
    //    EnLimSupNic[i, j].Visible := False;
    //    //finnic[i, j].Visible := False;
    //    //LabNic[i, j].Visible := False;
    //  end;
  end;

  numion := n;
  //Parametros.Update;
  //FitGen.Visible := True;
  //Parametros.ac
//  numberionschanged := True;
  PlanGen.Repaint;
end;

//procedure TFormInterf.Nuevo1Click(Sender: TObject);
//begin
//  MainForm.FileNew1Execute(Sender);
//end;

procedure TFormInterf.Ordenar1Click(Sender: TObject);
var
  i: integer;
  sp: TsSortParams;
begin
      FormOrd.OrdCol.Items.Clear;
      for i := 1 to PlanAct.ColCount - 1 do
        FormOrd.OrdCol.Items.Add(GetColString(PlanAct.GetWorksheetCol(i)));

      if FormOrd.ShowModal = mrOK then begin
        sp.SortByCols:= True;
        if FormOrd.CheckNumbers.Checked then
          sp.Priority := spNumAlpha
        else
          sp.Priority := spAlphaNum;
        SetLength(sp.Keys, 1);
        sp.Keys[0].ColRowIndex := FormOrd.OrdCol.ItemIndex + 1;
        if not FormOrd.CheckCase.Checked then
          sp.Keys[0].Options := sp.Keys[0].Options + [ssoCaseInsensitive];
        if FormOrd.DirGroup.ItemIndex = 1 then
          sp.Keys[0].Options := sp.Keys[0].Options + [ssoDescending];
        PlanAct.Worksheet.Sort(sp, 1, 1, PlanAct.RowCount-1,PlanAct.ColCount-1);
      end;
end;

//procedure TFormInterf.Ocultarfilas1Click(Sender: TObject);
//var
//    r1, r2: integer;
//begin
//  with PlanAct do begin
//    r1 := RealRowIndex(Selection.Top);
//    r2 := RealRowIndex(Selection.Bottom);
//    HideRows(r1, r2);
//    AutoSpreadHeaders;
//  end;
//end;

procedure TFormInterf.Todo2Click(Sender: TObject);
var
  i, j, r, c: integer;
begin
  with PlanAct do begin
    ColorDialog.Color := Color;
    r := Row;
    c := Col;
    if ColorDialog.Execute then begin
      for i := 1 to ColCount - 1 do
        for j := 1 to RowCount - 1 do begin
         BackgroundColor[i, j] := ColorDialog.Color;
        end;
      Color := ColorDialog.Color;
    end;
    Row := r;
    Col := c;
  end;
end;

procedure TFormInterf.Todo1Click(Sender: TObject);

begin
  with PlanAct do begin
    FontDialog.Font := Font;
    if FontDialog.Execute then begin
      FuenteCeldas(1, RowCount - 1, 1, RowCount - 1, Row, Col);
      Font := FontDialog.Font;
    end;
  end;
end;


procedure TFormInterf.CheckALPSTClick(Sender: TObject);
begin
  EntALPST1.Enabled := CheckALPST.Checked;
  EntALPST2.Enabled := CheckALPST.Checked;
end;

procedure TFormInterf.CheckDFMINClick(Sender: TObject);
begin
  EntDFMIN.Enabled := CheckDFMIN.Checked;
end;

procedure TFormInterf.Check1_1Click(Sender: TObject);
begin
  if Check1_1.Checked then begin
      FIonica.Enabled := True;
      if FIonica.ItemIndex = 1 then begin
        EntFionica.Enabled := False;
        ColE.Enabled := True;
      end else begin
        EntFionica.Enabled := True;
        ColE.Enabled := False;
      end;
      Panel1.Enabled := False;
  end else begin
    Panel1.Enabled := True;
    FIonica.Enabled := False;
    EntFionica.Enabled := False;
    ColE.Enabled := False;
  end;
end;

procedure TFormInterf.CheckALPSTChange(Sender: TObject);
begin

end;

procedure TFormInterf.CheckElectroClick(Sender: TObject);
begin
  if CheckElectro.Checked then begin
      EntChi.Enabled := True;
      Entf.Enabled := True;
      EntQmax.Enabled := True;
      EntQ0.Enabled := True;
      Entdens.Enabled := True;
      EntChi.Enabled := True;
      EntV2.Enabled := True;
      Entgf.Enabled := True;
      ChargeMainIon.Enabled := True;
      ChargeCompeIon.Enabled := True;
      FIonica.Enabled := True;
      ElecBindBox.Enabled := True;
      Entwpsi.Enabled := True;
      //Check1_1.Enabled := True;
      //Check1_1Click(Sender);
  end else begin
      EntChi.Enabled := False;
      Entf.Enabled := False;
      EntQmax.Enabled := False;
      EntQ0.Enabled := False;
      Entdens.Enabled := False;
      EntChi.Enabled := False;
      EntV2.Enabled := False;
      Entgf.Enabled := False;
      ChargeMainIon.Enabled := False;
      ChargeCompeIon.Enabled := False;
      FIonica.Enabled := False;
      EntFionica.Enabled := False;
      ColE.Enabled := False;
      Check1_1.Enabled := False;
      ElecBindBox.Enabled := False;
      Entwpsi.Enabled := False;
  end;
end;


procedure TFormInterf.CheckNNSGNClick(Sender: TObject);
var
  i, j: integer;
begin
  EntNNSGN1.Enabled := CheckNNSGN.Checked;
  EntNNSGN2.Enabled := CheckNNSGN.Checked;
  for i := 1 to 4 do
    entnsgn[i].Enabled := CheckNNSGN.Checked;
  for i := 1 to 4 do
    for j := 1 to 4 do
      entlsgn[i,j].Enabled := CheckNNSGN.Checked;
  for i := 1 to 4 do
    for j := 1 to 2 do
      entnflat[i,j].Enabled := CheckNNSGN.Checked;
  EntSRMIN.Enabled := CheckNNSGN.Checked;
  EntMQPITR.Enabled := CheckNNSGN.Checked;
end;

procedure TFormInterf.CheckNQPROGClick(Sender: TObject);
begin
  EntNQPROG1.Enabled := CheckNQPROG.Checked;
  EntNQPROG2.Enabled := CheckNQPROG.Checked;
end;

procedure TFormInterf.CheckRSVMNXClick(Sender: TObject);
begin
  EntRSVMNX11.Enabled := CheckRSVMNX.Checked;
  EntRSVMNX12.Enabled := CheckRSVMNX.Checked;
  EntRSVMNX21.Enabled := CheckRSVMNX.Checked;
  EntRSVMNX22.Enabled := CheckRSVMNX.Checked;
end;

procedure TFormInterf.Columnas2Click(Sender: TObject);
var
  t, b, l, r: integer;
begin
  with PlanAct do begin
    t := 1;
    b := RowCount-1;
    l := Selection.Left;
    r := Selection.Right;
    FuenteCeldas(t, b, l, r, Row, Col);
  end;
end;

procedure TFormInterf.Coma1Click(Sender: TObject);
begin
  FormatSettings.DecimalSeparator := ',';
end;

procedure TFormInterf.CompetGroupClick(Sender: TObject);
begin
    case CompetGroup.ItemIndex of
        0: begin
            //LabelFactor.Enabled := False;
            //EditFactor.Enabled := False;
            NicaBox.Enabled := True;
            EntK1.Enabled := True;
            EntQ1.Enabled := True;
            Entm1.Enabled := True;
            Entm1.Enabled := False;
            Entm2.Enabled := False;
            EntQ2.Enabled := False;
            GridGroup.Enabled := False;
            EntNICAdesde.Enabled := False;
 //           LabelDesde.Enabled := False;
            EntNICAhasta.Enabled := False;
 //           LabelHasta.Enabled := False;
            EntNICApuntos.Enabled := False;
            EntNICAPuntos.Enabled := False;
//            LabelColDistr.Enabled := False;
            ColDistrBox.Enabled := False;
        end;
  {
          1: begin
               LabelFactor.Enabled := True;
               EditFactor.Enabled := True;
               NicaBox.Enabled := False;
               EntK1.Enabled := False;
               Entm1.Enabled := False;
               EntQ1.Enabled := False;
               Entm1.Enabled := False;
               Entm2.Enabled := False;
               EntQ2.Enabled := False;
               GridGroup.Enabled := False;
               EntNICAdesde.Enabled := False;
               LabelDesde.Enabled := False;
               EntNICAhasta.Enabled := False;
               LabelHasta.Enabled := False;
               EntNICApuntos.Enabled := False;
               EntNICAPuntos.Enabled := False;
               LabelColDistr.Enabled := False;
               ColDistrBox.Enabled := False;
           end;
 }

          1: begin
               //LabelFactor.Enabled := False;
               //EditFactor.Enabled := False;
               NicaBox.Enabled := True;
               EntK1.Enabled := True;
               Entm1.Enabled := True;
               EntQ1.Enabled := True;
               Entm1.Enabled := True;
               Entm2.Enabled := True;
               EntQ2.Enabled := True;
               GridGroup.Enabled := False;
               EntNICAdesde.Enabled := True;
//               LabelDesde.Enabled := True;
               EntNICAhasta.Enabled := True;
//               LabelHasta.Enabled := True;
               EntNICApuntos.Enabled := True;
               EntNICAPuntos.Enabled := True;
//               LabelColDistr.Enabled := False;
               ColDistrBox.Enabled := False;
           end;

         2: begin
            //LabelFactor.Enabled := False;
            //EditFactor.Enabled := False;
            NicaBox.Enabled := False;
            EntK1.Enabled := False;
            Entm1.Enabled := False;
            EntQ1.Enabled := False;
            Entm1.Enabled := False;
            Entm2.Enabled := False;
            EntQ2.Enabled := False;
//            LabelColDistr.Enabled := True;
            ColDistrBox.Enabled := True;
            GridGroup.Enabled := True;
            GridGroupClick(Sender);
        end;
    end;
end;

procedure TFormInterf.Cortar1Click(Sender: TObject);
begin

end;

procedure TFormInterf.CurvasAdicBoxChange(Sender: TObject);
begin
  if CurvasAdicBox.Checked then begin
    EntUniformPoints.Visible := True;
    with PlanGen do begin
      RowCount := 10;
      MergeCells(8, 0, 2, 1);
      Cells[8, 0] := 'Curve range';
      Cells[8, 1] := 'From';
      Cells[9, 1] := 'To';
    end;
  end else begin
    EntUniformPoints.Visible := False;
    PlanGen.RowCount := 8;
  end;

end;

//procedure TFormInterf.CONTIN1Click(Sender: TObject);
//var
//  i: integer;
//begin
//  //FIT1.Checked := False;
//  //Todo3.Checked := False;
//  for i := 0 to Output.PageIndex do begin
//    Parametros.Pages[i].Visible := True;
//    Parametros.Pages[i].TabVisible := True;
//  end;
//  for i := Output.PageIndex + 1 to Parametros.PageCount - 1 do begin
//    Parametros.Pages[i].Visible := False;
//    Parametros.Pages[i].TabVisible := False;
//  end;
//end;

//procedure TFormInterf.FormConstrainedResize(Sender: TObject; var MinWidth,
//  MinHeight, MaxWidth, MaxHeight: Integer);
//begin
////    MinWidth := minancho;
////    MinHeight := minalto;
//end;


//procedure TFormInterf.Datos1Click(Sender: TObject);
//begin
//  PreviewDialog.Grid := PlanD;
//  PreviewDialog.Execute;
//end;
//
//procedure TFormInterf.PrintSet(Sender: TObject);
//begin
//  PrintSetDlg.Grid := PlanAct;
//  PrintSetDlg.Execute;
//end;
//
//procedure TFormInterf.Datos3Click(Sender: TObject);
//begin
//  if PrintDialog.Execute then
//    case PrintDialog.PrintRange of
//      prAllPages: PlanD.Print;
//      prSelection: PlanD.PrintSelection;
//      prPageNums: begin end;
//    end;
//end;
//
//procedure TFormInterf.Distrcompet2Click(Sender: TObject);
//begin
//  if PrintDialog.Execute then
//    case PrintDialog.PrintRange of
//      prAllPages: PlanC.Print;
//      prSelection: PlanC.PrintSelection;
//      prPageNums: begin end;
//    end;
//end;
//
//procedure TFormInterf.Distribcompetitiva1Click(Sender: TObject);
//begin
//  PreviewDialog.Grid := PlanC;
//  PreviewDialog.Execute;
//end;
//
//procedure TFormInterf.Resultados1Click(Sender: TObject);
//begin
//  PreviewDialog.Grid := PlanR;
//  PreviewDialog.Execute;
//end;
//
//
//procedure TFormInterf.Resultados3Click(Sender: TObject);
//begin
//  if PrintDialog.Execute then
//    case PrintDialog.PrintRange of
//      prAllPages: PlanR.Print;
//      prSelection: PlanR.PrintSelection;
//      prPageNums: begin end;
//    end;
//end;

procedure TFormInterf.DatosShow(Sender: TObject);
var
    i, n, it, iy, iq: integer;
begin
    n := PlanD.ColCount;
    it := ColT.ItemIndex;
    iy := ColY.ItemIndex;
    iq := ColQ.ItemIndex;
    ColT.Items.Clear;
    ColY.Items.Clear;
    ColQ.Items.Clear;
    for i := 1 to n do begin
        ColT.Items.Append(GetColString(PlanD.GetWorksheetCol(i)));
        ColY.Items.Append(GetColString(PlanD.GetWorksheetCol(i)));
        ColQ.Items.Append(GetColString(PlanD.GetWorksheetCol(i)));
    end;
    if it <= ColT.Items.Count then
      ColT.ItemIndex := it
    else
      ColT.ItemIndex := 0;
    if iy <= ColY.Items.Count then
      ColY.ItemIndex := iy
    else
      ColY.ItemIndex := 0;
    if iq <= ColQ.Items.Count then
      ColQ.ItemIndex := iq
    else
      ColQ.ItemIndex := 0;
    Application.ProcessMessages;
    //Planillas.ActivePageIndex := 0;
end;

procedure TFormInterf.GridGroupClick(Sender: TObject);
begin
    if GridGroup.ItemIndex = 0 then begin
        ColGridDistr.Enabled := True;
        EntNICAdesde.Enabled := False;
 //       LabelDesde.Enabled := False;
        EntNICAhasta.Enabled := False;
 //       LabelHasta.Enabled := False;
        EntNICApuntos.Enabled := False;
        EntNICAPuntos.Enabled := False;
    end else begin
        ColGridDistr.Enabled := False;
        EntNICAdesde.Enabled := True;
 //       LabelDesde.Enabled := True;
        EntNICAhasta.Enabled := True;
 //       LabelHasta.Enabled := True;
        EntNICApuntos.Enabled := True;
        EntNICAPuntos.Enabled := True;
    end;
end;

procedure TFormInterf.HojasChange(Sender: TObject);
begin

end;



end.
